{$A+,B-,D-,E-,F-,G+,I-,L-,N-,P-,Q-,R-,S-,T-,V+,X+,Y-}
{$S 65520}
{$ifdef win32}{$H-,O+}{$define windows}{$endif}
unit b_crypt;
{
Created by Bilbo (bilbo@centrum.cz) based on code
 written by David Barton (davebarton@bigfoot.com)

Algorithm	SHA1	Haval	RMD160
--------------------------------------
Speed (BP7)	 852	 647	 710
Speed (Delphi2)	2841	2324	2378
Bits		 160	 256	 160
 all 3 algorithms unpatended -> free
}

interface

{$ifndef windows}
uses crtc,dos;
{$else}
uses crtc,windows;
{$endif}

type
 a0=array[0..4095] of byte;
 p0=^a0;
 PWord=^Word;
 PDWord=^DWord;
 {$ifndef win32}
 u_val=word;
 smallint=integer;
 DWord=longint;
 {$else}
 u_val=longint;
 DWord=integer;
 {$endif}
 PDWordArray=^TDWordArray;
 TDWordArray=array[0..1023] of DWord;
 PByteArray=^TByteArray;
 TByteArray=array[0..4095] of byte;
 ivector=array[0..15] of byte;
 Hash160=array[0..4] of longint;
 Hash256=array[0..7] of longint;
 Hash160b=array[0..19] of byte;
 Hash256b=array[0..31] of byte;
 dw=packed record
       case integer of
        0:(b1,b2,b3,b4:byte);
        1:(w1,w2:word);
        2:(dw_long:longint);
       end;
var
 cbpressed:boolean;
{$ifndef windows}

function gettickcount:longint;
{$endif}
procedure initcb;
function strl(i:longint):string;
{$ifndef windows}
procedure debugtrap;
procedure resetcomp;
procedure hw_reboot;
procedure warmboot;
inline($B8/$40/0/$8E/$D8/$B8/$34/$12/$A3/$72/0/$EA/0/0/$FF/$FF);
procedure coldboot;
inline($B8/$40/0/$8E/$D8/$B8/$7F/$7F/$A3/$72/0/$EA/0/0/$FF/$FF);
function debuggeractive: boolean;
{$endif}
function loCase(Chr: Char): Char;
procedure error(const s:string);
function hexp(w:longint):string;
function hexl(w:longint):string;
function hexw(w:word):string;
function hexb(w:byte):string;
function crcb(const b;s:word):byte;
function crcw(const b;s:word):word;
function crc(const s:string):byte;
function _crcw(const s:string):word;
function tohexkey(const s:string):string;
function fromhexkey(s:string):string;
procedure readpwdenc(var s:string);
procedure burnstring(var s:string);
procedure add80buf(b:pointer;s:word);
procedure add88buf(b:pointer;s:word);
function bswap(X:longint):longint;
{$ifdef win32}
function LRot16(X: Word; c: longint): Word;
function RRot16(X: Word; c: longint): Word;
function LRot32(X: DWord; c: longint): DWord;
function RRot32(X: DWord; c: longint): DWord;
{$else}
function LRot16(X: Word; c: word): Word;
function RRot16(X: Word; c: word): Word;
function LRot32(X: DWord; c: word): DWord;
function RRot32(X: DWord; c: word): DWord;
{$endif}
procedure XorBlock(I1, I2, O1: PByteArray; Len: integer);
procedure convert256to128(var currenthash);
procedure writeblocktofile(const s:string;var da;dl:word);
procedure keybufclear;

type
  TSHA1Data=packed record
    LenHi, LenLo: DWord;
    Index: DWord;
    CurrentHash: array[0..4] of DWord;
    HashBuffer: array[0..63] of byte;
  end;
  THavalData=record
    LenHi, LenLo: DWord;
    Index: DWord;
    CurrentHash: array[0..7] of DWord;
    HashBuffer: array[0..127] of byte;
  end;
  TRmd160Data=record
    LenHi, LenLo: DWord;
    Index: DWord;
    CurrentHash: array[0..4] of DWord;
    HashBuffer: array[0..63] of byte;
  end;

procedure SHA1Init(var Data: TSHA1Data);
procedure SHA1Update(var Data: TSHA1Data; const Buffer; Size: longint);
procedure SHA1Final(var Data: TSHA1Data; var Digest);
procedure SHA1Burn(var Data: TSHA1Data);

procedure HavalInit(var Data: THavalData);
procedure HavalUpdate(var Data: THavalData; const Buffer; Size: longint);
procedure HavalFinal(var Data: THavalData; var Digest);
procedure HavalBurn(var Data: THavalData);

procedure Rmd160Init(var Data: TRmd160Data);
procedure Rmd160Update(var Data: TRmd160Data; const Buffer; Size: longint);
procedure Rmd160Final(var Data: TRmd160Data; var Digest);
procedure Rmd160Burn(var Data: TRmd160Data);

implementation

procedure SHA1Compress(var Data: TSHA1Data);
var
  A, B, C, D, E, T: DWord;
  W: array[0..79] of DWord;
  i: integer;
begin
  with Data do begin
  Index:=0;
  Move(HashBuffer,W,Sizeof(HashBuffer));
  for i:=0 to 15 do
  begin
   w[i]:=bswap(w[i]);
  end;
  for i:=16 to 79 do
    W[i]:=LRot32(W[i-3] xor W[i-8] xor W[i-14] xor W[i-16],1);
  A:=CurrentHash[0]; B:=CurrentHash[1]; C:=CurrentHash[2]; D:=CurrentHash[3]; E:=CurrentHash[4];
  for i:=0 to 19 do
  begin
    T:=LRot32(A,5) + (D xor (B and (C xor D))) + E + W[i] + $5A827999;
    E:=D; D:=C; C:=LRot32(B,30); B:=A; A:=T;
  end;
  for i:=20 to 39 do
  begin
    T:=LRot32(A,5) + (B xor C xor D) + E + W[i] + $6ED9EBA1;
    E:=D; D:=C; C:=LRot32(B,30); B:=A; A:=T;
  end;
  for i:=40 to 59 do
  begin
    T:=LRot32(A,5) + ((B and C) or (D and (B or C))) + E + W[i] + $8F1BBCDC;
    E:=D; D:=C; C:=LRot32(B,30); B:=A; A:=T;
  end;
  for i:=60 to 79 do
  begin
    T:=LRot32(A,5) + (B xor C xor D) + E + W[i] + $CA62C1D6;
    E:=D; D:=C; C:=LRot32(B,30); B:=A; A:=T;
  end;
  CurrentHash[0]:=CurrentHash[0] + A;
  CurrentHash[1]:=CurrentHash[1] + B;
  CurrentHash[2]:=CurrentHash[2] + C;
  CurrentHash[3]:=CurrentHash[3] + D;
  CurrentHash[4]:=CurrentHash[4] + E;
  FillChar(W,Sizeof(W),0);
  FillChar(HashBuffer,Sizeof(HashBuffer),0);
  end;
end;

procedure SHA1UpdateLen(var Data: TSHA1Data; Len: DWord);
begin
 with Data do begin
  Inc(LenLo,(Len shl 3));
  if LenLo<(Len shl 3) then Inc(LenHi);
  Inc(LenHi,(Len div (256*256*256*64)));
 end;
end;

procedure SHA1Init;
begin
 with Data do begin
  SHA1Burn(Data);
  CurrentHash[0]:=$67452301;
  CurrentHash[1]:=$EFCDAB89;
  CurrentHash[2]:=$98BADCFE;
  CurrentHash[3]:=$10325476;
  CurrentHash[4]:=$C3D2E1F0;
 end;
end;

procedure SHA1Burn;
begin
 with Data do begin
  LenHi:=0; LenLo:=0;
  Index:=0;
  FillChar(HashBuffer,Sizeof(HashBuffer),0);
  FillChar(CurrentHash,Sizeof(CurrentHash),0);
 end;
end;

procedure SHA1Update;
var
  PBuf: ^byte;
begin
 with Data do begin
  SHA1UpdateLen(Data,Size);
  PBuf:=@Buffer;
  while Size> 0 do
  begin
   if (Sizeof(HashBuffer)-Index)<=DWord(Size) then
   begin
    Move(PBuf^,HashBuffer[Index],Sizeof(HashBuffer)-Index);
    Dec(Size,Sizeof(HashBuffer)-Index);
    Inc(PBuf,Sizeof(HashBuffer)-Index);
    SHA1Compress(Data);
   end else begin
    Move(PBuf^,HashBuffer[Index],Size);
    Inc(Index,Size);
    Size:=0;
   end;
  end;
 end;
end;

procedure SHA1Final;
begin
 with Data do begin
  HashBuffer[Index]:=$80;
  if Index>=56 then SHA1Compress(Data);
  PDWord(@HashBuffer[56])^:=bswap(lenhi);
  PDWord(@HashBuffer[60])^:=bswap(lenlo);
  SHA1Compress(Data);
  CurrentHash[0]:=bswap(CurrentHash[0]);
  CurrentHash[1]:=bswap(CurrentHash[1]);
  CurrentHash[2]:=bswap(CurrentHash[2]);
  CurrentHash[3]:=bswap(CurrentHash[3]);
  CurrentHash[4]:=bswap(CurrentHash[4]);
  Move(CurrentHash,Digest,Sizeof(CurrentHash));
  SHA1Burn(Data);
 end;
end;

const
 fHashSize=256;

procedure FF_1(var x7, x6, x5, x4, x3, x2, x1, x0: dword; const w: dword);
var
  Temp: dword;
begin
  Temp:=((x2) and ((x6) xor (x1)) xor (x5) and (x4) xor (x0) and (x3) xor (x6));
  x7:=RRot32(temp,7) + RRot32(x7,11) + w;
end;
procedure FF_2(var x7, x6, x5, x4, x3, x2, x1, x0: dword; const w, c: dword);
var
  Temp: dword;
begin
  Temp:=(x3 and (x4 and (not x0) xor x1 and x2 xor x6 xor x5) xor x1 and (x4 xor x2) xor x0 and x2 xor x5);
  x7:=RRot32(temp,7) + RRot32(x7,11) + w + c;
end;
procedure FF_3(var x7, x6, x5, x4, x3, x2, x1, x0: dword; const w, c: dword);
var
  Temp: dword;
begin
  Temp:=((x4) and ((x1) and (x3) xor (x2) xor (x5)) xor (x1) and (x0) xor (x3) and (x6) xor (x5));
  x7:=RRot32(temp,7) + RRot32(x7,11) + w + c;
end;
procedure FF_4(var x7, x6, x5, x4, x3, x2, x1, x0: dword; const w, c: dword);
var
  Temp: dword;
begin
  Temp:=(x3 and (x5 and (not x0) xor x2 and (not x1) xor x4 xor x1 xor x6) xor x2 and
    (x4 and x0 xor x5 xor x1) xor x0 and x1 xor x6);
  x7:=RRot32(temp,7) + RRot32(x7,11) + w + c;
end;
procedure FF_5(var x7, x6, x5, x4, x3, x2, x1, x0: dword; const w, c: dword);
var
  Temp: dword;
begin
  Temp:=(x1 and (x3 and x4 and x6 xor (not x5)) xor x3 and x0 xor x4 and x5 xor x6 and x2);
  x7:=RRot32(temp,7) + RRot32(x7,11) + w + c;
end;

procedure HavalCompress(var Data: THavalData);
var
  t7, t6, t5, t4, t3, t2, t1, t0: DWord;
  W: array[0..31] of DWord;
begin
 with Data do begin
  t0:=CurrentHash[0];
  t1:=CurrentHash[1];
  t2:=CurrentHash[2];
  t3:=CurrentHash[3];
  t4:=CurrentHash[4];
  t5:=CurrentHash[5];
  t6:=CurrentHash[6];
  t7:=CurrentHash[7];
  Move(HashBuffer,W,Sizeof(W));
  FF_1(t7, t6, t5, t4, t3, t2, t1, t0, w[ 0]);
  FF_1(t6, t5, t4, t3, t2, t1, t0, t7, w[ 1]);
  FF_1(t5, t4, t3, t2, t1, t0, t7, t6, w[ 2]);
  FF_1(t4, t3, t2, t1, t0, t7, t6, t5, w[ 3]);
  FF_1(t3, t2, t1, t0, t7, t6, t5, t4, w[ 4]);
  FF_1(t2, t1, t0, t7, t6, t5, t4, t3, w[ 5]);
  FF_1(t1, t0, t7, t6, t5, t4, t3, t2, w[ 6]);
  FF_1(t0, t7, t6, t5, t4, t3, t2, t1, w[ 7]);

  FF_1(t7, t6, t5, t4, t3, t2, t1, t0, w[ 8]);
  FF_1(t6, t5, t4, t3, t2, t1, t0, t7, w[ 9]);
  FF_1(t5, t4, t3, t2, t1, t0, t7, t6, w[10]);
  FF_1(t4, t3, t2, t1, t0, t7, t6, t5, w[11]);
  FF_1(t3, t2, t1, t0, t7, t6, t5, t4, w[12]);
  FF_1(t2, t1, t0, t7, t6, t5, t4, t3, w[13]);
  FF_1(t1, t0, t7, t6, t5, t4, t3, t2, w[14]);
  FF_1(t0, t7, t6, t5, t4, t3, t2, t1, w[15]);

  FF_1(t7, t6, t5, t4, t3, t2, t1, t0, w[16]);
  FF_1(t6, t5, t4, t3, t2, t1, t0, t7, w[17]);
  FF_1(t5, t4, t3, t2, t1, t0, t7, t6, w[18]);
  FF_1(t4, t3, t2, t1, t0, t7, t6, t5, w[19]);
  FF_1(t3, t2, t1, t0, t7, t6, t5, t4, w[20]);
  FF_1(t2, t1, t0, t7, t6, t5, t4, t3, w[21]);
  FF_1(t1, t0, t7, t6, t5, t4, t3, t2, w[22]);
  FF_1(t0, t7, t6, t5, t4, t3, t2, t1, w[23]);

  FF_1(t7, t6, t5, t4, t3, t2, t1, t0, w[24]);
  FF_1(t6, t5, t4, t3, t2, t1, t0, t7, w[25]);
  FF_1(t5, t4, t3, t2, t1, t0, t7, t6, w[26]);
  FF_1(t4, t3, t2, t1, t0, t7, t6, t5, w[27]);
  FF_1(t3, t2, t1, t0, t7, t6, t5, t4, w[28]);
  FF_1(t2, t1, t0, t7, t6, t5, t4, t3, w[29]);
  FF_1(t1, t0, t7, t6, t5, t4, t3, t2, w[30]);
  FF_1(t0, t7, t6, t5, t4, t3, t2, t1, w[31]);

  FF_2(t7, t6, t5, t4, t3, t2, t1, t0, w[ 5], $452821E6);
  FF_2(t6, t5, t4, t3, t2, t1, t0, t7, w[14], $38D01377);
  FF_2(t5, t4, t3, t2, t1, t0, t7, t6, w[26], $BE5466CF);
  FF_2(t4, t3, t2, t1, t0, t7, t6, t5, w[18], $34E90C6C);
  FF_2(t3, t2, t1, t0, t7, t6, t5, t4, w[11], $C0AC29B7);
  FF_2(t2, t1, t0, t7, t6, t5, t4, t3, w[28], $C97C50DD);
  FF_2(t1, t0, t7, t6, t5, t4, t3, t2, w[ 7], $3F84D5B5);
  FF_2(t0, t7, t6, t5, t4, t3, t2, t1, w[16], $B5470917);

  FF_2(t7, t6, t5, t4, t3, t2, t1, t0, w[ 0], $9216D5D9);
  FF_2(t6, t5, t4, t3, t2, t1, t0, t7, w[23], $8979FB1B);
  FF_2(t5, t4, t3, t2, t1, t0, t7, t6, w[20], $D1310BA6);
  FF_2(t4, t3, t2, t1, t0, t7, t6, t5, w[22], $98DFB5AC);
  FF_2(t3, t2, t1, t0, t7, t6, t5, t4, w[ 1], $2FFD72DB);
  FF_2(t2, t1, t0, t7, t6, t5, t4, t3, w[10], $D01ADFB7);
  FF_2(t1, t0, t7, t6, t5, t4, t3, t2, w[ 4], $B8E1AFED);
  FF_2(t0, t7, t6, t5, t4, t3, t2, t1, w[ 8], $6A267E96);

  FF_2(t7, t6, t5, t4, t3, t2, t1, t0, w[30], $BA7C9045);
  FF_2(t6, t5, t4, t3, t2, t1, t0, t7, w[ 3], $F12C7F99);
  FF_2(t5, t4, t3, t2, t1, t0, t7, t6, w[21], $24A19947);
  FF_2(t4, t3, t2, t1, t0, t7, t6, t5, w[ 9], $B3916CF7);
  FF_2(t3, t2, t1, t0, t7, t6, t5, t4, w[17], $0801F2E2);
  FF_2(t2, t1, t0, t7, t6, t5, t4, t3, w[24], $858EFC16);
  FF_2(t1, t0, t7, t6, t5, t4, t3, t2, w[29], $636920D8);
  FF_2(t0, t7, t6, t5, t4, t3, t2, t1, w[ 6], $71574E69);

  FF_2(t7, t6, t5, t4, t3, t2, t1, t0, w[19], $A458FEA3);
  FF_2(t6, t5, t4, t3, t2, t1, t0, t7, w[12], $F4933D7E);
  FF_2(t5, t4, t3, t2, t1, t0, t7, t6, w[15], $0D95748F);
  FF_2(t4, t3, t2, t1, t0, t7, t6, t5, w[13], $728EB658);
  FF_2(t3, t2, t1, t0, t7, t6, t5, t4, w[ 2], $718BCD58);
  FF_2(t2, t1, t0, t7, t6, t5, t4, t3, w[25], $82154AEE);
  FF_2(t1, t0, t7, t6, t5, t4, t3, t2, w[31], $7B54A41D);
  FF_2(t0, t7, t6, t5, t4, t3, t2, t1, w[27], $C25A59B5);

  FF_3(t7, t6, t5, t4, t3, t2, t1, t0, w[19], $9C30D539);
  FF_3(t6, t5, t4, t3, t2, t1, t0, t7, w[ 9], $2AF26013);
  FF_3(t5, t4, t3, t2, t1, t0, t7, t6, w[ 4], $C5D1B023);
  FF_3(t4, t3, t2, t1, t0, t7, t6, t5, w[20], $286085F0);
  FF_3(t3, t2, t1, t0, t7, t6, t5, t4, w[28], $CA417918);
  FF_3(t2, t1, t0, t7, t6, t5, t4, t3, w[17], $B8DB38EF);
  FF_3(t1, t0, t7, t6, t5, t4, t3, t2, w[ 8], $8E79DCB0);
  FF_3(t0, t7, t6, t5, t4, t3, t2, t1, w[22], $603A180E);

  FF_3(t7, t6, t5, t4, t3, t2, t1, t0, w[29], $6C9E0E8B);
  FF_3(t6, t5, t4, t3, t2, t1, t0, t7, w[14], $B01E8A3E);
  FF_3(t5, t4, t3, t2, t1, t0, t7, t6, w[25], $D71577C1);
  FF_3(t4, t3, t2, t1, t0, t7, t6, t5, w[12], $BD314B27);
  FF_3(t3, t2, t1, t0, t7, t6, t5, t4, w[24], $78AF2FDA);
  FF_3(t2, t1, t0, t7, t6, t5, t4, t3, w[30], $55605C60);
  FF_3(t1, t0, t7, t6, t5, t4, t3, t2, w[16], $E65525F3);
  FF_3(t0, t7, t6, t5, t4, t3, t2, t1, w[26], $AA55AB94);

  FF_3(t7, t6, t5, t4, t3, t2, t1, t0, w[31], $57489862);
  FF_3(t6, t5, t4, t3, t2, t1, t0, t7, w[15], $63E81440);
  FF_3(t5, t4, t3, t2, t1, t0, t7, t6, w[ 7], $55CA396A);
  FF_3(t4, t3, t2, t1, t0, t7, t6, t5, w[ 3], $2AAB10B6);
  FF_3(t3, t2, t1, t0, t7, t6, t5, t4, w[ 1], $B4CC5C34);
  FF_3(t2, t1, t0, t7, t6, t5, t4, t3, w[ 0], $1141E8CE);
  FF_3(t1, t0, t7, t6, t5, t4, t3, t2, w[18], $A15486AF);
  FF_3(t0, t7, t6, t5, t4, t3, t2, t1, w[27], $7C72E993);

  FF_3(t7, t6, t5, t4, t3, t2, t1, t0, w[13], $B3EE1411);
  FF_3(t6, t5, t4, t3, t2, t1, t0, t7, w[ 6], $636FBC2A);
  FF_3(t5, t4, t3, t2, t1, t0, t7, t6, w[21], $2BA9C55D);
  FF_3(t4, t3, t2, t1, t0, t7, t6, t5, w[10], $741831F6);
  FF_3(t3, t2, t1, t0, t7, t6, t5, t4, w[23], $CE5C3E16);
  FF_3(t2, t1, t0, t7, t6, t5, t4, t3, w[11], $9B87931E);
  FF_3(t1, t0, t7, t6, t5, t4, t3, t2, w[ 5], $AFD6BA33);
  FF_3(t0, t7, t6, t5, t4, t3, t2, t1, w[ 2], $6C24CF5C);

  FF_4(t7, t6, t5, t4, t3, t2, t1, t0, w[24], $7A325381);
  FF_4(t6, t5, t4, t3, t2, t1, t0, t7, w[ 4], $28958677);
  FF_4(t5, t4, t3, t2, t1, t0, t7, t6, w[ 0], $3B8F4898);
  FF_4(t4, t3, t2, t1, t0, t7, t6, t5, w[14], $6B4BB9AF);
  FF_4(t3, t2, t1, t0, t7, t6, t5, t4, w[ 2], $C4BFE81B);
  FF_4(t2, t1, t0, t7, t6, t5, t4, t3, w[ 7], $66282193);
  FF_4(t1, t0, t7, t6, t5, t4, t3, t2, w[28], $61D809CC);
  FF_4(t0, t7, t6, t5, t4, t3, t2, t1, w[23], $FB21A991);

  FF_4(t7, t6, t5, t4, t3, t2, t1, t0, w[26], $487CAC60);
  FF_4(t6, t5, t4, t3, t2, t1, t0, t7, w[ 6], $5DEC8032);
  FF_4(t5, t4, t3, t2, t1, t0, t7, t6, w[30], $EF845D5D);
  FF_4(t4, t3, t2, t1, t0, t7, t6, t5, w[20], $E98575B1);
  FF_4(t3, t2, t1, t0, t7, t6, t5, t4, w[18], $DC262302);
  FF_4(t2, t1, t0, t7, t6, t5, t4, t3, w[25], $EB651B88);
  FF_4(t1, t0, t7, t6, t5, t4, t3, t2, w[19], $23893E81);
  FF_4(t0, t7, t6, t5, t4, t3, t2, t1, w[ 3], $D396ACC5);

  FF_4(t7, t6, t5, t4, t3, t2, t1, t0, w[22], $0F6D6FF3);
  FF_4(t6, t5, t4, t3, t2, t1, t0, t7, w[11], $83F44239);
  FF_4(t5, t4, t3, t2, t1, t0, t7, t6, w[31], $2E0B4482);
  FF_4(t4, t3, t2, t1, t0, t7, t6, t5, w[21], $A4842004);
  FF_4(t3, t2, t1, t0, t7, t6, t5, t4, w[ 8], $69C8F04A);
  FF_4(t2, t1, t0, t7, t6, t5, t4, t3, w[27], $9E1F9B5E);
  FF_4(t1, t0, t7, t6, t5, t4, t3, t2, w[12], $21C66842);
  FF_4(t0, t7, t6, t5, t4, t3, t2, t1, w[ 9], $F6E96C9A);

  FF_4(t7, t6, t5, t4, t3, t2, t1, t0, w[ 1], $670C9C61);
  FF_4(t6, t5, t4, t3, t2, t1, t0, t7, w[29], $ABD388F0);
  FF_4(t5, t4, t3, t2, t1, t0, t7, t6, w[ 5], $6A51A0D2);
  FF_4(t4, t3, t2, t1, t0, t7, t6, t5, w[15], $D8542F68);
  FF_4(t3, t2, t1, t0, t7, t6, t5, t4, w[17], $960FA728);
  FF_4(t2, t1, t0, t7, t6, t5, t4, t3, w[10], $AB5133A3);
  FF_4(t1, t0, t7, t6, t5, t4, t3, t2, w[16], $6EEF0B6C);
  FF_4(t0, t7, t6, t5, t4, t3, t2, t1, w[13], $137A3BE4);

  FF_5(t7, t6, t5, t4, t3, t2, t1, t0, w[27], $BA3BF050);
  FF_5(t6, t5, t4, t3, t2, t1, t0, t7, w[ 3], $7EFB2A98);
  FF_5(t5, t4, t3, t2, t1, t0, t7, t6, w[21], $A1F1651D);
  FF_5(t4, t3, t2, t1, t0, t7, t6, t5, w[26], $39AF0176);
  FF_5(t3, t2, t1, t0, t7, t6, t5, t4, w[17], $66CA593E);
  FF_5(t2, t1, t0, t7, t6, t5, t4, t3, w[11], $82430E88);
  FF_5(t1, t0, t7, t6, t5, t4, t3, t2, w[20], $8CEE8619);
  FF_5(t0, t7, t6, t5, t4, t3, t2, t1, w[29], $456F9FB4);

  FF_5(t7, t6, t5, t4, t3, t2, t1, t0, w[19], $7D84A5C3);
  FF_5(t6, t5, t4, t3, t2, t1, t0, t7, w[ 0], $3B8B5EBE);
  FF_5(t5, t4, t3, t2, t1, t0, t7, t6, w[12], $E06F75D8);
  FF_5(t4, t3, t2, t1, t0, t7, t6, t5, w[ 7], $85C12073);
  FF_5(t3, t2, t1, t0, t7, t6, t5, t4, w[13], $401A449F);
  FF_5(t2, t1, t0, t7, t6, t5, t4, t3, w[ 8], $56C16AA6);
  FF_5(t1, t0, t7, t6, t5, t4, t3, t2, w[31], $4ED3AA62);
  FF_5(t0, t7, t6, t5, t4, t3, t2, t1, w[10], $363F7706);

  FF_5(t7, t6, t5, t4, t3, t2, t1, t0, w[ 5], $1BFEDF72);
  FF_5(t6, t5, t4, t3, t2, t1, t0, t7, w[ 9], $429B023D);
  FF_5(t5, t4, t3, t2, t1, t0, t7, t6, w[14], $37D0D724);
  FF_5(t4, t3, t2, t1, t0, t7, t6, t5, w[30], $D00A1248);
  FF_5(t3, t2, t1, t0, t7, t6, t5, t4, w[18], $DB0FEAD3);
  FF_5(t2, t1, t0, t7, t6, t5, t4, t3, w[ 6], $49F1C09B);
  FF_5(t1, t0, t7, t6, t5, t4, t3, t2, w[28], $075372C9);
  FF_5(t0, t7, t6, t5, t4, t3, t2, t1, w[24], $80991B7B);

  FF_5(t7, t6, t5, t4, t3, t2, t1, t0, w[ 2], $25D479D8);
  FF_5(t6, t5, t4, t3, t2, t1, t0, t7, w[23], $F6E8DEF7);
  FF_5(t5, t4, t3, t2, t1, t0, t7, t6, w[16], $E3FE501A);
  FF_5(t4, t3, t2, t1, t0, t7, t6, t5, w[22], $B6794C3B);
  FF_5(t3, t2, t1, t0, t7, t6, t5, t4, w[ 4], $976CE0BD);
  FF_5(t2, t1, t0, t7, t6, t5, t4, t3, w[ 1], $04C006BA);
  FF_5(t1, t0, t7, t6, t5, t4, t3, t2, w[25], $C1A94FB6);
  FF_5(t0, t7, t6, t5, t4, t3, t2, t1, w[15], $409F60C4);

  Inc(CurrentHash[0],t0);
  Inc(CurrentHash[1],t1);
  Inc(CurrentHash[2],t2);
  Inc(CurrentHash[3],t3);
  Inc(CurrentHash[4],t4);
  Inc(CurrentHash[5],t5);
  Inc(CurrentHash[6],t6);
  Inc(CurrentHash[7],t7);
  FillChar(W,Sizeof(W),0);
  Index:=0;
  FillChar(HashBuffer,Sizeof(HashBuffer),0);
 end;
end;

procedure HavalUpdateLen(var Data: THavalData; Len: DWord);
begin
 with Data do begin
  Inc(LenLo,(Len shl 3));
  if LenLo<(Len shl 3) then Inc(LenHi);
  Inc(LenHi,(Len div (256*256*256*64)));
 end;
end;

procedure HavalInit;
begin
 HavalBurn(Data);
 with Data do begin
  CurrentHash[0]:=$243F6A88;
  CurrentHash[1]:=$85A308D3;
  CurrentHash[2]:=$13198A2E;
  CurrentHash[3]:=$03707344;
  CurrentHash[4]:=$A4093822;
  CurrentHash[5]:=$299F31D0;
  CurrentHash[6]:=$082EFA98;
  CurrentHash[7]:=$EC4E6C89;
 end;
end;

procedure HavalBurn;
begin
 with Data do begin
  LenHi:=0; LenLo:=0;
  Index:=0;
  FillChar(HashBuffer,Sizeof(HashBuffer),0);
  FillChar(CurrentHash,Sizeof(CurrentHash),0);
 end;
end;

procedure HavalUpdate;
var
  PBuf: ^byte;
begin
 HavalUpdateLen(Data,Size);
 with Data do begin
  PBuf:=@Buffer;
  while Size> 0 do
  begin
    if (Sizeof(HashBuffer)-Index)<=DWord(Size) then
    begin
      Move(PBuf^,HashBuffer[Index],Sizeof(HashBuffer)-Index);
      Dec(Size,Sizeof(HashBuffer)-Index);
      Inc(PBuf,Sizeof(HashBuffer)-Index);
      HavalCompress(Data);
    end
    else
    begin
      Move(PBuf^,HashBuffer[Index],Size);
      Inc(Index,Size);
      Size:=0;
    end;
  end;
 end;
end;

procedure HavalFinal;
begin
 with Data do begin
  HashBuffer[Index]:=$80;
  if Index> 118 then HavalCompress(Data);
  HashBuffer[118]:=((fHashSize and 3) shl 6) or (5 shl 3) or 1;
  HashBuffer[119]:=(fHashSize shr 2) and $FF;
  Move(LenLo,HashBuffer[120],Sizeof(LenLo));
  Move(LenHi,HashBuffer[124],Sizeof(LenHi));
  HavalCompress(Data);
  Move(CurrentHash,Digest,fHashSize div 8);
  HavalBurn(Data); end;
end;

procedure Rmd160Compress(var Data: TRmd160Data);
var
  aa, bb, cc, dd, ee, aaa, bbb, ccc, ddd, eee: DWord;
  X: array[0..15] of DWord;
begin
 with Data do begin
  Move(HashBuffer,X,Sizeof(X));
  aa:=CurrentHash[0];
  aaa:=CurrentHash[0];
  bb:=CurrentHash[1];
  bbb:=CurrentHash[1];
  cc:=CurrentHash[2];
  ccc:=CurrentHash[2];
  dd:=CurrentHash[3];
  ddd:=CurrentHash[3];
  ee:=CurrentHash[4];
  eee:=CurrentHash[4];

  aa:=aa + (bb xor cc xor dd) + X[ 0];
  aa:=LRot32(aa,11) + ee;
  cc:=LRot32(cc,10);
  ee:=ee + (aa xor bb xor cc) + X[ 1];
  ee:=LRot32(ee,14) + dd;
  bb:=LRot32(bb,10);
  dd:=dd + (ee xor aa xor bb) + X[ 2];
  dd:=LRot32(dd,15) + cc;
  aa:=LRot32(aa,10);
  cc:=cc + (dd xor ee xor aa) + X[ 3];
  cc:=LRot32(cc,12) + bb;
  ee:=LRot32(ee,10);
  bb:=bb + (cc xor dd xor ee) + X[ 4];
  bb:=LRot32(bb, 5) + aa;
  dd:=LRot32(dd,10);
  aa:=aa + (bb xor cc xor dd) + X[ 5];
  aa:=LRot32(aa, 8) + ee;
  cc:=LRot32(cc,10);
  ee:=ee + (aa xor bb xor cc) + X[ 6];
  ee:=LRot32(ee, 7) + dd;
  bb:=LRot32(bb,10);
  dd:=dd + (ee xor aa xor bb) + X[ 7];
  dd:=LRot32(dd, 9) + cc;
  aa:=LRot32(aa,10);
  cc:=cc + (dd xor ee xor aa) + X[ 8];
  cc:=LRot32(cc,11) + bb;
  ee:=LRot32(ee,10);
  bb:=bb + (cc xor dd xor ee) + X[ 9];
  bb:=LRot32(bb,13) + aa;
  dd:=LRot32(dd,10);
  aa:=aa + (bb xor cc xor dd) + X[10];
  aa:=LRot32(aa,14) + ee;
  cc:=LRot32(cc,10);
  ee:=ee + (aa xor bb xor cc) + X[11];
  ee:=LRot32(ee,15) + dd;
  bb:=LRot32(bb,10);
  dd:=dd + (ee xor aa xor bb) + X[12];
  dd:=LRot32(dd, 6) + cc;
  aa:=LRot32(aa,10);
  cc:=cc + (dd xor ee xor aa) + X[13];
  cc:=LRot32(cc, 7) + bb;
  ee:=LRot32(ee,10);
  bb:=bb + (cc xor dd xor ee) + X[14];
  bb:=LRot32(bb, 9) + aa;
  dd:=LRot32(dd,10);
  aa:=aa + (bb xor cc xor dd) + X[15];
  aa:=LRot32(aa, 8) + ee;
  cc:=LRot32(cc,10);

  ee:=ee + ((aa and bb) or ((not aa) and cc)) + X[ 7] + $5a827999;
  ee:=LRot32(ee, 7) + dd;
  bb:=LRot32(bb,10);
  dd:=dd + ((ee and aa) or ((not ee) and bb)) + X[ 4] + $5a827999;
  dd:=LRot32(dd, 6) + cc;
  aa:=LRot32(aa,10);
  cc:=cc + ((dd and ee) or ((not dd) and aa)) + X[13] + $5a827999;
  cc:=LRot32(cc, 8) + bb;
  ee:=LRot32(ee,10);
  bb:=bb + ((cc and dd) or ((not cc) and ee)) + X[ 1] + $5a827999;
  bb:=LRot32(bb,13) + aa;
  dd:=LRot32(dd,10);
  aa:=aa + ((bb and cc) or ((not bb) and dd)) + X[10] + $5a827999;
  aa:=LRot32(aa,11) + ee;
  cc:=LRot32(cc,10);
  ee:=ee + ((aa and bb) or ((not aa) and cc)) + X[ 6] + $5a827999;
  ee:=LRot32(ee, 9) + dd;
  bb:=LRot32(bb,10);
  dd:=dd + ((ee and aa) or ((not ee) and bb)) + X[15] + $5a827999;
  dd:=LRot32(dd, 7) + cc;
  aa:=LRot32(aa,10);
  cc:=cc + ((dd and ee) or ((not dd) and aa)) + X[ 3] + $5a827999;
  cc:=LRot32(cc,15) + bb;
  ee:=LRot32(ee,10);
  bb:=bb + ((cc and dd) or ((not cc) and ee)) + X[12] + $5a827999;
  bb:=LRot32(bb, 7) + aa;
  dd:=LRot32(dd,10);
  aa:=aa + ((bb and cc) or ((not bb) and dd)) + X[ 0] + $5a827999;
  aa:=LRot32(aa,12) + ee;
  cc:=LRot32(cc,10);
  ee:=ee + ((aa and bb) or ((not aa) and cc)) + X[ 9] + $5a827999;
  ee:=LRot32(ee,15) + dd;
  bb:=LRot32(bb,10);
  dd:=dd + ((ee and aa) or ((not ee) and bb)) + X[ 5] + $5a827999;
  dd:=LRot32(dd, 9) + cc;
  aa:=LRot32(aa,10);
  cc:=cc + ((dd and ee) or ((not dd) and aa)) + X[ 2] + $5a827999;
  cc:=LRot32(cc,11) + bb;
  ee:=LRot32(ee,10);
  bb:=bb + ((cc and dd) or ((not cc) and ee)) + X[14] + $5a827999;
  bb:=LRot32(bb, 7) + aa;
  dd:=LRot32(dd,10);
  aa:=aa + ((bb and cc) or ((not bb) and dd)) + X[11] + $5a827999;
  aa:=LRot32(aa,13) + ee;
  cc:=LRot32(cc,10);
  ee:=ee + ((aa and bb) or ((not aa) and cc)) + X[ 8] + $5a827999;
  ee:=LRot32(ee,12) + dd;
  bb:=LRot32(bb,10);

  dd:=dd + ((ee or (not aa)) xor bb) + X[ 3] + $6ed9eba1;
  dd:=LRot32(dd,11) + cc;
  aa:=LRot32(aa,10);
  cc:=cc + ((dd or (not ee)) xor aa) + X[10] + $6ed9eba1;
  cc:=LRot32(cc,13) + bb;
  ee:=LRot32(ee,10);
  bb:=bb + ((cc or (not dd)) xor ee) + X[14] + $6ed9eba1;
  bb:=LRot32(bb, 6) + aa;
  dd:=LRot32(dd,10);
  aa:=aa + ((bb or (not cc)) xor dd) + X[ 4] + $6ed9eba1;
  aa:=LRot32(aa, 7) + ee;
  cc:=LRot32(cc,10);
  ee:=ee + ((aa or (not bb)) xor cc) + X[ 9] + $6ed9eba1;
  ee:=LRot32(ee,14) + dd;
  bb:=LRot32(bb,10);
  dd:=dd + ((ee or (not aa)) xor bb) + X[15] + $6ed9eba1;
  dd:=LRot32(dd, 9) + cc;
  aa:=LRot32(aa,10);
  cc:=cc + ((dd or (not ee)) xor aa) + X[ 8] + $6ed9eba1;
  cc:=LRot32(cc,13) + bb;
  ee:=LRot32(ee,10);
  bb:=bb + ((cc or (not dd)) xor ee) + X[ 1] + $6ed9eba1;
  bb:=LRot32(bb,15) + aa;
  dd:=LRot32(dd,10);
  aa:=aa + ((bb or (not cc)) xor dd) + X[ 2] + $6ed9eba1;
  aa:=LRot32(aa,14) + ee;
  cc:=LRot32(cc,10);
  ee:=ee + ((aa or (not bb)) xor cc) + X[ 7] + $6ed9eba1;
  ee:=LRot32(ee, 8) + dd;
  bb:=LRot32(bb,10);
  dd:=dd + ((ee or (not aa)) xor bb) + X[ 0] + $6ed9eba1;
  dd:=LRot32(dd,13) + cc;
  aa:=LRot32(aa,10);
  cc:=cc + ((dd or (not ee)) xor aa) + X[ 6] + $6ed9eba1;
  cc:=LRot32(cc, 6) + bb;
  ee:=LRot32(ee,10);
  bb:=bb + ((cc or (not dd)) xor ee) + X[13] + $6ed9eba1;
  bb:=LRot32(bb, 5) + aa;
  dd:=LRot32(dd,10);
  aa:=aa + ((bb or (not cc)) xor dd) + X[11] + $6ed9eba1;
  aa:=LRot32(aa,12) + ee;
  cc:=LRot32(cc,10);
  ee:=ee + ((aa or (not bb)) xor cc) + X[ 5] + $6ed9eba1;
  ee:=LRot32(ee, 7) + dd;
  bb:=LRot32(bb,10);
  dd:=dd + ((ee or (not aa)) xor bb) + X[12] + $6ed9eba1;
  dd:=LRot32(dd, 5) + cc;
  aa:=LRot32(aa,10);

  cc:=cc + ((dd and aa) or (ee and (not aa))) + X[ 1] + $8f1bbcdc;
  cc:=LRot32(cc,11) + bb;
  ee:=LRot32(ee,10);
  bb:=bb + ((cc and ee) or (dd and (not ee))) + X[ 9] + $8f1bbcdc;
  bb:=LRot32(bb,12) + aa;
  dd:=LRot32(dd,10);
  aa:=aa + ((bb and dd) or (cc and (not dd))) + X[11] + $8f1bbcdc;
  aa:=LRot32(aa,14) + ee;
  cc:=LRot32(cc,10);
  ee:=ee + ((aa and cc) or (bb and (not cc))) + X[10] + $8f1bbcdc;
  ee:=LRot32(ee,15) + dd;
  bb:=LRot32(bb,10);
  dd:=dd + ((ee and bb) or (aa and (not bb))) + X[ 0] + $8f1bbcdc;
  dd:=LRot32(dd,14) + cc;
  aa:=LRot32(aa,10);
  cc:=cc + ((dd and aa) or (ee and (not aa))) + X[ 8] + $8f1bbcdc;
  cc:=LRot32(cc,15) + bb;
  ee:=LRot32(ee,10);
  bb:=bb + ((cc and ee) or (dd and (not ee))) + X[12] + $8f1bbcdc;
  bb:=LRot32(bb, 9) + aa;
  dd:=LRot32(dd,10);
  aa:=aa + ((bb and dd) or (cc and (not dd))) + X[ 4] + $8f1bbcdc;
  aa:=LRot32(aa, 8) + ee;
  cc:=LRot32(cc,10);
  ee:=ee + ((aa and cc) or (bb and (not cc))) + X[13] + $8f1bbcdc;
  ee:=LRot32(ee, 9) + dd;
  bb:=LRot32(bb,10);
  dd:=dd + ((ee and bb) or (aa and (not bb))) + X[ 3] + $8f1bbcdc;
  dd:=LRot32(dd,14) + cc;
  aa:=LRot32(aa,10);
  cc:=cc + ((dd and aa) or (ee and (not aa))) + X[ 7] + $8f1bbcdc;
  cc:=LRot32(cc, 5) + bb;
  ee:=LRot32(ee,10);
  bb:=bb + ((cc and ee) or (dd and (not ee))) + X[15] + $8f1bbcdc;
  bb:=LRot32(bb, 6) + aa;
  dd:=LRot32(dd,10);
  aa:=aa + ((bb and dd) or (cc and (not dd))) + X[14] + $8f1bbcdc;
  aa:=LRot32(aa, 8) + ee;
  cc:=LRot32(cc,10);
  ee:=ee + ((aa and cc) or (bb and (not cc))) + X[ 5] + $8f1bbcdc;
  ee:=LRot32(ee, 6) + dd;
  bb:=LRot32(bb,10);
  dd:=dd + ((ee and bb) or (aa and (not bb))) + X[ 6] + $8f1bbcdc;
  dd:=LRot32(dd, 5) + cc;
  aa:=LRot32(aa,10);
  cc:=cc + ((dd and aa) or (ee and (not aa))) + X[ 2] + $8f1bbcdc;
  cc:=LRot32(cc,12) + bb;
  ee:=LRot32(ee,10);

  bb:=bb + (cc xor (dd or (not ee))) + X[ 4] + $a953fd4e;
  bb:=LRot32(bb, 9) + aa;
  dd:=LRot32(dd,10);
  aa:=aa + (bb xor (cc or (not dd))) + X[ 0] + $a953fd4e;
  aa:=LRot32(aa,15) + ee;
  cc:=LRot32(cc,10);
  ee:=ee + (aa xor (bb or (not cc))) + X[ 5] + $a953fd4e;
  ee:=LRot32(ee, 5) + dd;
  bb:=LRot32(bb,10);
  dd:=dd + (ee xor (aa or (not bb))) + X[ 9] + $a953fd4e;
  dd:=LRot32(dd,11) + cc;
  aa:=LRot32(aa,10);
  cc:=cc + (dd xor (ee or (not aa))) + X[ 7] + $a953fd4e;
  cc:=LRot32(cc, 6) + bb;
  ee:=LRot32(ee,10);
  bb:=bb + (cc xor (dd or (not ee))) + X[12] + $a953fd4e;
  bb:=LRot32(bb, 8) + aa;
  dd:=LRot32(dd,10);
  aa:=aa + (bb xor (cc or (not dd))) + X[ 2] + $a953fd4e;
  aa:=LRot32(aa,13) + ee;
  cc:=LRot32(cc,10);
  ee:=ee + (aa xor (bb or (not cc))) + X[10] + $a953fd4e;
  ee:=LRot32(ee,12) + dd;
  bb:=LRot32(bb,10);
  dd:=dd + (ee xor (aa or (not bb))) + X[14] + $a953fd4e;
  dd:=LRot32(dd, 5) + cc;
  aa:=LRot32(aa,10);
  cc:=cc + (dd xor (ee or (not aa))) + X[ 1] + $a953fd4e;
  cc:=LRot32(cc,12) + bb;
  ee:=LRot32(ee,10);
  bb:=bb + (cc xor (dd or (not ee))) + X[ 3] + $a953fd4e;
  bb:=LRot32(bb,13) + aa;
  dd:=LRot32(dd,10);
  aa:=aa + (bb xor (cc or (not dd))) + X[ 8] + $a953fd4e;
  aa:=LRot32(aa,14) + ee;
  cc:=LRot32(cc,10);
  ee:=ee + (aa xor (bb or (not cc))) + X[11] + $a953fd4e;
  ee:=LRot32(ee,11) + dd;
  bb:=LRot32(bb,10);
  dd:=dd + (ee xor (aa or (not bb))) + X[ 6] + $a953fd4e;
  dd:=LRot32(dd, 8) + cc;
  aa:=LRot32(aa,10);
  cc:=cc + (dd xor (ee or (not aa))) + X[15] + $a953fd4e;
  cc:=LRot32(cc, 5) + bb;
  ee:=LRot32(ee,10);
  bb:=bb + (cc xor (dd or (not ee))) + X[13] + $a953fd4e;
  bb:=LRot32(bb, 6) + aa;
  dd:=LRot32(dd,10);

  aaa:=aaa + (bbb xor (ccc or (not ddd))) + X[ 5] + $50a28be6;
  aaa:=LRot32(aaa, 8) + eee;
  ccc:=LRot32(ccc,10);
  eee:=eee + (aaa xor (bbb or (not ccc))) + X[14] + $50a28be6;
  eee:=LRot32(eee, 9) + ddd;
  bbb:=LRot32(bbb,10);
  ddd:=ddd + (eee xor (aaa or (not bbb))) + X[ 7] + $50a28be6;
  ddd:=LRot32(ddd, 9) + ccc;
  aaa:=LRot32(aaa,10);
  ccc:=ccc + (ddd xor (eee or (not aaa))) + X[ 0] + $50a28be6;
  ccc:=LRot32(ccc,11) + bbb;
  eee:=LRot32(eee,10);
  bbb:=bbb + (ccc xor (ddd or (not eee))) + X[ 9] + $50a28be6;
  bbb:=LRot32(bbb,13) + aaa;
  ddd:=LRot32(ddd,10);
  aaa:=aaa + (bbb xor (ccc or (not ddd))) + X[ 2] + $50a28be6;
  aaa:=LRot32(aaa,15) + eee;
  ccc:=LRot32(ccc,10);
  eee:=eee + (aaa xor (bbb or (not ccc))) + X[11] + $50a28be6;
  eee:=LRot32(eee,15) + ddd;
  bbb:=LRot32(bbb,10);
  ddd:=ddd + (eee xor (aaa or (not bbb))) + X[ 4] + $50a28be6;
  ddd:=LRot32(ddd, 5) + ccc;
  aaa:=LRot32(aaa,10);
  ccc:=ccc + (ddd xor (eee or (not aaa))) + X[13] + $50a28be6;
  ccc:=LRot32(ccc, 7) + bbb;
  eee:=LRot32(eee,10);
  bbb:=bbb + (ccc xor (ddd or (not eee))) + X[ 6] + $50a28be6;
  bbb:=LRot32(bbb, 7) + aaa;
  ddd:=LRot32(ddd,10);
  aaa:=aaa + (bbb xor (ccc or (not ddd))) + X[15] + $50a28be6;
  aaa:=LRot32(aaa, 8) + eee;
  ccc:=LRot32(ccc,10);
  eee:=eee + (aaa xor (bbb or (not ccc))) + X[ 8] + $50a28be6;
  eee:=LRot32(eee,11) + ddd;
  bbb:=LRot32(bbb,10);
  ddd:=ddd + (eee xor (aaa or (not bbb))) + X[ 1] + $50a28be6;
  ddd:=LRot32(ddd,14) + ccc;
  aaa:=LRot32(aaa,10);
  ccc:=ccc + (ddd xor (eee or (not aaa))) + X[10] + $50a28be6;
  ccc:=LRot32(ccc,14) + bbb;
  eee:=LRot32(eee,10);
  bbb:=bbb + (ccc xor (ddd or (not eee))) + X[ 3] + $50a28be6;
  bbb:=LRot32(bbb,12) + aaa;
  ddd:=LRot32(ddd,10);
  aaa:=aaa + (bbb xor (ccc or (not ddd))) + X[12] + $50a28be6;
  aaa:=LRot32(aaa, 6) + eee;
  ccc:=LRot32(ccc,10);

  eee:=eee + ((aaa and ccc) or (bbb and (not ccc))) + X[ 6] + $5c4dd124;
  eee:=LRot32(eee, 9) + ddd;
  bbb:=LRot32(bbb,10);
  ddd:=ddd + ((eee and bbb) or (aaa and (not bbb))) + X[11] + $5c4dd124;
  ddd:=LRot32(ddd,13) + ccc;
  aaa:=LRot32(aaa,10);
  ccc:=ccc + ((ddd and aaa) or (eee and (not aaa))) + X[ 3] + $5c4dd124;
  ccc:=LRot32(ccc,15) + bbb;
  eee:=LRot32(eee,10);
  bbb:=bbb + ((ccc and eee) or (ddd and (not eee))) + X[ 7] + $5c4dd124;
  bbb:=LRot32(bbb, 7) + aaa;
  ddd:=LRot32(ddd,10);
  aaa:=aaa + ((bbb and ddd) or (ccc and (not ddd))) + X[ 0] + $5c4dd124;
  aaa:=LRot32(aaa,12) + eee;
  ccc:=LRot32(ccc,10);
  eee:=eee + ((aaa and ccc) or (bbb and (not ccc))) + X[13] + $5c4dd124;
  eee:=LRot32(eee, 8) + ddd;
  bbb:=LRot32(bbb,10);
  ddd:=ddd + ((eee and bbb) or (aaa and (not bbb))) + X[ 5] + $5c4dd124;
  ddd:=LRot32(ddd, 9) + ccc;
  aaa:=LRot32(aaa,10);
  ccc:=ccc + ((ddd and aaa) or (eee and (not aaa))) + X[10] + $5c4dd124;
  ccc:=LRot32(ccc,11) + bbb;
  eee:=LRot32(eee,10);
  bbb:=bbb + ((ccc and eee) or (ddd and (not eee))) + X[14] + $5c4dd124;
  bbb:=LRot32(bbb, 7) + aaa;
  ddd:=LRot32(ddd,10);
  aaa:=aaa + ((bbb and ddd) or (ccc and (not ddd))) + X[15] + $5c4dd124;
  aaa:=LRot32(aaa, 7) + eee;
  ccc:=LRot32(ccc,10);
  eee:=eee + ((aaa and ccc) or (bbb and (not ccc))) + X[ 8] + $5c4dd124;
  eee:=LRot32(eee,12) + ddd;
  bbb:=LRot32(bbb,10);
  ddd:=ddd + ((eee and bbb) or (aaa and (not bbb))) + X[12] + $5c4dd124;
  ddd:=LRot32(ddd, 7) + ccc;
  aaa:=LRot32(aaa,10);
  ccc:=ccc + ((ddd and aaa) or (eee and (not aaa))) + X[ 4] + $5c4dd124;
  ccc:=LRot32(ccc, 6) + bbb;
  eee:=LRot32(eee,10);
  bbb:=bbb + ((ccc and eee) or (ddd and (not eee))) + X[ 9] + $5c4dd124;
  bbb:=LRot32(bbb,15) + aaa;
  ddd:=LRot32(ddd,10);
  aaa:=aaa + ((bbb and ddd) or (ccc and (not ddd))) + X[ 1] + $5c4dd124;
  aaa:=LRot32(aaa,13) + eee;
  ccc:=LRot32(ccc,10);
  eee:=eee + ((aaa and ccc) or (bbb and (not ccc))) + X[ 2] + $5c4dd124;
  eee:=LRot32(eee,11) + ddd;
  bbb:=LRot32(bbb,10);

  ddd:=ddd + ((eee or (not aaa)) xor bbb) + X[15] + $6d703ef3;
  ddd:=LRot32(ddd, 9) + ccc;
  aaa:=LRot32(aaa,10);
  ccc:=ccc + ((ddd or (not eee)) xor aaa) + X[ 5] + $6d703ef3;
  ccc:=LRot32(ccc, 7) + bbb;
  eee:=LRot32(eee,10);
  bbb:=bbb + ((ccc or (not ddd)) xor eee) + X[ 1] + $6d703ef3;
  bbb:=LRot32(bbb,15) + aaa;
  ddd:=LRot32(ddd,10);
  aaa:=aaa + ((bbb or (not ccc)) xor ddd) + X[ 3] + $6d703ef3;
  aaa:=LRot32(aaa,11) + eee;
  ccc:=LRot32(ccc,10);
  eee:=eee + ((aaa or (not bbb)) xor ccc) + X[ 7] + $6d703ef3;
  eee:=LRot32(eee, 8) + ddd;
  bbb:=LRot32(bbb,10);
  ddd:=ddd + ((eee or (not aaa)) xor bbb) + X[14] + $6d703ef3;
  ddd:=LRot32(ddd, 6) + ccc;
  aaa:=LRot32(aaa,10);
  ccc:=ccc + ((ddd or (not eee)) xor aaa) + X[ 6] + $6d703ef3;
  ccc:=LRot32(ccc, 6) + bbb;
  eee:=LRot32(eee,10);
  bbb:=bbb + ((ccc or (not ddd)) xor eee) + X[ 9] + $6d703ef3;
  bbb:=LRot32(bbb,14) + aaa;
  ddd:=LRot32(ddd,10);
  aaa:=aaa + ((bbb or (not ccc)) xor ddd) + X[11] + $6d703ef3;
  aaa:=LRot32(aaa,12) + eee;
  ccc:=LRot32(ccc,10);
  eee:=eee + ((aaa or (not bbb)) xor ccc) + X[ 8] + $6d703ef3;
  eee:=LRot32(eee,13) + ddd;
  bbb:=LRot32(bbb,10);
  ddd:=ddd + ((eee or (not aaa)) xor bbb) + X[12] + $6d703ef3;
  ddd:=LRot32(ddd, 5) + ccc;
  aaa:=LRot32(aaa,10);
  ccc:=ccc + ((ddd or (not eee)) xor aaa) + X[ 2] + $6d703ef3;
  ccc:=LRot32(ccc,14) + bbb;
  eee:=LRot32(eee,10);
  bbb:=bbb + ((ccc or (not ddd)) xor eee) + X[10] + $6d703ef3;
  bbb:=LRot32(bbb,13) + aaa;
  ddd:=LRot32(ddd,10);
  aaa:=aaa + ((bbb or (not ccc)) xor ddd) + X[ 0] + $6d703ef3;
  aaa:=LRot32(aaa,13) + eee;
  ccc:=LRot32(ccc,10);
  eee:=eee + ((aaa or (not bbb)) xor ccc) + X[ 4] + $6d703ef3;
  eee:=LRot32(eee, 7) + ddd;
  bbb:=LRot32(bbb,10);
  ddd:=ddd + ((eee or (not aaa)) xor bbb) + X[13] + $6d703ef3;
  ddd:=LRot32(ddd, 5) + ccc;
  aaa:=LRot32(aaa,10);

  ccc:=ccc + ((ddd and eee) or ((not ddd) and aaa)) + X[ 8] + $7a6d76e9;
  ccc:=LRot32(ccc,15) + bbb;
  eee:=LRot32(eee,10);
  bbb:=bbb + ((ccc and ddd) or ((not ccc) and eee)) + X[ 6] + $7a6d76e9;
  bbb:=LRot32(bbb, 5) + aaa;
  ddd:=LRot32(ddd,10);
  aaa:=aaa + ((bbb and ccc) or ((not bbb) and ddd)) + X[ 4] + $7a6d76e9;
  aaa:=LRot32(aaa, 8) + eee;
  ccc:=LRot32(ccc,10);
  eee:=eee + ((aaa and bbb) or ((not aaa) and ccc)) + X[ 1] + $7a6d76e9;
  eee:=LRot32(eee,11) + ddd;
  bbb:=LRot32(bbb,10);
  ddd:=ddd + ((eee and aaa) or ((not eee) and bbb)) + X[ 3] + $7a6d76e9;
  ddd:=LRot32(ddd,14) + ccc;
  aaa:=LRot32(aaa,10);
  ccc:=ccc + ((ddd and eee) or ((not ddd) and aaa)) + X[11] + $7a6d76e9;
  ccc:=LRot32(ccc,14) + bbb;
  eee:=LRot32(eee,10);
  bbb:=bbb + ((ccc and ddd) or ((not ccc) and eee)) + X[15] + $7a6d76e9;
  bbb:=LRot32(bbb, 6) + aaa;
  ddd:=LRot32(ddd,10);
  aaa:=aaa + ((bbb and ccc) or ((not bbb) and ddd)) + X[ 0] + $7a6d76e9;
  aaa:=LRot32(aaa,14) + eee;
  ccc:=LRot32(ccc,10);
  eee:=eee + ((aaa and bbb) or ((not aaa) and ccc)) + X[ 5] + $7a6d76e9;
  eee:=LRot32(eee, 6) + ddd;
  bbb:=LRot32(bbb,10);
  ddd:=ddd + ((eee and aaa) or ((not eee) and bbb)) + X[12] + $7a6d76e9;
  ddd:=LRot32(ddd, 9) + ccc;
  aaa:=LRot32(aaa,10);
  ccc:=ccc + ((ddd and eee) or ((not ddd) and aaa)) + X[ 2] + $7a6d76e9;
  ccc:=LRot32(ccc,12) + bbb;
  eee:=LRot32(eee,10);
  bbb:=bbb + ((ccc and ddd) or ((not ccc) and eee)) + X[13] + $7a6d76e9;
  bbb:=LRot32(bbb, 9) + aaa;
  ddd:=LRot32(ddd,10);
  aaa:=aaa + ((bbb and ccc) or ((not bbb) and ddd)) + X[ 9] + $7a6d76e9;
  aaa:=LRot32(aaa,12) + eee;
  ccc:=LRot32(ccc,10);
  eee:=eee + ((aaa and bbb) or ((not aaa) and ccc)) + X[ 7] + $7a6d76e9;
  eee:=LRot32(eee, 5) + ddd;
  bbb:=LRot32(bbb,10);
  ddd:=ddd + ((eee and aaa) or ((not eee) and bbb)) + X[10] + $7a6d76e9;
  ddd:=LRot32(ddd,15) + ccc;
  aaa:=LRot32(aaa,10);
  ccc:=ccc + ((ddd and eee) or ((not ddd) and aaa)) + X[14] + $7a6d76e9;
  ccc:=LRot32(ccc, 8) + bbb;
  eee:=LRot32(eee,10);

  bbb:=bbb + (ccc xor ddd xor eee) + X[12];
  bbb:=LRot32(bbb, 8) + aaa;
  ddd:=LRot32(ddd,10);
  aaa:=aaa + (bbb xor ccc xor ddd) + X[15];
  aaa:=LRot32(aaa, 5) + eee;
  ccc:=LRot32(ccc,10);
  eee:=eee + (aaa xor bbb xor ccc) + X[10];
  eee:=LRot32(eee,12) + ddd;
  bbb:=LRot32(bbb,10);
  ddd:=ddd + (eee xor aaa xor bbb) + X[ 4];
  ddd:=LRot32(ddd, 9) + ccc;
  aaa:=LRot32(aaa,10);
  ccc:=ccc + (ddd xor eee xor aaa) + X[ 1];
  ccc:=LRot32(ccc,12) + bbb;
  eee:=LRot32(eee,10);
  bbb:=bbb + (ccc xor ddd xor eee) + X[ 5];
  bbb:=LRot32(bbb, 5) + aaa;
  ddd:=LRot32(ddd,10);
  aaa:=aaa + (bbb xor ccc xor ddd) + X[ 8];
  aaa:=LRot32(aaa,14) + eee;
  ccc:=LRot32(ccc,10);
  eee:=eee + (aaa xor bbb xor ccc) + X[ 7];
  eee:=LRot32(eee, 6) + ddd;
  bbb:=LRot32(bbb,10);
  ddd:=ddd + (eee xor aaa xor bbb) + X[ 6];
  ddd:=LRot32(ddd, 8) + ccc;
  aaa:=LRot32(aaa,10);
  ccc:=ccc + (ddd xor eee xor aaa) + X[ 2];
  ccc:=LRot32(ccc,13) + bbb;
  eee:=LRot32(eee,10);
  bbb:=bbb + (ccc xor ddd xor eee) + X[13];
  bbb:=LRot32(bbb, 6) + aaa;
  ddd:=LRot32(ddd,10);
  aaa:=aaa + (bbb xor ccc xor ddd) + X[14];
  aaa:=LRot32(aaa, 5) + eee;
  ccc:=LRot32(ccc,10);
  eee:=eee + (aaa xor bbb xor ccc) + X[ 0];
  eee:=LRot32(eee,15) + ddd;
  bbb:=LRot32(bbb,10);
  ddd:=ddd + (eee xor aaa xor bbb) + X[ 3];
  ddd:=LRot32(ddd,13) + ccc;
  aaa:=LRot32(aaa,10);
  ccc:=ccc + (ddd xor eee xor aaa) + X[ 9];
  ccc:=LRot32(ccc,11) + bbb;
  eee:=LRot32(eee,10);
  bbb:=bbb + (ccc xor ddd xor eee) + X[11];
  bbb:=LRot32(bbb,11) + aaa;
  ddd:=LRot32(ddd,10);

  ddd:=ddd + cc + CurrentHash[1];
  CurrentHash[1]:=CurrentHash[2] + dd + eee;
  CurrentHash[2]:=CurrentHash[3] + ee + aaa;
  CurrentHash[3]:=CurrentHash[4] + aa + bbb;
  CurrentHash[4]:=CurrentHash[0] + bb + ccc;
  CurrentHash[0]:=ddd;
  FillChar(X,Sizeof(X),0);
  Index:=0;
  FillChar(HashBuffer,Sizeof(HashBuffer),0);
 end;
end;

procedure Rmd160UpdateLen(var Data: TRmd160Data; Len: DWord);
begin
 with Data do begin
  Inc(LenLo,(Len shl 3));
  if LenLo<(Len shl 3) then Inc(LenHi);
  Inc(LenHi,(Len div (256*256*256*64)));
 end;
end;

procedure Rmd160Init;
begin
 with Data do begin
  Rmd160Burn(Data);
  CurrentHash[0]:=$67452301;
  CurrentHash[1]:=$efcdab89;
  CurrentHash[2]:=$98badcfe;
  CurrentHash[3]:=$10325476;
  CurrentHash[4]:=$c3d2e1f0;
 end;
end;

procedure Rmd160Burn;
begin
 with Data do begin
  LenHi:=0; LenLo:=0;
  Index:=0;
  FillChar(HashBuffer,Sizeof(HashBuffer),0);
  FillChar(CurrentHash,Sizeof(CurrentHash),0);
 end;
end;

procedure Rmd160Update;
var
  PBuf: ^byte;
begin
 with Data do begin
  Rmd160UpdateLen(Data,Size);
  PBuf:=@Buffer;
  while Size> 0 do
  begin
    if (Sizeof(HashBuffer)-Index)<=DWord(Size) then
    begin
      Move(PBuf^,HashBuffer[Index],Sizeof(HashBuffer)-Index);
      Dec(Size,Sizeof(HashBuffer)-Index);
      Inc(PBuf,Sizeof(HashBuffer)-Index);
      Rmd160Compress(Data);
    end
    else
    begin
      Move(PBuf^,HashBuffer[Index],Size);
      Inc(Index,Size);
      Size:=0;
    end;
  end;
 end;
end;

procedure Rmd160Final;
begin
 with Data do begin
  HashBuffer[Index]:=$80;
  if Index>=56 then Rmd160Compress(Data);
  PDWord(@HashBuffer[56])^:=LenLo;
  PDWord(@HashBuffer[60])^:=LenHi;
  Rmd160Compress(Data);
  Move(CurrentHash,Digest,Sizeof(CurrentHash));
  Rmd160Burn(Data);
 end;
end;

{
Created by Bilbo (bilbo@centrum.cz) based on code
 written by David Barton (davebarton@bigfoot.com)
}

{$ifndef windows}

var
 old:procedure;
 oldexitproc:pointer;
{$f+}
procedure nic;interrupt;assembler;asm mov [cbpressed],true;end;
{$f-}

{$f+}
procedure donecb;
begin
 setintvec($1b,@old);
 exitproc:=oldexitproc;
 old:=nil;
 oldexitproc:=nil;
 asm
  db 66h;xor ax,ax
  db 66h;xor bx,bx
  db 66h;xor cx,cx
  db 66h;xor dx,dx
  db 66h;xor di,di
  db 66h;xor si,si
  mov es,ax
 end;
end;
{$f-}

{$endif}

{$ifdef win32}

function handler(typ:longint):longbool;stdcall;
begin
 if typ in [CTRL_C_EVENT,CTRL_BREAK_EVENT,CTRL_CLOSE_EVENT,CTRL_LOGOFF_EVENT,CTRL_SHUTDOWN_EVENT]
 then begin
  cbpressed:=true;
  handler:=TRUE;
 end else handler:=FALSE;
end;

procedure initcb;
begin
setconsolectrlhandler(@handler,TRUE);
end;
{$else}
procedure initcb;
begin
 getintvec($1b,@old);
 setintvec($1b,addr(nic));
 oldexitproc:=exitproc;
 exitproc:=@donecb;
end;
{$endif}

{$ifndef windows}

procedure debugtrap;assembler;
asm
 db 0ebh,01h,9ah
end;

function gettickcount:longint;assembler;
asm
 mov di,046ch
 xor ax,ax
 mov es,ax
 mov ax,es:[di]
 mov dx,es:[di+2]
end;

procedure resetcomp;assembler;
asm
 db 0eah;dw 0;dw -1;
end;

procedure hw_reboot;assembler;
asm
 mov al,0feh
 out 64h,al
end;

function debuggeractive: boolean;
var s:word;
begin
 s:=memw[prefixseg:$16];
 s:=memw[s-1:3];
 debuggeractive:=(s>=$180);
end;

{$endif}

function loCase(Chr: Char): Char;assembler;
asm
 MOV AL,chr
 CMP AL,'A'
 JB  @1
 CMP AL,'Z'
 JA  @1
 sub AL,'A'-'a'
@1:
end;

procedure error(const s:string);
begin
 writeln(s);
 halt(255);
end;

{$ifdef windows}

function strl(i:longint):string;assembler;
 asm
  xor ecx,ecx
  xor ebx,ebx
  mov bl,10
  mov eax,[i]
 @1:
  xor edx,edx
  div ebx
  push edx
  inc ecx
  cmp eax,0
  jne @1
  mov edi,0
  mov [result],cl
 @2:
  pop eax
  add al,'0'
  inc edi
  mov [result+edi],al
  loop @2
 end;

{$else}

function strl(i:longint):string;assembler;
 asm
  xor cx,cx
  db 66h;xor bx,bx
  mov bl,10
  db 66h;mov ax,word [i]
 @1:
  db 66h;xor dx,dx
  db 66h;div bx
  push dx
  inc cx
  db 66h;cmp ax,0;dw 0
  jne @1
  les di,[bp+offset @result]
  mov es:[di],cl
 @2:
  pop ax
  add al,'0'
  inc di
  mov es:[di],al
  loop @2
 end;
{$endif}
const chex:string='0123456789ABCDEF';

function hexp(w:longint):string;
begin
 hexp[0]:=#9;
 hexp[1]:=chex[((dw(w).b4 and $f0)shr 4)+1];
 hexp[2]:=chex[((dw(w).b4 and $0f))+1];
 hexp[3]:=chex[((dw(w).b3 and $f0)shr 4)+1];
 hexp[4]:=chex[((dw(w).b3 and $0f))+1];
 hexp[5]:=':';
 hexp[6]:=chex[((dw(w).b2 and $f0)shr 4)+1];
 hexp[7]:=chex[((dw(w).b2 and $0f))+1];
 hexp[8]:=chex[((dw(w).b1 and $f0)shr 4)+1];
 hexp[9]:=chex[((dw(w).b1 and $0f))+1];
end;

function hexl(w:longint):string;
begin
 hexl[0]:=#8;
 hexl[1]:=chex[((dw(w).b4 and $f0)shr 4)+1];
 hexl[2]:=chex[((dw(w).b4 and $0f))+1];
 hexl[3]:=chex[((dw(w).b3 and $f0)shr 4)+1];
 hexl[4]:=chex[((dw(w).b3 and $0f))+1];
 hexl[5]:=chex[((dw(w).b2 and $f0)shr 4)+1];
 hexl[6]:=chex[((dw(w).b2 and $0f))+1];
 hexl[7]:=chex[((dw(w).b1 and $f0)shr 4)+1];
 hexl[8]:=chex[((dw(w).b1 and $0f))+1];
end;

function hexw(w:word):string;
begin
 hexw[0]:=#4;
 hexw[1]:=chex[((hi(w) and $f0)shr 4)+1];
 hexw[2]:=chex[((hi(w) and $0f))+1];
 hexw[3]:=chex[((lo(w) and $f0)shr 4)+1];
 hexw[4]:=chex[((lo(w) and $0f))+1];
end;

function hexb(w:byte):string;
begin
 hexb[0]:=#2;
 hexb[1]:=chex[((w and $f0)shr 4)+1];
 hexb[2]:=chex[((w and $0f))+1];
end;

function crcb(const b;s:word):byte;
var
 c:byte;
 i:word;
begin
 c:=0;
 if s<>0 then
  for i:=0 to s-1 do inc(c,a0(b)[i]);
 crcb:=c;
 c:=0;i:=0;s:=0;
end;
function crcw(const b;s:word):word;
var
 c:word;
 i:word;
begin
 c:=0;
 if s<>0 then for i:=0 to s-1 do inc(c,a0(b)[i]);
 crcw:=c;
 c:=0;i:=0;s:=0;
end;

function crc(const s:string):byte;
var
 c:byte;
 i:word;
begin
 c:=0;
 if s[0]<>#0 then
 for i:=1 to ord(s[0]) do
 begin
  if (i and 1)=1 then inc(c,ord(s[i])) else dec(c,ord(s[i]));
 end;
 crc:=c;
 c:=0;i:=0;
end;

function _crcw(const s:string):word;
var
 c:word;
 i:word;
begin
 c:=0;
 if s[0]<>#0 then;
 for i:=1 to ord(s[0]) do
 begin
  inc(c,word(ord(s[i]))shl i mod 8);
 end;
 _crcw:=c;
 c:=0;i:=0;
end;

function tohexkey(const s:string):string;
var
 t:string;
 i:word;
begin
 t:='';
 for i:=1 to ord(s[0]) do
 begin
  t:=t+hexb(ord(s[i]));
 end;
 tohexkey:=t;
end;

function fromhexkey(s:string):string;
var
 t:string;
 i:word;
begin
 t:='';
 if (ord(s[0]) and 1)=0 then
 begin
  for i:=1 to ord(s[0]) do s[i]:=upcase(s[i]);
  for i:=1 to ord(s[0]) do begin
   if not(s[i] in ['0'..'9','A'..'F']) then
   begin
    fromhexkey:=t;
    exit;
   end;
   if s[i] in ['0'..'9'] then dec(s[i],ord('0')) else dec(s[i],ord('A')-10);
  end;
  t[0]:=chr(ord(s[0]) shr 1);
  for i:=1 to ord(t[0]) do t[i]:=chr(ord(s[i*2-1])*16+ord(s[i*2]));
 end;
 fromhexkey:=t;
end;

{$ifndef win32}
var
__kb__:array[0..31]of char absolute 0:$41e;
__kb1__:word absolute 0:$41a;
__kb2__:word absolute 0:$41c;
{$endif}

procedure keybufclear;
begin
{$ifdef win32}
 FlushConsoleInputBuffer(GetStdhandle(STD_INPUT_HANDLE));
 {need to find some way to clear kbd buffer in Delphi. Seems to be impossible}
{$else}
 fillchar(__kb__,sizeof(__kb__),0);__kb2__:=__kb1__;{clear keyboard buffer}
{$endif}
end;

{$ifndef win32}
{procedure writex(x,y:word;s:string);
var o:word;
begin
 if s[0]=#0 then exit;
 o:=x*2+y*160;
 asm
  xor cx,cx
  mov cl,[bp+offset s[0]]
  mov ax,segb800
  mov es,ax
  mov ah,7
  mov si,offset s[0]
  mov di,[o]
  sub di,162
 @e:
  inc si
  mov al,ss:[bp+si]
  stosw
  loop @e
 end;
end;}
procedure readpwdenc(var s:string);
var
 i:integer;
 k:char;
begin
 s:='';
 if cbpressed then exit;
 repeat
  repeat
   i:=random(i*2+1);
  until keypressed;
  k:=readkey;
  if cbpressed then begin
   k:=#0;i:=0;
   fillchar(s,sizeof(s),0);
   exit;
  end;
  if k=#8 then begin
   if s[0]<>#0 then begin s[ord(s[0])]:=#0;dec(s[0]);write(#8' '#8);end;
  end else begin
   if k<>#13 then begin write('*');s:=s+chr(ord(k)+$80);end;
  end;
 until k=#13;
 writeln;
 i:=0;k:=#0;
end;
{$else}
procedure readpwdenc(var s:String);
var
 ev:TInputrecord;
 ConsInfo:tconsolescreenbufferinfo;
 events_read:DWORD;
 done:Boolean;
 NewPos:tcoord;
begin
 if cbpressed then exit;
 done:=False;
 s:='';
 GetConsoleScreenBufferInfo(GetStdHandle(STD_OUTPUT_HANDLE), ConsInfo);
 NewPos.Y:=ConsInfo.dwcursorposition.Y;
 repeat
  ReadConsoleInput(GetStdhandle(STD_INPUT_HANDLE),ev,1,events_read);
  if cbpressed then begin
   done:=false;
   fillchar(ev,sizeof(ev),0);
   fillchar(s,sizeof(s),0);
   fillchar(consinfo,sizeof(consinfo),0);
   fillchar(newpos,sizeof(newpos),0);
   events_read:=0;
   exit;
  end;
  if ev.Eventtype=key_Event then
   with ev.KeyEvent do
    if bKeyDown then begin
     done:=wVirtualKeyCode=VK_RETURN;
     if wVirtualKeyCode=VK_BACK then begin
      if s[0]<>#0 then begin
       s[ord(s[0])]:=#0;dec(s[0]);
       newpos.x:=ConsInfo.dwcursorposition.X;
       SetConsoleCursorPosition(GetStdHandle(STD_OUTPUT_HANDLE), NewPos);
       if s[0]<>#0 then for events_read:=1 to ord(s[0]) do Write('*');
       Write(' ');
       newpos.x:=ConsInfo.dwcursorposition.X+ord(s[0]);
       SetConsoleCursorPosition(GetStdHandle(STD_OUTPUT_HANDLE), NewPos);
      end;
     end else if not done and (AsciiChar <> #0) then
      begin
       Write('*');
       s:=s+chr(ord(AsciiChar)+$80);
      end;
     end;
  until done;
 fillchar(ev,sizeof(ev),0);
 fillchar(consinfo,sizeof(consinfo),0);
 events_read:=0;
 fillchar(newpos,sizeof(newpos),0);
 done:=false;
 Writeln;
end;
{$endif}

procedure burnstring(var s:string);
var i:word;
begin
 for i:=0 to 255 do s[i]:=#0;i:=0;
end;

procedure add80buf(b:pointer;s:word);
var i:word;
begin
 if s>0 then for i:=1 to s do begin
  inc(byte(b^),$80);
  inc(pchar(b));
 end;
 i:=0;
 b:=nil;
 s:=0;
end;

procedure add88buf(b:pointer;s:word);
var i:word;
begin
 if s>0 then for i:=1 to s do begin
  inc(byte(b^),$80);
  byte(b^):=((byte(b^) and $f) shl 4)+((byte(b^) and $f0) shr 4);
  inc(byte(b^),$80);
  inc(pchar(b));
 end;
 i:=0;
 b:=nil;
 s:=0;
end;

{$ifdef win32}

function LRot16(X: Word; c: longint): Word; assembler;
asm
  mov ecx,&c
  mov ax,&X
  rol ax,cl
  mov &Result,ax
end;

function RRot16(X: Word; c: longint): Word; assembler;
asm
  mov ecx,&c
  mov ax,&X
  ror ax,cl
  mov &Result,ax
end;

function LRot32(X: DWord; c: longint): DWord; register; assembler;
asm
 mov ecx, edx
 rol eax, cl
end;

function RRot32(X: DWord; c: longint): DWord; register; assembler;
asm
 mov ecx, edx
 ror eax, cl
end;

function bswap(X:longint):longint; register; assembler;
asm
  xchg al,ah
  rol  eax,16
  xchg al,ah
end;
{$else}

function LRot16(X: Word; c: word): Word;
begin
  LRot16:=(X shl c) or (X shr (16 - c));
end;

function RRot16(X: Word; c: word): Word;
begin
  RRot16:=(X shr c) or (X shl (16 - c));
end;

function LRot32(X:DWord;c:word): DWord;assembler;
asm
 mov cx,[c]
 db 66h;mov ax,x.word
 db 66h;rol ax, cl
 db 66h;mov dx,ax
 db 66h;shr dx,16
end;

function RRot32(X:DWord;c:word): DWord;assembler;
asm
 mov cx,[c]
 db 66h;mov ax,x.word
 db 66h;ror ax, cl
 db 66h;mov dx,ax
 db 66h;shr dx,16
end;

function bswap(X:longint):longint;assembler;
asm
 mov ax,x.word+2
 xchg al,ah
 mov dx,x.word
 xchg dl,dh
end;

{$endif}
procedure XorBlock(I1, I2, O1: PByteArray; Len: integer);
var
 i: integer;
begin
 for i:=0 to Len-1 do O1^[i]:=I1^[i] xor I2^[i];
end;

procedure writeblocktofile(const s:string;var da;dl:word);
var
 f:file;
begin
 assign(f,s);
 rewrite(f,1);
 blockwrite(f,da,dl);
 close(f);
end;

procedure convert256to128(var currenthash);
var temp:longint;
begin
 begin
  temp:=(tdwordarray(CurrentHash)[7] and $000000FF) or
        (tdwordarray(CurrentHash)[6] and $FF000000) or
        (tdwordarray(CurrentHash)[5] and $00FF0000) or
        (tdwordarray(CurrentHash)[4] and $0000FF00);
  Inc(tdwordarray(CurrentHash)[0],RRot32(temp,  8));
  temp:=(tdwordarray(CurrentHash)[7] and $0000FF00) or
        (tdwordarray(CurrentHash)[6] and $000000FF) or
        (tdwordarray(CurrentHash)[5] and $FF000000) or
        (tdwordarray(CurrentHash)[4] and $00FF0000);
  Inc(tdwordarray(CurrentHash)[1],RRot32(temp, 16));
  temp:=(tdwordarray(CurrentHash)[7] and $00FF0000) or
        (tdwordarray(CurrentHash)[6] and $0000FF00) or
        (tdwordarray(CurrentHash)[5] and $000000FF) or
        (tdwordarray(CurrentHash)[4] and $FF000000);
  Inc(tdwordarray(CurrentHash)[2],RRot32(temp, 24));
  temp:=(tdwordarray(CurrentHash)[7] and $FF000000) or
        (tdwordarray(CurrentHash)[6] and $00FF0000) or
        (tdwordarray(CurrentHash)[5] and $0000FF00) or
        (tdwordarray(CurrentHash)[4] and $000000FF);
  Inc(tdwordarray(CurrentHash)[3],temp);
 end;
 tdwordarray(CurrentHash)[7]:=0;
 tdwordarray(CurrentHash)[6]:=0;
 tdwordarray(CurrentHash)[5]:=0;
 tdwordarray(CurrentHash)[4]:=0;
end;

end.