{NOT!!$define encrypt_ivector}
{$A+,B-,D-,E-,F-,G+,I-,L-,N-,P-,Q-,R-,S-,T-,V+,X+,Y-}
{$ifdef win32}{$H-,O+}{$endif}
unit crypt;
{Modified by Bilbo (bilbo@centrum.cz)
 from code written by David Barton (davebarton@bigfoot.com)
 The original code (DCPCrypt) is available on http://www.scramdisk.clara.net
 I've modified this to work also on 16 bit systems and also added some
 minor improvements

 Blowfish passed tests with both ECB and CBC.
 I was unable to test CFB, since the tests assume CFB64 and this is CFB8
 other block ciphers are untested now, but seems to be ok...
}
{
Algorithm:     Twofish Blowfish IDEA Rijndael Cast128
---------------------------------------------------------
Speed (BP7)        527     847   253    1312   772
Speed (Delphi2)   4847    2603  2177    3574  2997
Max. Key bits      256     448   128     256   128
Block bits         128      64    64     128    64
patented?	    no      no  *yes      no    no
*Yes, but free for non-commercial purposes.

Maybe add: RC6
}
interface
uses
 B_crypt;

const
  BLU:array[0..3] of DWord=(0,8,16,24);
  TWOFISH_BLOCKSIZE=16;
  INPUTWHITEN=0;
  OUTPUTWHITEN=(TWOFISH_BLOCKSIZE div 4);
  NUMROUNDS=16;
  ROUNDSUBKEYS=(OUTPUTWHITEN+TWOFISH_BLOCKSIZE div 4);
  TOTALSUBKEYS=(ROUNDSUBKEYS+NUMROUNDS*2);
  RS_GF_FDBK=$14d;
  SK_STEP=$02020202;
  SK_BUMP=$01010101;
  SK_ROTL=9;
  P_00=1;
  P_01=0;
  P_02=0;
  P_03=(P_01 xor 1);
  P_04=1;
  P_10=0;
  P_11=0;
  P_12=1;
  P_13=(P_11 xor 1);
  P_14=0;
  P_20=1;
  P_21=1;
  P_22=0;
  P_23=(P_21 xor 1);
  P_24=0;
  P_30=0;
  P_31=1;
  P_32=1;
  P_33=(P_31 xor 1);
  P_34=1;
  MDS_GF_FDBK=$169;

var
  precomp:boolean;

type
  TTwofishData=record
    IV,LB:array[0..15] of byte;
    KeyLen:DWord;
    SubKeys:array[0..TOTALSUBKEYS-1] of DWord;
    sboxKeys:array[0..3] of DWord;
    sbox:array[0..3,0..255] of DWord;
  end;
  TBlowfishData=record
    IV, LB: array[0..7] of byte;
    SBox: array[0..3,0..255] of DWord;
    PBox: array[0..17] of DWord;
  end;
  TIDEAData=record
   IV,LB:array[0..7] of byte;
   EK:array[0..51] of word;
   DK:array[0..51] of word;
   Rounds:longint;
  end;

procedure TwofishInit(var Data:TTwofishData;var Key;Size:longint;IVector:pointer);
procedure TwofishReset(var Data:TTwofishData);
procedure TwofishBurn(var Data: TTwofishData);
procedure TwofishEncryptECB(var Data:TTwofishData;const InBlock;var OutBlock);
procedure TwofishDecryptECB(var Data:TTwofishData;const InBlock;var OutBlock);
procedure TwofishEncryptCBC(var Data:TTwofishData;const InData;var OutData;Size:longint);
procedure TwofishDecryptCBC(var Data:TTwofishData;const InData;var OutData;Size:longint);
procedure TwofishEncryptCFB(var Data:TTwofishData;const InData;var OutData;Size:longint);
procedure TwofishDecryptCFB(var Data:TTwofishData;const InData;var OutData;Size:longint);
procedure PreCompMDS;

procedure BlowfishInit(var Data: TBlowfishData; var Key; Size: longint; IVector: pointer);
procedure BlowfishReset(var Data: TBlowfishData);
procedure BlowfishBurn(var Data:  TBlowfishData);
procedure BlowfishEncryptECB(var Data: TBlowfishData; const InBlock; var OutBlock);
procedure BlowfishDecryptECB(var Data: TBlowfishData; const InBlock; var OutBlock);
procedure BlowfishEncryptCBC(var Data: TBlowfishData; const InData; var OutData; Size: longint);
procedure BlowfishDecryptCBC(var Data: TBlowfishData; const InData; var OutData; Size: longint);
procedure BlowfishEncryptCFB(var Data: TBlowfishData; const InData; var OutData; Size: longint);
procedure BlowfishDecryptCFB(var Data: TBlowfishData; const InData; var OutData; Size: longint);

procedure IDEAInit(var Data:TIDEAData;var Key;Size:longint;IVector:pointer);
procedure IDEAReset(var Data:TIDEAData);
procedure IDEABurn(var Data:TIDEAData);
procedure IDEAEncryptECB(var Data:TIDEAData;const InBlock;var OutBlock);
procedure IDEADecryptECB(var Data:TIDEAData;const InBlock;var OutBlock);
procedure IDEAEncryptCBC(var Data:TIDEAData;const InData;var OutData;Size:longint);
procedure IDEADecryptCBC(var Data:TIDEAData;const InData;var OutData;Size:longint);
procedure IDEAEncryptCFB(var Data:TIDEAData;const InData;var OutData;Size:longint);
procedure IDEADecryptCFB(var Data:TIDEAData;const InData;var OutData;Size:longint);

const
 BC=4;
 MAXROUNDS=14;
type
 TRijndaelData=record
  IV,LB:array[0..15] of byte;
  numrounds:longint;
  rk,drk:array[0..MAXROUNDS,0..7] of DWord;
 end;

procedure RijndaelInit(var Data:TRijndaelData;var Key;Size:longint;IVector:pointer);
procedure RijndaelReset(var Data:TRijndaelData);
procedure RijndaelBurn(var Data:TRijndaelData);
procedure RijndaelEncryptECB(var Data:TRijndaelData;const InBlock;var OutBlock);
procedure RijndaelDecryptECB(var Data:TRijndaelData;const InBlock;var OutBlock);
procedure RijndaelEncryptCBC(var Data:TRijndaelData;const InData;var OutData;Size:longint);
procedure RijndaelDecryptCBC(var Data:TRijndaelData;const InData;var OutData;Size:longint);
procedure RijndaelEncryptCFB(var Data:TRijndaelData;const InData;var OutData;Size:longint);
procedure RijndaelDecryptCFB(var Data:TRijndaelData;const InData;var OutData;Size:longint);

type
 TCast128Data= record
  IV, LB:array[0..7] of byte;
  KeyData:array[0..31] of DWord;
  Rounds:longint;
end;

procedure Cast128Init(var Data:TCast128Data;var Key;Size:longint;IVector:pointer);
procedure Cast128Reset(var Data:TCast128Data);
procedure Cast128Burn(var Data:TCast128Data);
procedure Cast128EncryptECB(var Data:TCast128Data;const InBlock;var OutBlock);
procedure Cast128DecryptECB(var Data:TCast128Data;const InBlock;var OutBlock);
procedure Cast128EncryptCBC(var Data:TCast128Data;const InData;var OutData;Size:longint);
procedure Cast128DecryptCBC(var Data:TCast128Data;const InData;var OutData;Size:longint);
procedure Cast128EncryptCFB(var Data:TCast128Data;const InData;var OutData;Size:longint);
procedure Cast128DecryptCFB(var Data:TCast128Data;const InData;var OutData;Size:longint);

type
 PTwofishData=^TTwofishData;
 PBlowfishData=^TBlowfishData;
 PIDEAData=^TIDEAData;
 PCast128Data=^TCast128Data;
 PRijndaelData=^TRijndaelData;

implementation

{** Startof: twofish **}

const
  p8x8: array[0..1,0..255] of byte=((
    $a9, $67, $b3, $e8, $04, $fd, $a3, $76,
    $9a, $92, $80, $78, $e4, $dd, $d1, $38,
    $0d, $c6, $35, $98, $18, $f7, $ec, $6c,
    $43, $75, $37, $26, $fa, $13, $94, $48,
    $f2, $d0, $8b, $30, $84, $54, $df, $23,
    $19, $5b, $3d, $59, $f3, $ae, $a2, $82,
    $63, $01, $83, $2e, $d9, $51, $9b, $7c,
    $a6, $eb, $a5, $be, $16, $0c, $e3, $61,
    $c0, $8c, $3a, $f5, $73, $2c, $25, $0b,
    $bb, $4e, $89, $6b, $53, $6a, $b4, $f1,
    $e1, $e6, $bd, $45, $e2, $f4, $b6, $66,
    $cc, $95, $03, $56, $d4, $1c, $1e, $d7,
    $fb, $c3, $8e, $b5, $e9, $cf, $bf, $ba,
    $ea, $77, $39, $af, $33, $c9, $62, $71,
    $81, $79, $09, $ad, $24, $cd, $f9, $d8,
    $e5, $c5, $b9, $4d, $44, $08, $86, $e7,
    $a1, $1d, $aa, $ed, $06, $70, $b2, $d2,
    $41, $7b, $a0, $11, $31, $c2, $27, $90,
    $20, $f6, $60, $ff, $96, $5c, $b1, $ab,
    $9e, $9c, $52, $1b, $5f, $93, $0a, $ef,
    $91, $85, $49, $ee, $2d, $4f, $8f, $3b,
    $47, $87, $6d, $46, $d6, $3e, $69, $64,
    $2a, $ce, $cb, $2f, $fc, $97, $05, $7a,
    $ac, $7f, $d5, $1a, $4b, $0e, $a7, $5a,
    $28, $14, $3f, $29, $88, $3c, $4c, $02,
    $b8, $da, $b0, $17, $55, $1f, $8a, $7d,
    $57, $c7, $8d, $74, $b7, $c4, $9f, $72,
    $7e, $15, $22, $12, $58, $07, $99, $34,
    $6e, $50, $de, $68, $65, $bc, $db, $f8,
    $c8, $a8, $2b, $40, $dc, $fe, $32, $a4,
    $ca, $10, $21, $f0, $d3, $5d, $0f, $00,
    $6f, $9d, $36, $42, $4a, $5e, $c1, $e0),(
    $75, $f3, $c6, $f4, $db, $7b, $fb, $c8,
    $4a, $d3, $e6, $6b, $45, $7d, $e8, $4b,
    $d6, $32, $d8, $fd, $37, $71, $f1, $e1,
    $30, $0f, $f8, $1b, $87, $fa, $06, $3f,
    $5e, $ba, $ae, $5b, $8a, $00, $bc, $9d,
    $6d, $c1, $b1, $0e, $80, $5d, $d2, $d5,
    $a0, $84, $07, $14, $b5, $90, $2c, $a3,
    $b2, $73, $4c, $54, $92, $74, $36, $51,
    $38, $b0, $bd, $5a, $fc, $60, $62, $96,
    $6c, $42, $f7, $10, $7c, $28, $27, $8c,
    $13, $95, $9c, $c7, $24, $46, $3b, $70,
    $ca, $e3, $85, $cb, $11, $d0, $93, $b8,
    $a6, $83, $20, $ff, $9f, $77, $c3, $cc,
    $03, $6f, $08, $bf, $40, $e7, $2b, $e2,
    $79, $0c, $aa, $82, $41, $3a, $ea, $b9,
    $e4, $9a, $a4, $97, $7e, $da, $7a, $17,
    $66, $94, $a1, $1d, $3d, $f0, $de, $b3,
    $0b, $72, $a7, $1c, $ef, $d1, $53, $3e,
    $8f, $33, $26, $5f, $ec, $76, $2a, $49,
    $81, $88, $ee, $21, $c4, $1a, $eb, $d9,
    $c5, $39, $99, $cd, $ad, $31, $8b, $01,
    $18, $23, $dd, $1f, $4e, $2d, $f9, $48,
    $4f, $f2, $65, $8e, $78, $5c, $58, $19,
    $8d, $e5, $98, $57, $67, $7f, $05, $64,
    $af, $63, $b6, $fe, $f5, $b7, $3c, $a5,
    $ce, $e9, $68, $44, $e0, $4d, $43, $69,
    $29, $2e, $ac, $15, $59, $a8, $0a, $9e,
    $6e, $47, $df, $34, $35, $6a, $cf, $dc,
    $22, $c9, $c0, $9b, $89, $d4, $ed, $ab,
    $12, $a2, $0d, $52, $bb, $02, $2f, $a9,
    $d7, $61, $1e, $b4, $50, $04, $f6, $c2,
    $16, $25, $86, $56, $55, $09, $be, $91));

var
  MDS:array[0..3,0..255] of DWord;

function LFSR1(x:DWord):DWord;
begin
  if (x and 1)<>0 then
    LFSR1:=(x shr 1) xor (MDS_GF_FDBK div 2)
  else
    LFSR1:=(x shr 1);
end;
function LFSR2(x:DWord):DWord;
begin
  if (x and 2)<>0 then
    if (x and 1)<>0 then
      LFSR2:=(x shr 2) xor (MDS_GF_FDBK div 2) xor (MDS_GF_FDBK div 4)
    else
      LFSR2:=(x shr 2) xor (MDS_GF_FDBK div 2)
  else
    if (x and 1)<>0 then
      LFSR2:=(x shr 2) xor (MDS_GF_FDBK div 4)
    else
      LFSR2:=(x shr 2);
end;
function Mul_X(x:DWord):DWord;
begin
  Mul_X:=x xor LFSR2(x);
end;
function Mul_Y(x:DWord):DWord;
begin
  Mul_Y:=x xor LFSR1(x) xor LFSR2(x);
end;

function RS_MDS_Encode(lK0,lK1:DWord):DWord;
var
  lR,nI,nJ,lG2,lG3:DWord;
  bB:byte;
begin
  lR:=0;
  for nI:=0 to 1 do
  begin
    if nI<>0  then
      lR:=lR xor lK0
    else
      lR:=lR xor lK1;
    for nJ:=0 to 3 do
    begin
      bB:=dw(lR).b4;
      if (bB and $80)<>0 then
        lG2:=((bB shl 1) xor RS_GF_FDBK) and $FF
      else
        lG2:=(bB shl 1) and $FF;
      if (bB and 1)<>0 then
        lG3:=((bB shr 1) and $7f) xor (RS_GF_FDBK shr 1) xor lG2
      else
        lG3:=((bB shr 1) and $7f) xor lG2;
      lR:=(lR shl 8) xor (lG3 shl 24) xor (lG2 shl 16) xor (lG3 shl 8) xor bB;
    end;
  end;
  RS_MDS_Encode:=lR;
end;

function f32(x:DWord;K32:PDWordArray;Len:DWord):DWord;
var
  t0,t1,t2,t3:DWord;
begin
  t0:=dw(x).b1;
  t1:=dw(x).b2;
  t2:=dw(x).b3;
  t3:=dw(x).b4;
  if Len=256 then
  begin
    t0:=p8x8[p_04,t0] xor (dw(K32^[3]).b1);
    t1:=p8x8[p_14,t1] xor (dw(K32^[3]).b2);
    t2:=p8x8[p_24,t2] xor (dw(K32^[3]).b3);
    t3:=p8x8[p_34,t3] xor (dw(K32^[3]).b4);
  end;
  if Len>=192 then
  begin
    t0:=p8x8[p_03,t0] xor (dw(K32^[2]).b1);
    t1:=p8x8[p_13,t1] xor (dw(K32^[2]).b2);
    t2:=p8x8[p_23,t2] xor (dw(K32^[2]).b3);
    t3:=p8x8[p_33,t3] xor (dw(K32^[2]).b4);
  end;
  f32:=MDS[0,p8x8[p_01,p8x8[p_02,t0] xor (dw(K32^[1]).b1)] xor (dw(K32^[0]).b1)] xor
       MDS[1,p8x8[p_11,p8x8[p_12,t1] xor (dw(K32^[1]).b2)] xor (dw(K32^[0]).b2)] xor
       MDS[2,p8x8[p_21,p8x8[p_22,t2] xor (dw(K32^[1]).b3)] xor (dw(K32^[0]).b3)] xor
       MDS[3,p8x8[p_31,p8x8[p_32,t3] xor (dw(K32^[1]).b4)] xor (dw(K32^[0]).b4)];
end;

procedure TwofishEncryptECB;
var
  i:longint;
  t0,t1:DWord;
  X:array[0..3] of DWord;
begin
 with Data do begin
  X[0]:=PDWord(@InBlock)^ xor SubKeys[INPUTWHITEN];
  X[1]:=PDWord(longint(@InBlock)+4)^ xor SubKeys[INPUTWHITEN+1];
  X[2]:=PDWord(longint(@InBlock)+8)^ xor SubKeys[INPUTWHITEN+2];
  X[3]:=PDWord(longint(@InBlock)+12)^ xor SubKeys[INPUTWHITEN+3];
  i:=0;
  while i<=NUMROUNDS-2 do
  begin
    t0:=sBox[0,2*dw(x[0]).b1] xor sBox[0,2*dw(x[0]).b2+1]
    xor sBox[2,2*dw(x[0]).b3] xor sBox[2,2*dw(x[0]).b4+1];
    t1:=sBox[0,2*dw(x[1]).b4] xor sBox[0,2*dw(x[1]).b1+1]
    xor sBox[2,2*dw(x[1]).b2] xor sBox[2,2*dw(x[1]).b3+1];
    x[3]:=LRot32(x[3],1);
    x[2]:=x[2] xor (t0+  t1+SubKeys[ROUNDSUBKEYS+2*i]);
    x[3]:=x[3] xor (t0+2*t1+SubKeys[ROUNDSUBKEYS+2*i+1]);
    x[2]:=RRot32(x[2],1);

    t0:=sBox[0,2*dw(x[2]).b1] xor sBox[0,2*dw(x[2]).b2+1]
    xor sBox[2,2*dw(x[2]).b3] xor sBox[2,2*dw(x[2]).b4+1];
    t1:=sBox[0,2*dw(x[3]).b4] xor sBox[0,2*dw(x[3]).b1+1]
    xor sBox[2,2*dw(x[3]).b2] xor sBox[2,2*dw(x[3]).b3+1];
    x[1]:=LRot32(x[1],1);
    x[0]:=x[0] xor (t0+  t1+SubKeys[ROUNDSUBKEYS+2*(i+1)]);
    x[1]:=x[1] xor (t0+2*t1+SubKeys[ROUNDSUBKEYS+2*(i+1)+1]);
    x[0]:=RRot32(x[0],1);
    Inc(i,2);
  end;
  PDWord(longint(@OutBlock)+ 0)^:=X[2] xor SubKeys[OUTPUTWHITEN];
  PDWord(longint(@OutBlock)+ 4)^:=X[3] xor SubKeys[OUTPUTWHITEN+1];
  PDWord(longint(@OutBlock)+ 8)^:=X[0] xor SubKeys[OUTPUTWHITEN+2];
  PDWord(longint(@OutBlock)+12)^:=X[1] xor SubKeys[OUTPUTWHITEN+3];
 end;
end;

procedure TwofishDecryptECB;
var
  i:longint;
  t0,t1:DWord;
  X:array[0..3] of DWord;
begin
 with Data do begin
  X[2]:=PDWord(@InBlock)^ xor SubKeys[OUTPUTWHITEN];
  X[3]:=PDWord(longint(@InBlock)+4)^ xor SubKeys[OUTPUTWHITEN+1];
  X[0]:=PDWord(longint(@InBlock)+8)^ xor SubKeys[OUTPUTWHITEN+2];
  X[1]:=PDWord(longint(@InBlock)+12)^ xor SubKeys[OUTPUTWHITEN+3];
  i:=NUMROUNDS-2;
  while i>=0 do
  begin
    t0:=sBox[0,2*dw(x[2]).b1] xor sBox[0,2*dw(x[2]).b2+1]
    xor sBox[2,2*dw(x[2]).b3] xor sBox[2,2*dw(x[2]).b4+1];
    t1:=sBox[0,2*dw(x[3]).b4] xor sBox[0,2*dw(x[3]).b1+1]
    xor sBox[2,2*dw(x[3]).b2] xor sBox[2,2*dw(x[3]).b3+1];
    x[0]:=LRot32(x[0],1);
    x[0]:=x[0] xor (t0+  t1+Subkeys[ROUNDSUBKEYS+2*(i+1)]);
    x[1]:=x[1] xor (t0+2*t1+Subkeys[ROUNDSUBKEYS+2*(i+1)+1]);
    x[1]:=RRot32(x[1],1);

    t0:=sBox[0,2*dw(x[0]).b1] xor sBox[0,2*dw(x[0]).b2+1]
    xor sBox[2,2*dw(x[0]).b3] xor sBox[2,2*dw(x[0]).b4+1];
    t1:=sBox[0,2*dw(x[1]).b4] xor sBox[0,2*dw(x[1]).b1+1]
    xor sBox[2,2*dw(x[1]).b2] xor sBox[2,2*dw(x[1]).b3+1];
    x[2]:=LRot32(x[2],1);
    x[2]:=x[2] xor (t0+  t1+Subkeys[ROUNDSUBKEYS+2*i]);
    x[3]:=x[3] xor (t0+2*t1+Subkeys[ROUNDSUBKEYS+2*i+1]);
    x[3]:=RRot32(x[3],1);
    Dec(i,2);
  end;
  PDWord(longint(@OutBlock)+ 0)^:=X[0] xor SubKeys[INPUTWHITEN];
  PDWord(longint(@OutBlock)+ 4)^:=X[1] xor SubKeys[INPUTWHITEN+1];
  PDWord(longint(@OutBlock)+ 8)^:=X[2] xor SubKeys[INPUTWHITEN+2];
  PDWord(longint(@OutBlock)+12)^:=X[3] xor SubKeys[INPUTWHITEN+3];
 end;
end;

procedure TwofishInit;
  procedure Xor256(Dst,Src:PDWordArray;v:byte);
  var
    i:DWord;
  begin
    for i:=0 to 63 do
      Dst^[i]:=Src^[i] xor (v*$01010101);
  end;
var
  key32:array[0..7] of DWord;
  k32e,k32o:array[0..3] of DWord;
  k64Cnt,i,j,A,B,q,subkeyCnt:DWord;
  L0,L1:array[0..255] of byte;
begin
 if not precomp then
 begin
  precomp:=false;
  PreCompMDS;
 end;
 if (Size>256) or (Size<=0) or ((Size and 7)<>0) then Exit;
 with Data do begin
  FillChar(Key32,Sizeof(Key32),0);
  Move(Key,Key32,Size div 8);
  if Size<=128 then           { pad the key to either 128bit,192bit or 256bit}
    Size:=128
  else if Size<=192 then
    Size:=192
  else
    Size:=256;
  subkeyCnt:=ROUNDSUBKEYS+2*NUMROUNDS;
  KeyLen:=Size;
  k64Cnt:=Size div 64;
  j:=k64Cnt-1;
  for i:=0 to j do
  begin
    k32e[i]:=key32[2*i];
    k32o[i]:=key32[2*i+1];
    sboxKeys[j]:=RS_MDS_Encode(k32e[i],k32o[i]);
    Dec(j);
  end;
  q:=0;
  for i:=0 to ((subkeyCnt div 2)-1) do
  begin
    A:=f32(q,@k32e,Size);
    B:=f32(q+SK_BUMP,@k32o,Size);
    B:=LRot32(B,8);
    SubKeys[2*i]:=A+B;
    B:=A+2*B;
    SubKeys[2*i+1]:=LRot32(B,SK_ROTL);
    Inc(q,SK_STEP);
  end;
  case Size of
    128:begin
           Xor256(@L0,@p8x8[p_02],dw(sboxKeys[1]).b1);
           A:=dw(sboxKeys[0]).b1;
           i:=0;
           while i< 256 do
           begin
             sBox[0 and 2,2*i+(0 and 1)]:=MDS[0,p8x8[p_01,L0[i]] xor A];
             sBox[0 and 2,2*i+(0 and 1)+2]:=MDS[0,p8x8[p_01,L0[i+1]] xor A];
             Inc(i,2);
           end;
           Xor256(@L0,@p8x8[p_12],dw(sboxKeys[1]).b2);
           A:=dw(sboxKeys[0]).b2;
           i:=0;
           while i< 256 do
           begin
             sBox[1 and 2,2*i+(1 and 1)]:=MDS[1,p8x8[p_11,L0[i]] xor A];
             sBox[1 and 2,2*i+(1 and 1)+2]:=MDS[1,p8x8[p_11,L0[i+1]] xor A];
             Inc(i,2);
           end;
           Xor256(@L0,@p8x8[p_22],dw(sboxKeys[1]).b3);
           A:=dw(sboxKeys[0]).b3;
           i:=0;
           while i< 256 do
           begin
             sBox[2 and 2,2*i+(2 and 1)]:=MDS[2,p8x8[p_21,L0[i]] xor A];
             sBox[2 and 2,2*i+(2 and 1)+2]:=MDS[2,p8x8[p_21,L0[i+1]] xor A];
             Inc(i,2);
           end;
           Xor256(@L0,@p8x8[p_32],dw(sboxKeys[1]).b4);
           A:=dw(sboxKeys[0]).b4;
           i:=0;
           while i< 256 do
           begin
             sBox[3 and 2,2*i+(3 and 1)]:=MDS[3,p8x8[p_31,L0[i]] xor A];
             sBox[3 and 2,2*i+(3 and 1)+2]:=MDS[3,p8x8[p_31,L0[i+1]] xor A];
             Inc(i,2);
           end;
         end;
    192:begin
           Xor256(@L0,@p8x8[p_03],dw(sboxKeys[2]).b1);
           A:=dw(sboxKeys[0]).b1;
           B:=dw(sboxKeys[1]).b1;
           i:=0;
           while i< 256 do
           begin
             sBox[0 and 2,2*i+(0 and 1)]:=MDS[0,p8x8[p_01,p8x8[p_02,L0[i]] xor B] xor A];
             sBox[0 and 2,2*i+(0 and 1)+2]:=MDS[0,p8x8[p_01,p8x8[p_02,L0[i+1]] xor B] xor A];
             Inc(i,2);
           end;
           Xor256(@L0,@p8x8[p_13],dw(sboxKeys[2]).b2);
           A:=dw(sboxKeys[0]).b2;
           B:=dw(sboxKeys[1]).b2;
           i:=0;
           while i< 256 do
           begin
             sBox[1 and 2,2*i+(1 and 1)]:=MDS[1,p8x8[p_11,p8x8[p_12,L0[i]] xor B] xor A];
             sBox[1 and 2,2*i+(1 and 1)+2]:=MDS[1,p8x8[p_11,p8x8[p_12,L0[i+1]] xor B] xor A];
             Inc(i,2);
           end;
           Xor256(@L0,@p8x8[p_23],dw(sboxKeys[2]).b3);
           A:=dw(sboxKeys[0]).b3;
           B:=dw(sboxKeys[1]).b3;
           i:=0;
           while i< 256 do
           begin
             sBox[2 and 2,2*i+(2 and 1)]:=MDS[2,p8x8[p_21,p8x8[p_22,L0[i]] xor B] xor A];
             sBox[2 and 2,2*i+(2 and 1)+2]:=MDS[2,p8x8[p_21,p8x8[p_22,L0[i+1]] xor B] xor A];
             Inc(i,2);
           end;
           Xor256(@L0,@p8x8[p_33],dw(sboxKeys[2]).b4);
           A:=dw(sboxKeys[0]).b4;
           B:=dw(sboxKeys[1]).b4;
           i:=0;
           while i< 256 do
           begin
             sBox[3 and 2,2*i+(3 and 1)]:=MDS[3,p8x8[p_31,p8x8[p_32,L0[i]] xor B] xor A];
             sBox[3 and 2,2*i+(3 and 1)+2]:=MDS[3,p8x8[p_31,p8x8[p_32,L0[i+1]] xor B] xor A];
             Inc(i,2);
           end;
         end;
    256:begin
           Xor256(@L1,@p8x8[p_04],dw(sboxKeys[3]).b1);
           i:=0;
           while i< 256 do
           begin
             L0[i  ]:=p8x8[p_03,L1[i]];
             L0[i+1]:=p8x8[p_03,L1[i+1]];
             Inc(i,2);
           end;
           Xor256(@L0,@L0,dw(sboxKeys[2]).b1);
           A:=dw(sboxKeys[0]).b1;
           B:=dw(sboxKeys[1]).b1;
           i:=0;
           while i< 256 do
           begin
             sBox[0 and 2,2*i+(0 and 1)]:=MDS[0,p8x8[p_01,p8x8[p_02,L0[i]] xor B] xor A];
             sBox[0 and 2,2*i+(0 and 1)+2]:=MDS[0,p8x8[p_01,p8x8[p_02,L0[i+1]] xor B] xor A];
             Inc(i,2);
           end;
           Xor256(@L1,@p8x8[p_14],dw(sboxKeys[3]).b2);
           i:=0;
           while i< 256 do
           begin
             L0[i  ]:=p8x8[p_13,L1[i]];
             L0[i+1]:=p8x8[p_13,L1[i+1]];
             Inc(i,2);
           end;
           Xor256(@L0,@L0,dw(sboxKeys[2]).b2);
           A:=dw(sboxKeys[0]).b2;
           B:=dw(sboxKeys[1]).b2;
           i:=0;
           while i< 256 do
           begin
             sBox[1 and 2,2*i+(1 and 1)]:=MDS[1,p8x8[p_11,p8x8[p_12,L0[i]] xor B] xor A];
             sBox[1 and 2,2*i+(1 and 1)+2]:=MDS[1,p8x8[p_11,p8x8[p_12,L0[i+1]] xor B] xor A];
             Inc(i,2);
           end;

           Xor256(@L1,@p8x8[p_24],dw(sboxKeys[3]).b3);
           i:=0;
           while i< 256 do
           begin
             L0[i  ]:=p8x8[p_23,L1[i]];
             L0[i+1]:=p8x8[p_23,L1[i+1]];
             Inc(i,2);
           end;
           Xor256(@L0,@L0,dw(sboxKeys[2]).b3);
           A:=dw(sboxKeys[0]).b3;
           B:=dw(sboxKeys[1]).b3;
           i:=0;
           while i< 256 do
           begin
             sBox[2 and 2,2*i+(2 and 1)]:=MDS[2,p8x8[p_21,p8x8[p_22,L0[i]] xor B] xor A];
             sBox[2 and 2,2*i+(2 and 1)+2]:=MDS[2,p8x8[p_21,p8x8[p_22,L0[i+1]] xor B] xor A];
             Inc(i,2);
           end;
           Xor256(@L1,@p8x8[p_34],dw(sboxKeys[3]).b4);
           i:=0;
           while i< 256 do
           begin
             L0[i  ]:=p8x8[p_33,L1[i]];
             L0[i+1]:=p8x8[p_33,L1[i+1]];
             Inc(i,2);
           end;
           Xor256(@L0,@L0,dw(sboxKeys[2]).b4);
           A:=dw(sboxKeys[0]).b4;
           B:=dw(sboxKeys[1]).b4;
           i:=0;
           while i< 256 do
           begin
             sBox[3 and 2,2*i+(3 and 1)]:=MDS[3,p8x8[p_31,p8x8[p_32,L0[i]] xor B] xor A];
             sBox[3 and 2,2*i+(3 and 1)+2]:=MDS[3,p8x8[p_31,p8x8[p_32,L0[i+1]] xor B] xor A];
             Inc(i,2);
           end;
         end;
  end;
  if IVector=nil then
  begin
    FillChar(IV,Sizeof(IV),$FF);
    TwofishEncryptECB(Data,IV,IV);
    Move(IV,LB,Sizeof(IV));
  end
  else
  begin
    Move(IVector^,IV,Sizeof(IV));
  {$ifdef encrypt_ivector}
    TwofishEncryptECB(Data,IV,IV);
  {$endif}
    Move(IV,LB,Sizeof(IV));
  end;
 end;
end;

procedure TwofishBurn;
begin
 with Data do begin
  FillChar(sBox,Sizeof(sBox),$FF);
  FillChar(sBoxKeys,Sizeof(sBoxKeys),$FF);
  FillChar(SubKeys,Sizeof(SubKeys),$FF);
  FillChar(IV,Sizeof(IV),$FF);
  FillChar(LB,Sizeof(LB),$FF);
 end;
end;

procedure TwofishReset;
begin
 with Data do
  Move(IV,LB,Sizeof(LB));
end;

procedure TwofishEncryptCBC;
var
  TB:array[0..15] of byte;
  i:longint;
begin
 with Data do begin
  for i:=1 to (Size div 16) do
  begin
    XorBlock(pointer(longint(@InData)+((i-1)*16)),@LB,@TB,Sizeof(TB));
    TwofishEncryptECB(Data,TB,TB);
    Move(TB,pointer(longint(@OutData)+((i-1)*16))^,Sizeof(TB));
    Move(TB,LB,Sizeof(TB));
  end;
  if (Size mod 16)<>0 then
  begin
    TwofishEncryptECB(Data,LB,TB);
    XorBlock(@TB,@pointer(longint(@InData)+Size-(Size mod 16))^,@pointer(longint(@OutData)+Size-(Size mod 16))^,Size mod 16);
  end;
  FillChar(TB,Sizeof(TB),$FF);
 end;
end;

procedure TwofishDecryptCBC;
var
  TB:array[0..15] of byte;
  i:longint;
begin
 with Data do begin
  for i:=1 to (Size div 16) do
  begin
    Move(pointer(longint(@InData)+((i-1)*16))^,TB,Sizeof(TB));
    TwofishDecryptECB(Data,pointer(longint(@InData)+((i-1)*16))^,pointer(longint(@OutData)+((i-1)*16))^);
    XorBlock(@LB,pointer(longint(@OutData)+((i-1)*16)),pointer(longint(@OutData)+((i-1)*16)),Sizeof(TB));
    Move(TB,LB,Sizeof(TB));
  end;
  if (Size mod 16)<>0 then
  begin
   TwofishEncryptECB(Data,LB,TB);
   XorBlock(@TB,@pointer(longint(@InData)+Size-(Size mod 16))^,@pointer(longint(@OutData)+Size-(Size mod 16))^,Size mod 16);
  end;
  FillChar(TB,Sizeof(TB),$FF);
 end;
end;

procedure TwofishEncryptCFB;
var
  i:longint;
  TB:array[0..15] of byte;
begin
 with Data do begin
  for i:=0 to Size-1 do
  begin
    TwofishEncryptECB(Data,LB,TB);
    PByteArray(@OutData)^[i]:=PByteArray(@InData)^[i] xor TB[0];
    Move(LB[1],LB[0],15);
    LB[15]:=PByteArray(@OutData)^[i];
  end;
 end;
end;

procedure TwofishDecryptCFB;
var
  i:longint;
  TB:array[0..15] of byte;
  b:byte;
begin
 with Data do begin
  for i:=0 to Size-1 do
  begin
   b:=PByteArray(@InData)^[i];
   TwofishEncryptECB(Data,LB,TB);
   PByteArray(@OutData)^[i]:=PByteArray(@InData)^[i] xor TB[0];
   Move(LB[1],LB[0],15);
   LB[15]:=b;
  end;
 end;
end;

procedure PreCompMDS;
var
  m1,mx,my:array[0..1] of DWord;
  nI:longint;
begin
  for nI:=0 to 255 do
  begin
    m1[0]:=p8x8[0,nI];
    mx[0]:=Mul_X(m1[0]);
    my[0]:=Mul_Y(m1[0]);
    m1[1]:=p8x8[1,nI];
    mx[1]:=Mul_X(m1[1]);
    my[1]:=Mul_Y(m1[1]);
    mds[0,nI]:=(m1[p_00]      ) or
               (mx[p_00] shl 8) or
               (my[p_00] shl 16)or
               (my[p_00] shl 24);
    mds[1,nI]:=(my[p_10]      ) or
               (my[p_10] shl 8) or
               (mx[p_10] shl 16)or
               (m1[p_10] shl 24);
    mds[2,nI]:=(mx[p_20]      ) or
               (my[p_20] shl 8) or
               (m1[p_20] shl 16)or
               (my[p_20] shl 24);
    mds[3,nI]:=(mx[p_30]      ) or
               (m1[p_30] shl 8) or
               (my[p_30] shl 16)or
               (mx[p_30] shl 24);
  end;
end;

{** Startof: blowfish **}
const
  PBoxOrg: array[0..17] of DWord=(
    $243f6a88, $85a308d3, $13198a2e, $03707344,
    $a4093822, $299f31d0, $082efa98, $ec4e6c89,
    $452821e6, $38d01377, $be5466cf, $34e90c6c,
    $c0ac29b7, $c97c50dd, $3f84d5b5, $b5470917,
    $9216d5d9, $8979fb1b);
  SBoxOrg: array[0..3,0..255] of DWord=((
    $d1310ba6, $98dfb5ac, $2ffd72db, $d01adfb7,
    $b8e1afed, $6a267e96, $ba7c9045, $f12c7f99,
    $24a19947, $b3916cf7, $0801f2e2, $858efc16,
    $636920d8, $71574e69, $a458fea3, $f4933d7e,
    $0d95748f, $728eb658, $718bcd58, $82154aee, 
    $7b54a41d, $c25a59b5, $9c30d539, $2af26013,
    $c5d1b023, $286085f0, $ca417918, $b8db38ef, 
    $8e79dcb0, $603a180e, $6c9e0e8b, $b01e8a3e,
    $d71577c1, $bd314b27, $78af2fda, $55605c60, 
    $e65525f3, $aa55ab94, $57489862, $63e81440,
    $55ca396a, $2aab10b6, $b4cc5c34, $1141e8ce, 
    $a15486af, $7c72e993, $b3ee1411, $636fbc2a,
    $2ba9c55d, $741831f6, $ce5c3e16, $9b87931e,
    $afd6ba33, $6c24cf5c, $7a325381, $28958677, 
    $3b8f4898, $6b4bb9af, $c4bfe81b, $66282193, 
    $61d809cc, $fb21a991, $487cac60, $5dec8032, 
    $ef845d5d, $e98575b1, $dc262302, $eb651b88, 
    $23893e81, $d396acc5, $0f6d6ff3, $83f44239,
    $2e0b4482, $a4842004, $69c8f04a, $9e1f9b5e,
    $21c66842, $f6e96c9a, $670c9c61, $abd388f0, 
    $6a51a0d2, $d8542f68, $960fa728, $ab5133a3, 
    $6eef0b6c, $137a3be4, $ba3bf050, $7efb2a98, 
    $a1f1651d, $39af0176, $66ca593e, $82430e88, 
    $8cee8619, $456f9fb4, $7d84a5c3, $3b8b5ebe,
    $e06f75d8, $85c12073, $401a449f, $56c16aa6, 
    $4ed3aa62, $363f7706, $1bfedf72, $429b023d, 
    $37d0d724, $d00a1248, $db0fead3, $49f1c09b, 
    $075372c9, $80991b7b, $25d479d8, $f6e8def7, 
    $e3fe501a, $b6794c3b, $976ce0bd, $04c006ba, 
    $c1a94fb6, $409f60c4, $5e5c9ec2, $196a2463,
    $68fb6faf, $3e6c53b5, $1339b2eb, $3b52ec6f, 
    $6dfc511f, $9b30952c, $cc814544, $af5ebd09, 
    $bee3d004, $de334afd, $660f2807, $192e4bb3,
    $c0cba857, $45c8740f, $d20b5f39, $b9d3fbdb, 
    $5579c0bd, $1a60320a, $d6a100c6, $402c7279, 
    $679f25fe, $fb1fa3cc, $8ea5e9f8, $db3222f8,
    $3c7516df, $fd616b15, $2f501ec8, $ad0552ab, 
    $323db5fa, $fd238760, $53317b48, $3e00df82, 
    $9e5c57bb, $ca6f8ca0, $1a87562e, $df1769db,
    $d542a8f6, $287effc3, $ac6732c6, $8c4f5573, 
    $695b27b0, $bbca58c8, $e1ffa35d, $b8f011a0, 
    $10fa3d98, $fd2183b8, $4afcb56c, $2dd1d35b,
    $9a53e479, $b6f84565, $d28e49bc, $4bfb9790, 
    $e1ddf2da, $a4cb7e33, $62fb1341, $cee4c6e8, 
    $ef20cada, $36774c01, $d07e9efe, $2bf11fb4, 
    $95dbda4d, $ae909198, $eaad8e71, $6b93d5a0, 
    $d08ed1d0, $afc725e0, $8e3c5b2f, $8e7594b7, 
    $8ff6e2fb, $f2122b64, $8888b812, $900df01c,
    $4fad5ea0, $688fc31c, $d1cff191, $b3a8c1ad, 
    $2f2f2218, $be0e1777, $ea752dfe, $8b021fa1, 
    $e5a0cc0f, $b56f74e8, $18acf3d6, $ce89e299, 
    $b4a84fe0, $fd13e0b7, $7cc43b81, $d2ada8d9, 
    $165fa266, $80957705, $93cc7314, $211a1477,
    $e6ad2065, $77b5fa86, $c75442f5, $fb9d35cf,
    $ebcdaf0c, $7b3e89a0, $d6411bd3, $ae1e7e49, 
    $00250e2d, $2071b35e, $226800bb, $57b8e0af,
    $2464369b, $f009b91e, $5563911d, $59dfa6aa, 
    $78c14389, $d95a537f, $207d5ba2, $02e5b9c5, 
    $83260376, $6295cfa9, $11c81968, $4e734a41,
    $b3472dca, $7b14a94a, $1b510052, $9a532915,
    $d60f573f, $bc9bc6e4, $2b60a476, $81e67400, 
    $08ba6fb5, $571be91f, $f296ec6b, $2a0dd915, 
    $b6636521, $e7b9f9b6, $ff34052e, $c5855664, 
    $53b02d5d, $a99f8fa1, $08ba4799, $6e85076a),( 
    $4b7a70e9, $b5b32944, $db75092e, $c4192623,
    $ad6ea6b0, $49a7df7d, $9cee60b8, $8fedb266,
    $ecaa8c71, $699a17ff, $5664526c, $c2b19ee1, 
    $193602a5, $75094c29, $a0591340, $e4183a3e, 
    $3f54989a, $5b429d65, $6b8fe4d6, $99f73fd6, 
    $a1d29c07, $efe830f5, $4d2d38e6, $f0255dc1, 
    $4cdd2086, $8470eb26, $6382e9c6, $021ecc5e, 
    $09686b3f, $3ebaefc9, $3c971814, $6b6a70a1,
    $687f3584, $52a0e286, $b79c5305, $aa500737,
    $3e07841c, $7fdeae5c, $8e7d44ec, $5716f2b8, 
    $b03ada37, $f0500c0d, $f01c1f04, $0200b3ff, 
    $ae0cf51a, $3cb574b2, $25837a58, $dc0921bd,
    $d19113f9, $7ca92ff6, $94324773, $22f54701, 
    $3ae5e581, $37c2dadc, $c8b57634, $9af3dda7,
    $a9446146, $0fd0030e, $ecc8c73e, $a4751e41,
    $e238cd99, $3bea0e2f, $3280bba1, $183eb331, 
    $4e548b38, $4f6db908, $6f420d03, $f60a04bf, 
    $2cb81290, $24977c79, $5679b072, $bcaf89af, 
    $de9a771f, $d9930810, $b38bae12, $dccf3f2e,
    $5512721f, $2e6b7124, $501adde6, $9f84cd87, 
    $7a584718, $7408da17, $bc9f9abc, $e94b7d8c, 
    $ec7aec3a, $db851dfa, $63094366, $c464c3d2, 
    $ef1c1847, $3215d908, $dd433b37, $24c2ba16, 
    $12a14d43, $2a65c451, $50940002, $133ae4dd,
    $71dff89e, $10314e55, $81ac77d6, $5f11199b, 
    $043556f1, $d7a3c76b, $3c11183b, $5924a509, 
    $f28fe6ed, $97f1fbfa, $9ebabf2c, $1e153c6e, 
    $86e34570, $eae96fb1, $860e5e0a, $5a3e2ab3, 
    $771fe71c, $4e3d06fa, $2965dcb9, $99e71d0f,
    $803e89d6, $5266c825, $2e4cc978, $9c10b36a, 
    $c6150eba, $94e2ea78, $a5fc3c53, $1e0a2df4, 
    $f2f74ea7, $361d2b3d, $1939260f, $19c27960,
    $5223a708, $f71312b6, $ebadfe6e, $eac31f66, 
    $e3bc4595, $a67bc883, $b17f37d1, $018cff28,
    $c332ddef, $be6c5aa5, $65582185, $68ab9802,
    $eecea50f, $db2f953b, $2aef7dad, $5b6e2f84, 
    $1521b628, $29076170, $ecdd4775, $619f1510, 
    $13cca830, $eb61bd96, $0334fe1e, $aa0363cf, 
    $b5735c90, $4c70a239, $d59e9e0b, $cbaade14,
    $eecc86bc, $60622ca7, $9cab5cab, $b2f3846e, 
    $648b1eaf, $19bdf0ca, $a02369b9, $655abb50, 
    $40685a32, $3c2ab4b3, $319ee9d5, $c021b8f7, 
    $9b540b19, $875fa099, $95f7997e, $623d7da8, 
    $f837889a, $97e32d77, $11ed935f, $16681281,
    $0e358829, $c7e61fd6, $96dedfa1, $7858ba99, 
    $57f584a5, $1b227263, $9b83c3ff, $1ac24696, 
    $cdb30aeb, $532e3054, $8fd948e4, $6dbc3128,
    $58ebf2ef, $34c6ffea, $fe28ed61, $ee7c3c73, 
    $5d4a14d9, $e864b7e3, $42105d14, $203e13e0,
    $45eee2b6, $a3aaabea, $db6c4f15, $facb4fd0, 
    $c742f442, $ef6abbb5, $654f3b1d, $41cd2105, 
    $d81e799e, $86854dc7, $e44b476a, $3d816250,
    $cf62a1f2, $5b8d2646, $fc8883a0, $c1c7b6a3, 
    $7f1524c3, $69cb7492, $47848a0b, $5692b285,
    $095bbf00, $ad19489d, $1462b174, $23820e00,
    $58428d2a, $0c55f5ea, $1dadf43e, $233f7061, 
    $3372f092, $8d937e41, $d65fecf1, $6c223bdb, 
    $7cde3759, $cbee7460, $4085f2a7, $ce77326e, 
    $a6078084, $19f8509e, $e8efd855, $61d99735,
    $a969a7aa, $c50c06c2, $5a04abfc, $800bcadc, 
    $9e447a2e, $c3453484, $fdd56705, $0e1e9ec9, 
    $db73dbd3, $105588cd, $675fda79, $e3674340, 
    $c5c43465, $713e38d8, $3d28f89e, $f16dff20, 
    $153e21e7, $8fb03d4a, $e6e39f2b, $db83adf7),(
    $e93d5a68, $948140f7, $f64c261c, $94692934,
    $411520f7, $7602d4f7, $bcf46b2e, $d4a20068, 
    $d4082471, $3320f46a, $43b7d4b7, $500061af, 
    $1e39f62e, $97244546, $14214f74, $bf8b8840, 
    $4d95fc1d, $96b591af, $70f4ddd3, $66a02f45,
    $bfbc09ec, $03bd9785, $7fac6dd0, $31cb8504,
    $96eb27b3, $55fd3941, $da2547e6, $abca0a9a, 
    $28507825, $530429f4, $0a2c86da, $e9b66dfb,
    $68dc1462, $d7486900, $680ec0a4, $27a18dee, 
    $4f3ffea2, $e887ad8c, $b58ce006, $7af4d6b6,
    $aace1e7c, $d3375fec, $ce78a399, $406b2a42,
    $20fe9e35, $d9f385b9, $ee39d7ab, $3b124e8b, 
    $1dc9faf7, $4b6d1856, $26a36631, $eae397b2, 
    $3a6efa74, $dd5b4332, $6841e7f7, $ca7820fb, 
    $fb0af54e, $d8feb397, $454056ac, $ba489527,
    $55533a3a, $20838d87, $fe6ba9b7, $d096954b, 
    $55a867bc, $a1159a58, $cca92963, $99e1db33, 
    $a62a4a56, $3f3125f9, $5ef47e1c, $9029317c, 
    $fdf8e802, $04272f70, $80bb155c, $05282ce3, 
    $95c11548, $e4c66d22, $48c1133f, $c70f86dc,
    $07f9c9ee, $41041f0f, $404779a4, $5d886e17,
    $325f51eb, $d59bc0d1, $f2bcc18f, $41113564,
    $257b7834, $602a9c60, $dff8e8a3, $1f636c1b, 
    $0e12b4c2, $02e1329e, $af664fd1, $cad18115, 
    $6b2395e0, $333e92e1, $3b240b62, $eebeb922,
    $85b2a20e, $e6ba0d99, $de720c8c, $2da2f728, 
    $d0127845, $95b794fd, $647d0862, $e7ccf5f0, 
    $5449a36f, $877d48fa, $c39dfd27, $f33e8d1e,
    $0a476341, $992eff74, $3a6f6eab, $f4f8fd37,
    $a812dc60, $a1ebddf8, $991be14c, $db6e6b0d,
    $c67b5510, $6d672c37, $2765d43b, $dcd0e804,
    $f1290dc7, $cc00ffa3, $b5390f92, $690fed0b, 
    $667b9ffb, $cedb7d9c, $a091cf0b, $d9155ea3, 
    $bb132f88, $515bad24, $7b9479bf, $763bd6eb, 
    $37392eb3, $cc115979, $8026e297, $f42e312d,
    $6842ada7, $c66a2b3b, $12754ccc, $782ef11c,
    $6a124237, $b79251e7, $06a1bbe6, $4bfb6350, 
    $1a6b1018, $11caedfa, $3d25bdd8, $e2e1c3c9, 
    $44421659, $0a121386, $d90cec6e, $d5abea2a, 
    $64af674e, $da86a85f, $bebfe988, $64e4c3fe,
    $9dbc8057, $f0f7c086, $60787bf8, $6003604d, 
    $d1fd8346, $f6381fb0, $7745ae04, $d736fccc,
    $83426b33, $f01eab71, $b0804187, $3c005e5f, 
    $77a057be, $bde8ae24, $55464299, $bf582e61, 
    $4e58f48f, $f2ddfda2, $f474ef38, $8789bdc2,
    $5366f9c3, $c8b38e74, $b475f255, $46fcd9b9, 
    $7aeb2661, $8b1ddf84, $846a0e79, $915f95e2, 
    $466e598e, $20b45770, $8cd55591, $c902de4c,
    $b90bace1, $bb8205d0, $11a86248, $7574a99e, 
    $b77f19b6, $e0a9dc09, $662d09a1, $c4324633,
    $e85a1f02, $09f0be8c, $4a99a025, $1d6efe10,
    $1ab93d1d, $0ba5a4df, $a186f20f, $2868f169,
    $dcb7da83, $573906fe, $a1e2ce9b, $4fcd7f52, 
    $50115e01, $a70683fa, $a002b5c4, $0de6d027, 
    $9af88c27, $773f8641, $c3604c06, $61a806b5,
    $f0177a28, $c0f586e0, $006058aa, $30dc7d62, 
    $11e69ed7, $2338ea63, $53c2dd94, $c2c21634, 
    $bbcbee56, $90bcb6de, $ebfc7da1, $ce591d76, 
    $6f05e409, $4b7c0188, $39720a3d, $7c927c24,
    $86e3725f, $724d9db9, $1ac15bb4, $d39eb8fc,
    $ed545578, $08fca5b5, $d83d7cd3, $4dad0fc4, 
    $1e50ef5e, $b161e6f8, $a28514d9, $6c51133c,
    $6fd5c7e7, $56e14ec4, $362abfce, $ddc6c837,
    $d79a3234, $92638212, $670efa8e, $406000e0),( 
    $3a39ce37, $d3faf5cf, $abc27737, $5ac52d1b,
    $5cb0679e, $4fa33742, $d3822740, $99bc9bbe, 
    $d5118e9d, $bf0f7315, $d62d1c7e, $c700c47b,
    $b78c1b6b, $21a19045, $b26eb1be, $6a366eb4,
    $5748ab2f, $bc946e79, $c6a376d2, $6549c2c8, 
    $530ff8ee, $468dde7d, $d5730a1d, $4cd04dc6,
    $2939bbdb, $a9ba4650, $ac9526e8, $be5ee304,
    $a1fad5f0, $6a2d519a, $63ef8ce2, $9a86ee22, 
    $c089c2b8, $43242ef6, $a51e03aa, $9cf2d0a4, 
    $83c061ba, $9be96a4d, $8fe51550, $ba645bd6, 
    $2826a2f9, $a73a3ae1, $4ba99586, $ef5562e9,
    $c72fefd3, $f752f7da, $3f046f69, $77fa0a59, 
    $80e4a915, $87b08601, $9b09e6ad, $3b3ee593, 
    $e990fd5a, $9e34d797, $2cf0b7d9, $022b8b51, 
    $96d5ac3a, $017da67d, $d1cf3ed6, $7c7d2d28, 
    $1f9f25cf, $adf2b89b, $5ad6b472, $5a88f54c,
    $e029ac71, $e019a5e6, $47b0acfd, $ed93fa9b, 
    $e8d3c48d, $283b57cc, $f8d56629, $79132e28,
    $785f0191, $ed756055, $f7960e44, $e3d35e8c, 
    $15056dd4, $88f46dba, $03a16125, $0564f0bd, 
    $c3eb9e15, $3c9057a2, $97271aec, $a93a072a,
    $1b3f6d9b, $1e6321f5, $f59c66fb, $26dcf319, 
    $7533d928, $b155fdf5, $03563482, $8aba3cbb,
    $28517711, $c20ad9f8, $abcc5167, $ccad925f,
    $4de81751, $3830dc8e, $379d5862, $9320f991, 
    $ea7a90c2, $fb3e7bce, $5121ce64, $774fbe32,
    $a8b6e37e, $c3293d46, $48de5369, $6413e680,
    $a2ae0810, $dd6db224, $69852dfd, $09072166, 
    $b39a460a, $6445c0dd, $586cdecf, $1c20c8ae, 
    $5bbef7dd, $1b588d40, $ccd2017f, $6bb4e3bb, 
    $dda26a7e, $3a59ff45, $3e350a44, $bcb4cdd5,
    $72eacea8, $fa6484bb, $8d6612ae, $bf3c6f47, 
    $d29be463, $542f5d9e, $aec2771b, $f64e6370, 
    $740e0d8d, $e75b1357, $f8721671, $af537d5d,
    $4040cb08, $4eb4e2cc, $34d2466a, $0115af84, 
    $e1b00428, $95983a1d, $06b89fb4, $ce6ea048,
    $6f3f3b82, $3520ab82, $011a1d4b, $277227f8, 
    $611560b1, $e7933fdc, $bb3a792b, $344525bd, 
    $a08839e1, $51ce794b, $2f32c9b7, $a01fbac9, 
    $e01cc87e, $bcc7d1f6, $cf0111c3, $a1e8aac7, 
    $1a908749, $d44fbd9a, $d0dadecb, $d50ada38,
    $0339c32a, $c6913667, $8df9317c, $e0b12b4f, 
    $f79e59b7, $43f5bb3a, $f2d519ff, $27d9459c,
    $bf97222c, $15e6fc2a, $0f91fc71, $9b941525,
    $fae59361, $ceb69ceb, $c2a86459, $12baa8d1, 
    $b6c1075e, $e3056a0c, $10d25065, $cb03a442,
    $e0ec6e0e, $1698db3b, $4c98a0be, $3278e964,
    $9f1f9532, $e0d392df, $d3a0342b, $8971f21e, 
    $1b0a7441, $4ba3348c, $c5be7120, $c37632d8, 
    $df359f8d, $9b992f2e, $e60b6f47, $0fe3f11d, 
    $e54cda54, $1edad891, $ce6279cf, $cd3e7e6f,
    $1618b166, $fd2c1d05, $848fd2c5, $f6fb2299, 
    $f523f357, $a6327623, $93a83531, $56cccd02, 
    $acf08162, $5a75ebb5, $6e163697, $88d273cc, 
    $de966292, $81b949d0, $4c50901b, $71c65614, 
    $e6c6c7bd, $327a140a, $45e1d006, $c3f27b9a,
    $c9aa53fd, $62a80f00, $bb25bfe2, $35bdd2f6,
    $71126905, $b2040222, $b6cbcf7c, $cd769c2b, 
    $53113ec0, $1640e3d3, $38abbd60, $2547adf0, 
    $ba38209c, $f746ce76, $77afa1c5, $20756060, 
    $85cbfe4e, $8ae88dd8, $7aaaf9b0, $4cf9aa7e,
    $1948c25c, $02fb8a8c, $01c36ae4, $d6ebe1f9, 
    $90d4f869, $a65cdea0, $3f09252d, $c208e69f,
    $b74e6132, $ce77e25b, $578fdfe3, $3ac372e6));

procedure BlowfishEncryptECB;
var
  xL, xR: DWord;
begin
 with Data do begin
  Move(InBlock,xL,4);
  Move(pointer(longint(@InBlock)+4)^,xR,4);
  xL:=bswap(xL);
  xR:=bswap(xR);
  xL:=xL xor PBox[0];
  xR:=xR xor (((SBox[0,dw(xL).b4]+SBox[1,dw(xL).b3]) xor
    SBox[2,dw(xL).b2])+SBox[3,dw(xL).b1]) xor PBox[1];
  xL:=xL xor (((SBox[0,dw(xR).b4]+SBox[1,dw(xR).b3]) xor
    SBox[2,dw(xR).b2])+SBox[3,dw(xR).b1]) xor PBox[2];
  xR:=xR xor (((SBox[0,dw(xL).b4]+SBox[1,dw(xL).b3]) xor
    SBox[2,dw(xL).b2])+SBox[3,dw(xL).b1]) xor PBox[3];
  xL:=xL xor (((SBox[0,dw(xR).b4]+SBox[1,dw(xR).b3]) xor
    SBox[2,dw(xR).b2])+SBox[3,dw(xR).b1]) xor PBox[4];
  xR:=xR xor (((SBox[0,dw(xL).b4]+SBox[1,dw(xL).b3]) xor
    SBox[2,dw(xL).b2])+SBox[3,dw(xL).b1]) xor PBox[5];
  xL:=xL xor (((SBox[0,dw(xR).b4]+SBox[1,dw(xR).b3]) xor
    SBox[2,dw(xR).b2])+SBox[3,dw(xR).b1]) xor PBox[6];
  xR:=xR xor (((SBox[0,dw(xL).b4]+SBox[1,dw(xL).b3]) xor
    SBox[2,dw(xL).b2])+SBox[3,dw(xL).b1]) xor PBox[7];
  xL:=xL xor (((SBox[0,dw(xR).b4]+SBox[1,dw(xR).b3]) xor
    SBox[2,dw(xR).b2])+SBox[3,dw(xR).b1]) xor PBox[8];
  xR:=xR xor (((SBox[0,dw(xL).b4]+SBox[1,dw(xL).b3]) xor
    SBox[2,dw(xL).b2])+SBox[3,dw(xL).b1]) xor PBox[9];
  xL:=xL xor (((SBox[0,dw(xR).b4]+SBox[1,dw(xR).b3]) xor
    SBox[2,dw(xR).b2])+SBox[3,dw(xR).b1]) xor PBox[10];
  xR:=xR xor (((SBox[0,dw(xL).b4]+SBox[1,dw(xL).b3]) xor
    SBox[2,dw(xL).b2])+SBox[3,dw(xL).b1]) xor PBox[11];
  xL:=xL xor (((SBox[0,dw(xR).b4]+SBox[1,dw(xR).b3]) xor
    SBox[2,dw(xR).b2])+SBox[3,dw(xR).b1]) xor PBox[12];
  xR:=xR xor (((SBox[0,dw(xL).b4]+SBox[1,dw(xL).b3]) xor
    SBox[2,dw(xL).b2])+SBox[3,dw(xL).b1]) xor PBox[13];
  xL:=xL xor (((SBox[0,dw(xR).b4]+SBox[1,dw(xR).b3]) xor
    SBox[2,dw(xR).b2])+SBox[3,dw(xR).b1]) xor PBox[14];
  xR:=xR xor (((SBox[0,dw(xL).b4]+SBox[1,dw(xL).b3]) xor
    SBox[2,dw(xL).b2])+SBox[3,dw(xL).b1]) xor PBox[15];
  xL:=xL xor (((SBox[0,dw(xR).b4]+SBox[1,dw(xR).b3]) xor
    SBox[2,dw(xR).b2])+SBox[3,dw(xR).b1]) xor PBox[16];
  xR:=xR xor PBox[17];
  xL:=bswap(xL);
  xR:=bswap(xR);
  Move(xR,OutBlock,4);
  Move(xL,pointer(longint(@OutBlock)+4)^,4);
 end;
end;

procedure BlowfishDecryptECB;
var
  xL, xR: DWord;
begin
 with Data do begin
  Move(InBlock,xL,4);
  Move(pointer(longint(@InBlock)+4)^,xR,4);
  xL:=bswap(xL);
  xR:=bswap(xR);
  xL:=xL xor PBox[17];
  xR:=xR xor (((SBox[0,dw(xL).b4]+SBox[1,dw(xL).b3]) xor
    SBox[2,dw(xL).b2])+SBox[3,dw(xL).b1]) xor PBox[16];
  xL:=xL xor (((SBox[0,dw(xR).b4]+SBox[1,dw(xR).b3]) xor
    SBox[2,dw(xR).b2])+SBox[3,dw(xR).b1]) xor PBox[15];
  xR:=xR xor (((SBox[0,dw(xL).b4]+SBox[1,dw(xL).b3]) xor
    SBox[2,dw(xL).b2])+SBox[3,dw(xL).b1]) xor PBox[14];
  xL:=xL xor (((SBox[0,dw(xR).b4]+SBox[1,dw(xR).b3]) xor
    SBox[2,dw(xR).b2])+SBox[3,dw(xR).b1]) xor PBox[13];
  xR:=xR xor (((SBox[0,dw(xL).b4]+SBox[1,dw(xL).b3]) xor
    SBox[2,dw(xL).b2])+SBox[3,dw(xL).b1]) xor PBox[12];
  xL:=xL xor (((SBox[0,dw(xR).b4]+SBox[1,dw(xR).b3]) xor
    SBox[2,dw(xR).b2])+SBox[3,dw(xR).b1]) xor PBox[11];
  xR:=xR xor (((SBox[0,dw(xL).b4]+SBox[1,dw(xL).b3]) xor
    SBox[2,dw(xL).b2])+SBox[3,dw(xL).b1]) xor PBox[10];
  xL:=xL xor (((SBox[0,dw(xR).b4]+SBox[1,dw(xR).b3]) xor
    SBox[2,dw(xR).b2])+SBox[3,dw(xR).b1]) xor PBox[9];
  xR:=xR xor (((SBox[0,dw(xL).b4]+SBox[1,dw(xL).b3]) xor
    SBox[2,dw(xL).b2])+SBox[3,dw(xL).b1]) xor PBox[8];
  xL:=xL xor (((SBox[0,dw(xR).b4]+SBox[1,dw(xR).b3]) xor
    SBox[2,dw(xR).b2])+SBox[3,dw(xR).b1]) xor PBox[7];
  xR:=xR xor (((SBox[0,dw(xL).b4]+SBox[1,dw(xL).b3]) xor
    SBox[2,dw(xL).b2])+SBox[3,dw(xL).b1]) xor PBox[6];
  xL:=xL xor (((SBox[0,dw(xR).b4]+SBox[1,dw(xR).b3]) xor
    SBox[2,dw(xR).b2])+SBox[3,dw(xR).b1]) xor PBox[5];
  xR:=xR xor (((SBox[0,dw(xL).b4]+SBox[1,dw(xL).b3]) xor
    SBox[2,dw(xL).b2])+SBox[3,dw(xL).b1]) xor PBox[4];
  xL:=xL xor (((SBox[0,dw(xR).b4]+SBox[1,dw(xR).b3]) xor
    SBox[2,dw(xR).b2])+SBox[3,dw(xR).b1]) xor PBox[3];
  xR:=xR xor (((SBox[0,dw(xL).b4]+SBox[1,dw(xL).b3]) xor
    SBox[2,dw(xL).b2])+SBox[3,dw(xL).b1]) xor PBox[2];
  xL:=xL xor (((SBox[0,dw(xR).b4]+SBox[1,dw(xR).b3]) xor
    SBox[2,dw(xR).b2])+SBox[3,dw(xR).b1]) xor PBox[1];
  xR:=xR xor PBox[0];
  xL:=bswap(xL);
  xR:=bswap(xR);
  Move(xR,OutBlock,4);
  Move(xL,pointer(longint(@OutBlock)+4)^,4);
 end;
end;

procedure BlowfishInit;
var
  i, k: longint;
  A: DWord;
  KeyB: PByteArray;
  Block: array[0..7] of byte;
begin
 if (Size>448) or (Size<=0) or ((Size mod 8)<>0) then Exit;
 with Data do begin
  Size:=Size div 8;
  KeyB:=@Key;
  Move(SBoxOrg,SBox,Sizeof(SBox));
  Move(PBoxOrg,PBox,Sizeof(PBox));
  k:=0;
  for i:=0 to 17 do
  begin
   A:=dword(KeyB^[(k+3) mod Size]);
   A:=A+(dword(KeyB^[(k+2) mod Size]) shl 8);
   A:=A+(dword(KeyB^[(k+1) mod Size]) shl 16);
   A:=A+(dword(KeyB^[k]) shl 24);
   PBox[i]:=PBox[i] xor A;
   k:=(k+4) mod Size;
  end;
  FillChar(Block,Sizeof(Block),0);
  for i:=0 to 8 do
  begin
   BlowfishEncryptECB(Data,Block,Block);
   PBox[i*2]:=dword(Block[3])+(dword(Block[2]) shl 8)+(dword(Block[1]) shl 16)+(dword(Block[0]) shl 24);
   PBox[i*2+1]:=dword(Block[7])+(dword(Block[6]) shl 8)+(dword(Block[5]) shl 16)+(dword(Block[4]) shl 24);
  end;
  for k:=0 to 3 do
  begin
   for i:=0 to 127 do
   begin
    BlowfishEncryptECB(Data,Block,Block);
    SBox[k,i*2]:=dword(Block[3])+(dword(Block[2]) shl 8)+(dword(Block[1]) shl 16)+(dword(Block[0]) shl 24);
    SBox[k,i*2+1]:=dword(Block[7])+(dword(Block[6]) shl 8)+(dword(Block[5]) shl 16)+(dword(Block[4]) shl 24);
   end;
  end;

  if IVector=nil then
  begin
    FillChar(IV,Sizeof(IV),$FF);
    BlowfishEncryptECB(Data,IV,IV);
    Move(IV,LB,Sizeof(LB));
  end
  else
  begin
    Move(IVector^,IV,Sizeof(IV));
  {$ifdef encrypt_ivector}
    BlowfishEncryptECB(Data,IV,IV);
  {$endif}
    Move(IV,LB,Sizeof(IV));
  end;
 end;
end;

procedure BlowfishBurn;
begin
 with Data do begin
  FillChar(SBox,Sizeof(SBox),$FF);
  FillChar(PBox,Sizeof(PBox),$FF);
  FillChar(IV,Sizeof(IV),$FF);
  FillChar(LB,Sizeof(LB),$FF);
 end;
end;

procedure BlowfishReset;
begin
  with Data do Move(IV,LB,Sizeof(LB));
end;

procedure BlowfishEncryptCBC;
var
  TB: array[0..7] of byte;
  i: longint;
begin
 with Data do begin
  for i:=1 to (Size div 8) do
  begin
    XorBlock(pointer(longint(@InData)+((i-1)*8)),@LB,@TB,Sizeof(TB));
    BlowfishEncryptECB(Data,TB,TB);
    Move(TB,pointer(longint(@OutData)+((i-1)*8))^,Sizeof(TB));
    Move(TB,LB,Sizeof(TB));
  end;
  if (Size mod 8)<>0 then
  begin
    BlowfishEncryptECB(Data,LB,TB);
    XorBlock(@TB,@pointer(longint(@InData)+Size-(Size mod 8))^,@pointer(longint(@OutData)+Size-(Size mod 8))^,Size mod 8);
  end;
  FillChar(TB,Sizeof(TB),$FF);
 end;
end;

procedure BlowfishDecryptCBC;
var
  TB: array[0..7] of byte;
  i: longint;
begin
 with Data do begin
  for i:=1 to (Size div 8) do
  begin
    Move(pointer(longint(@InData)+((i-1)*8))^,TB,Sizeof(TB));
    BlowfishDecryptECB(Data,pointer(longint(@InData)+((i-1)*8))^,pointer(longint(@OutData)+((i-1)*8))^);
    XorBlock(@LB,pointer(longint(@OutData)+((i-1)*8)),pointer(longint(@OutData)+((i-1)*8)),Sizeof(TB));
    Move(TB,LB,Sizeof(TB));
  end;
  if (Size mod 8)<>0 then
  begin
    BlowfishEncryptECB(Data,LB,TB);
    XorBlock(@TB,@pointer(longint(@InData)+Size-(Size mod 8))^,@pointer(longint(@OutData)+Size-(Size mod 8))^,Size mod 8);
  end;
  FillChar(TB,Sizeof(TB),$FF);
 end;
end;

procedure BlowfishEncryptCFB;
var
  i: longint;
  TB: array[0..7] of byte;
begin
 with Data do begin
  for i:=0 to Size-1 do
  begin
    BlowfishEncryptECB(Data,LB,TB);
    PByteArray(@OutData)^[i]:=PByteArray(@InData)^[i] xor TB[0];
    Move(LB[1],LB[0],7);
    LB[7]:=PByteArray(@OutData)^[i];
  end;
 end;
end;

procedure BlowfishDecryptCFB;
var
  i: longint;
  TB: array[0..7] of byte;
  b: byte;
begin
 with Data do begin
  for i:=0 to Size-1 do
  begin
    b:=PByteArray(@InData)^[i];
    BlowfishEncryptECB(Data,LB,TB);
    PByteArray(@OutData)^[i]:=PByteArray(@InData)^[i] xor TB[0];
    Move(LB[1],LB[0],7);
    LB[7]:=b;
  end;
 end;
end;

{** Startof: IDEA **}

procedure Mul(var x:word;y:word);
var
  p:DWord;
  t16:word;
begin
  p:=DWord(x)*y;
  if p=0 then x:=1-x-y
  else begin
  {$ifdef win32}
   x:=p shr 16;
   t16:=p and $FFFF;
  {$else}
   x:=dw(p).w2;
   t16:=dw(p).w1;
  {$endif}
   x:=t16-x;
   if (t16<x) then Inc(x);
  end;
end;

function MulInv(x:word):word;
var
 t0,t1,q,y:word;
begin
 if x<=1 then begin
  MulInv:=x;
  Exit;
 end;
 t1:=DWord($10001) div x;
 y:=DWord($10001) mod x;
 if y=1 then begin
  {$ifdef win32}
  MulInv:=(1-t1) and $FFFF;
  {$else}
  MulInv:=(1-t1);
  {$endif}
  Exit;
 end;
 t0:=1;
 repeat
  q:=x div y;
  x:=x mod y;
  t0:=t0+(q*t1);
  if x=1 then begin
   MulInv:=t0;
   Exit;
  end;
  q:=y div x;
  y:=y mod x;
  t1:=t1+(q*t0);
 until y=1;
 {$ifdef win32}
 MulInv:=(1-t1) and $FFFF;
 {$else}
 MulInv:=(1-t1);
 {$endif}
end;

procedure IDEAEncryptECB;
var
 x:array[1..4] of word;
 s3,s2:word;
 i:longint;
begin
 with Data do begin
  Move(InBlock,x,Sizeof(x));
  for i:=1 to 4 do x[i]:=(x[i] shl 8) or (x[i] shr 8);
  for i:=0 to 7 do begin
   Mul(x[1],EK[(i*6)+0]);
   Inc(x[2],EK[(i*6)+1]);
   Inc(x[3],EK[(i*6)+2]);
   Mul(x[4],EK[(i*6)+3]);
   s3:=x[3];
   x[3]:=x[3] xor x[1];
   Mul(x[3],EK[(i*6)+4]);
   s2:=x[2];
   x[2]:=x[2] xor x[4];
   Inc(x[2],x[3]);
   Mul(x[2],EK[(i*6)+5]);
   Inc(x[3],x[2]);
   x[1]:=x[1] xor x[2];
   x[4]:=x[4] xor x[3];
   x[2]:=x[2] xor s3;
   x[3]:=x[3] xor s2;
  end;
  Mul(x[1],EK[48]);
  Inc(x[3],EK[49]);
  Inc(x[2],EK[50]);
  Mul(x[4],EK[51]);
  x[1]:=(x[1] shl 8) or (x[1] shr 8);
  s2:=(x[3] shl 8) or (x[3] shr 8);
  x[3]:=(x[2] shl 8) or (x[2] shr 8);
  x[4]:=(x[4] shl 8) or (x[4] shr 8);
  x[2]:=s2;
  Move(x,OutBlock,Sizeof(x));
 end;
end;

procedure IDEADecryptECB;
var
 x:array[1..4] of word;
 s3,s2:word;
 i:longint;
begin
 with Data do begin
  Move(InBlock,x,Sizeof(x));
  for i:=1 to 4 do x[i]:=(x[i] shl 8) or (x[i] shr 8);
  for i:=0 to 7 do begin
   Mul(x[1],DK[(i*6)+0]);
   Inc(x[2],DK[(i*6)+1]);
   Inc(x[3],DK[(i*6)+2]);
   Mul(x[4],DK[(i*6)+3]);
   s3:=x[3];
   x[3]:=x[3] xor x[1];
   Mul(x[3],DK[(i*6)+4]);
   s2:=x[2];
   x[2]:=x[2] xor x[4];
   Inc(x[2],x[3]);
   Mul(x[2],DK[(i*6)+5]);
   Inc(x[3],x[2]);
   x[1]:=x[1] xor x[2];
   x[4]:=x[4] xor x[3];
   x[2]:=x[2] xor s3;
   x[3]:=x[3] xor s2;
  end;
  Mul(x[1],DK[48]);
  Inc(x[3],DK[49]);
  Inc(x[2],DK[50]);
  Mul(x[4],DK[51]);
  x[1]:=(x[1] shl 8) or (x[1] shr 8);
  s2:=(x[3] shl 8) or (x[3] shr 8);
  x[3]:=(x[2] shl 8) or (x[2] shr 8);
  x[4]:=(x[4] shl 8) or (x[4] shr 8);
  x[2]:=s2;
  Move(x,OutBlock,Sizeof(x));
 end;
end;

procedure InvertKey(EK,DK:PWord);
var
 i:longint;
 t1,t2,t3:word;
 temp:array[0..51] of word;
 p:PWord;
begin
 p:=pointer(longint(@temp)+Sizeof(Temp));
 Dec(p);
 t1:=MulInv(EK^);
 Inc(EK);
 t2:=-EK^;
 Inc(EK);
 t3:=-EK^;
 Inc(EK);
 p^:=MulInv(EK^);
 Inc(EK);
 Dec(p);
 p^:=t3;
 Dec(p);
 p^:=t2;
 Dec(p);
 p^:=t1;
 Dec(p);
 for i:=0 to 6 do begin
  t1:=EK^;
  Inc(EK);
  p^:=EK^;
  Inc(EK);
  Dec(p);
  p^:=t1;
  Dec(p);
  t1:=MulInv(EK^);
  Inc(EK);
  t2:=-EK^;
  Inc(EK);
  t3:=-EK^;
  Inc(EK);
  p^:=MulInv(EK^);
  Inc(EK);
  Dec(p);
  p^:=t2;
  Dec(p);
  p^:=t3;
  Dec(p);
  p^:=t1;
  Dec(p);
 end;
 t1:=EK^;
 Inc(EK);
 p^:=EK^;
 Dec(p);
 Inc(EK);
 p^:=t1;
 Dec(p);

 t1:=MulInv(EK^);
 Inc(EK);
 t2:=-EK^;
 Inc(EK);
 t3:=-EK^;
 Inc(EK);
 p^:=MulInv(EK^);
 Dec(p);
 p^:=t3;
 Dec(p);
 p^:=t2;
 Dec(p);
 p^:=t1;
 Move(Temp,DK^,Sizeof(Temp));
 FillChar(Temp,Sizeof(Temp),0);
end;

procedure IDEAInit;
var
 i:longint;
begin
 if (Size> 128) or (Size<=0) or ((Size mod 8)<> 0) then Exit;
 with Data do begin
 Size:=Size div 8;
 FillChar(EK,Sizeof(EK),0);
 Move(Key,EK,Size);
 for i:=0 to 7 do EK[i]:=(EK[i] shl 8) or (EK[i] shr 8);
 for i:=1 to 5 do begin
  EK[(i*8)+0]:=(EK[((i-1)*8)+1] shl 9) or (EK[((i-1)*8)+2] shr 7);
  EK[(i*8)+1]:=(EK[((i-1)*8)+2] shl 9) or (EK[((i-1)*8)+3] shr 7);
  EK[(i*8)+2]:=(EK[((i-1)*8)+3] shl 9) or (EK[((i-1)*8)+4] shr 7);
  EK[(i*8)+3]:=(EK[((i-1)*8)+4] shl 9) or (EK[((i-1)*8)+5] shr 7);
  EK[(i*8)+4]:=(EK[((i-1)*8)+5] shl 9) or (EK[((i-1)*8)+6] shr 7);
  EK[(i*8)+5]:=(EK[((i-1)*8)+6] shl 9) or (EK[((i-1)*8)+7] shr 7);
  EK[(i*8)+6]:=(EK[((i-1)*8)+7] shl 9) or (EK[((i-1)*8)+0] shr 7);
  EK[(i*8)+7]:=(EK[((i-1)*8)+0] shl 9) or (EK[((i-1)*8)+1] shr 7);
 end;
 EK[48]:=(EK[41] shl 9) or (EK[42] shr 7);
 EK[49]:=(EK[42] shl 9) or (EK[43] shr 7);
 EK[50]:=(EK[43] shl 9) or (EK[44] shr 7);
 EK[51]:=(EK[44] shl 9) or (EK[45] shr 7);
 InvertKey(@EK,@DK);
 if IVector=nil then begin
  FillChar(IV,Sizeof(IV),$FF);
  IDEAEncryptECB(Data,IV,IV);
  Move(IV,LB,Sizeof(LB));
 end else begin
  Move(IVector^,IV,Sizeof(IV));
  Move(IV,LB,Sizeof(IV));
 end;
 end;
end;

procedure IDEABurn;
begin
 with Data do begin
  FillChar(EK,Sizeof(EK),$FF);
  FillChar(DK,Sizeof(DK),$FF);
  FillChar(IV,Sizeof(IV),$FF);
  FillChar(LB,Sizeof(LB),$FF);
 end;
end;

procedure IDEAReset;
begin
 with Data do Move(IV,LB,Sizeof(LB));
end;

procedure IDEAEncryptCBC;
var
 TB:array[0..7] of byte;
 i:longint;
begin
 with Data do begin
  for i:=1 to (Size div 8) do begin
   XorBlock(pointer(longint(@InData)+((i-1)*8)),@LB,@TB,Sizeof(TB));
   IDEAEncryptECB(Data,TB,TB);
   Move(TB,pointer(longint(@OutData)+((i-1)*8))^,Sizeof(TB));
   Move(TB,LB,Sizeof(TB));
  end;
  if (Size mod 8)<> 0 then begin
   IDEAEncryptECB(Data,LB,TB);
   XorBlock(@TB,@pointer(longint(@InData)+Size-(Size mod 8))^,@pointer(longint(@OutData)+Size-(Size mod 8))^,Size mod 8);
  end;
  FillChar(TB,Sizeof(TB),$FF);
 end;
end;

procedure IDEADecryptCBC;
var
 TB:array[0..7] of byte;
 i:longint;
begin
 with Data do begin
  for i:=1 to (Size div 8) do begin
   Move(pointer(longint(@InData)+((i-1)*8))^,TB,Sizeof(TB));
   IDEADecryptECB(Data,pointer(longint(@InData)+((i-1)*8))^,pointer(longint(@OutData)+((i-1)*8))^);
   XorBlock(@LB,pointer(longint(@OutData)+((i-1)*8)),pointer(longint(@OutData)+((i-1)*8)),Sizeof(TB));
   Move(TB,LB,Sizeof(TB));
  end;
  if (Size mod 8)<> 0 then begin
   IDEAEncryptECB(Data,LB,TB);
   XorBlock(@TB,@pointer(longint(@InData)+Size-(Size mod 8))^,@pointer(longint(@OutData)+Size-(Size mod 8))^,Size mod 8);
  end;
  FillChar(TB,Sizeof(TB),$FF);
 end;
end;

procedure IDEAEncryptCFB;
var
 i:longint;
 TB:array[0..7] of byte;
begin
 with Data do begin
  for i:=0 to Size-1 do begin
   IDEAEncryptECB(Data,LB,TB);
   PByteArray(@OutData)^[i]:=PByteArray(@InData)^[i] xor TB[0];
   Move(LB[1],LB[0],7);
   LB[7]:=PByteArray(@OutData)^[i];
  end;
 end;
end;

procedure IDEADecryptCFB;
var
 i:longint;
 TB:array[0..7] of byte;
 b:byte;
begin
 with Data do begin
  for i:=0 to Size-1 do begin
   b:=PByteArray(@InData)^[i];
   IDEAEncryptECB(Data,LB,TB);
   PByteArray(@OutData)^[i]:=PByteArray(@InData)^[i] xor TB[0];
   Move(LB[1],LB[0],7);
   LB[7]:=b;
  end;
 end;
end;

{** Startof: Rijndael **}

const
 S:array[0..255] of byte=(
  99,124,119,123,242,107,111,197, 48,  1,103, 43,254,215,171,118,
 202,130,201,125,250, 89, 71,240,173,212,162,175,156,164,114,192,
 183,253,147, 38, 54, 63,247,204, 52,165,229,241,113,216, 49, 21,
   4,199, 35,195, 24,150,  5,154,  7, 18,128,226,235, 39,178,117,
   9,131, 44, 26, 27,110, 90,160, 82, 59,214,179, 41,227, 47,132,
  83,209,  0,237, 32,252,177, 91,106,203,190, 57, 74, 76, 88,207,
 208,239,170,251, 67, 77, 51,133, 69,249,  2,127, 80, 60,159,168,
  81,163, 64,143,146,157, 56,245,188,182,218, 33, 16,255,243,210,
 205, 12, 19,236, 95,151, 68, 23,196,167,126, 61,100, 93, 25,115,
  96,129, 79,220, 34, 42,144,136, 70,238,184, 20,222, 94, 11,219,
 224, 50, 58, 10, 73,  6, 36, 92,194,211,172, 98,145,149,228,121,
 231,200, 55,109,141,213, 78,169,108, 86,244,234,101,122,174,  8,
 186,120, 37, 46, 28,166,180,198,232,221,116, 31, 75,189,139,138,
 112, 62,181,102, 72,  3,246, 14, 97, 53, 87,185,134,193, 29,158,
 225,248,152, 17,105,217,142,148,155, 30,135,233,206, 85, 40,223,
 140,161,137, 13,191,230, 66,104, 65,153, 45, 15,176, 84,187, 22);
 T1:array[0..255,0..3] of byte=(
 ($c6,$63,$63,$a5),($f8,$7c,$7c,$84),($ee,$77,$77,$99),($f6,$7b,$7b,$8d),
 ($ff,$f2,$f2,$0d),($d6,$6b,$6b,$bd),($de,$6f,$6f,$b1),($91,$c5,$c5,$54),
 ($60,$30,$30,$50),($02,$01,$01,$03),($ce,$67,$67,$a9),($56,$2b,$2b,$7d),
 ($e7,$fe,$fe,$19),($b5,$d7,$d7,$62),($4d,$ab,$ab,$e6),($ec,$76,$76,$9a),
 ($8f,$ca,$ca,$45),($1f,$82,$82,$9d),($89,$c9,$c9,$40),($fa,$7d,$7d,$87),
 ($ef,$fa,$fa,$15),($b2,$59,$59,$eb),($8e,$47,$47,$c9),($fb,$f0,$f0,$0b),
 ($41,$ad,$ad,$ec),($b3,$d4,$d4,$67),($5f,$a2,$a2,$fd),($45,$af,$af,$ea),
 ($23,$9c,$9c,$bf),($53,$a4,$a4,$f7),($e4,$72,$72,$96),($9b,$c0,$c0,$5b),
 ($75,$b7,$b7,$c2),($e1,$fd,$fd,$1c),($3d,$93,$93,$ae),($4c,$26,$26,$6a),
 ($6c,$36,$36,$5a),($7e,$3f,$3f,$41),($f5,$f7,$f7,$02),($83,$cc,$cc,$4f),
 ($68,$34,$34,$5c),($51,$a5,$a5,$f4),($d1,$e5,$e5,$34),($f9,$f1,$f1,$08),
 ($e2,$71,$71,$93),($ab,$d8,$d8,$73),($62,$31,$31,$53),($2a,$15,$15,$3f),
 ($08,$04,$04,$0c),($95,$c7,$c7,$52),($46,$23,$23,$65),($9d,$c3,$c3,$5e),
 ($30,$18,$18,$28),($37,$96,$96,$a1),($0a,$05,$05,$0f),($2f,$9a,$9a,$b5),
 ($0e,$07,$07,$09),($24,$12,$12,$36),($1b,$80,$80,$9b),($df,$e2,$e2,$3d),
 ($cd,$eb,$eb,$26),($4e,$27,$27,$69),($7f,$b2,$b2,$cd),($ea,$75,$75,$9f),
 ($12,$09,$09,$1b),($1d,$83,$83,$9e),($58,$2c,$2c,$74),($34,$1a,$1a,$2e),
 ($36,$1b,$1b,$2d),($dc,$6e,$6e,$b2),($b4,$5a,$5a,$ee),($5b,$a0,$a0,$fb),
 ($a4,$52,$52,$f6),($76,$3b,$3b,$4d),($b7,$d6,$d6,$61),($7d,$b3,$b3,$ce),
 ($52,$29,$29,$7b),($dd,$e3,$e3,$3e),($5e,$2f,$2f,$71),($13,$84,$84,$97),
 ($a6,$53,$53,$f5),($b9,$d1,$d1,$68),($00,$00,$00,$00),($c1,$ed,$ed,$2c),
 ($40,$20,$20,$60),($e3,$fc,$fc,$1f),($79,$b1,$b1,$c8),($b6,$5b,$5b,$ed),
 ($d4,$6a,$6a,$be),($8d,$cb,$cb,$46),($67,$be,$be,$d9),($72,$39,$39,$4b),
 ($94,$4a,$4a,$de),($98,$4c,$4c,$d4),($b0,$58,$58,$e8),($85,$cf,$cf,$4a),
 ($bb,$d0,$d0,$6b),($c5,$ef,$ef,$2a),($4f,$aa,$aa,$e5),($ed,$fb,$fb,$16),
 ($86,$43,$43,$c5),($9a,$4d,$4d,$d7),($66,$33,$33,$55),($11,$85,$85,$94),
 ($8a,$45,$45,$cf),($e9,$f9,$f9,$10),($04,$02,$02,$06),($fe,$7f,$7f,$81),
 ($a0,$50,$50,$f0),($78,$3c,$3c,$44),($25,$9f,$9f,$ba),($4b,$a8,$a8,$e3),
 ($a2,$51,$51,$f3),($5d,$a3,$a3,$fe),($80,$40,$40,$c0),($05,$8f,$8f,$8a),
 ($3f,$92,$92,$ad),($21,$9d,$9d,$bc),($70,$38,$38,$48),($f1,$f5,$f5,$04),
 ($63,$bc,$bc,$df),($77,$b6,$b6,$c1),($af,$da,$da,$75),($42,$21,$21,$63),
 ($20,$10,$10,$30),($e5,$ff,$ff,$1a),($fd,$f3,$f3,$0e),($bf,$d2,$d2,$6d),
 ($81,$cd,$cd,$4c),($18,$0c,$0c,$14),($26,$13,$13,$35),($c3,$ec,$ec,$2f),
 ($be,$5f,$5f,$e1),($35,$97,$97,$a2),($88,$44,$44,$cc),($2e,$17,$17,$39),
 ($93,$c4,$c4,$57),($55,$a7,$a7,$f2),($fc,$7e,$7e,$82),($7a,$3d,$3d,$47),
 ($c8,$64,$64,$ac),($ba,$5d,$5d,$e7),($32,$19,$19,$2b),($e6,$73,$73,$95),
 ($c0,$60,$60,$a0),($19,$81,$81,$98),($9e,$4f,$4f,$d1),($a3,$dc,$dc,$7f),
 ($44,$22,$22,$66),($54,$2a,$2a,$7e),($3b,$90,$90,$ab),($0b,$88,$88,$83),
 ($8c,$46,$46,$ca),($c7,$ee,$ee,$29),($6b,$b8,$b8,$d3),($28,$14,$14,$3c),
 ($a7,$de,$de,$79),($bc,$5e,$5e,$e2),($16,$0b,$0b,$1d),($ad,$db,$db,$76),
 ($db,$e0,$e0,$3b),($64,$32,$32,$56),($74,$3a,$3a,$4e),($14,$0a,$0a,$1e),
 ($92,$49,$49,$db),($0c,$06,$06,$0a),($48,$24,$24,$6c),($b8,$5c,$5c,$e4),
 ($9f,$c2,$c2,$5d),($bd,$d3,$d3,$6e),($43,$ac,$ac,$ef),($c4,$62,$62,$a6),
 ($39,$91,$91,$a8),($31,$95,$95,$a4),($d3,$e4,$e4,$37),($f2,$79,$79,$8b),
 ($d5,$e7,$e7,$32),($8b,$c8,$c8,$43),($6e,$37,$37,$59),($da,$6d,$6d,$b7),
 ($01,$8d,$8d,$8c),($b1,$d5,$d5,$64),($9c,$4e,$4e,$d2),($49,$a9,$a9,$e0),
 ($d8,$6c,$6c,$b4),($ac,$56,$56,$fa),($f3,$f4,$f4,$07),($cf,$ea,$ea,$25),
 ($ca,$65,$65,$af),($f4,$7a,$7a,$8e),($47,$ae,$ae,$e9),($10,$08,$08,$18),
 ($6f,$ba,$ba,$d5),($f0,$78,$78,$88),($4a,$25,$25,$6f),($5c,$2e,$2e,$72),
 ($38,$1c,$1c,$24),($57,$a6,$a6,$f1),($73,$b4,$b4,$c7),($97,$c6,$c6,$51),
 ($cb,$e8,$e8,$23),($a1,$dd,$dd,$7c),($e8,$74,$74,$9c),($3e,$1f,$1f,$21),
 ($96,$4b,$4b,$dd),($61,$bd,$bd,$dc),($0d,$8b,$8b,$86),($0f,$8a,$8a,$85),
 ($e0,$70,$70,$90),($7c,$3e,$3e,$42),($71,$b5,$b5,$c4),($cc,$66,$66,$aa),
 ($90,$48,$48,$d8),($06,$03,$03,$05),($f7,$f6,$f6,$01),($1c,$0e,$0e,$12),
 ($c2,$61,$61,$a3),($6a,$35,$35,$5f),($ae,$57,$57,$f9),($69,$b9,$b9,$d0),
 ($17,$86,$86,$91),($99,$c1,$c1,$58),($3a,$1d,$1d,$27),($27,$9e,$9e,$b9),
 ($d9,$e1,$e1,$38),($eb,$f8,$f8,$13),($2b,$98,$98,$b3),($22,$11,$11,$33),
 ($d2,$69,$69,$bb),($a9,$d9,$d9,$70),($07,$8e,$8e,$89),($33,$94,$94,$a7),
 ($2d,$9b,$9b,$b6),($3c,$1e,$1e,$22),($15,$87,$87,$92),($c9,$e9,$e9,$20),
 ($87,$ce,$ce,$49),($aa,$55,$55,$ff),($50,$28,$28,$78),($a5,$df,$df,$7a),
 ($03,$8c,$8c,$8f),($59,$a1,$a1,$f8),($09,$89,$89,$80),($1a,$0d,$0d,$17),
 ($65,$bf,$bf,$da),($d7,$e6,$e6,$31),($84,$42,$42,$c6),($d0,$68,$68,$b8),
 ($82,$41,$41,$c3),($29,$99,$99,$b0),($5a,$2d,$2d,$77),($1e,$0f,$0f,$11),
 ($7b,$b0,$b0,$cb),($a8,$54,$54,$fc),($6d,$bb,$bb,$d6),($2c,$16,$16,$3a));
 T2:array[0..255,0..3] of byte=(
 ($a5,$c6,$63,$63),($84,$f8,$7c,$7c),($99,$ee,$77,$77),($8d,$f6,$7b,$7b),
 ($0d,$ff,$f2,$f2),($bd,$d6,$6b,$6b),($b1,$de,$6f,$6f),($54,$91,$c5,$c5),
 ($50,$60,$30,$30),($03,$02,$01,$01),($a9,$ce,$67,$67),($7d,$56,$2b,$2b),
 ($19,$e7,$fe,$fe),($62,$b5,$d7,$d7),($e6,$4d,$ab,$ab),($9a,$ec,$76,$76),
 ($45,$8f,$ca,$ca),($9d,$1f,$82,$82),($40,$89,$c9,$c9),($87,$fa,$7d,$7d),
 ($15,$ef,$fa,$fa),($eb,$b2,$59,$59),($c9,$8e,$47,$47),($0b,$fb,$f0,$f0),
 ($ec,$41,$ad,$ad),($67,$b3,$d4,$d4),($fd,$5f,$a2,$a2),($ea,$45,$af,$af),
 ($bf,$23,$9c,$9c),($f7,$53,$a4,$a4),($96,$e4,$72,$72),($5b,$9b,$c0,$c0),
 ($c2,$75,$b7,$b7),($1c,$e1,$fd,$fd),($ae,$3d,$93,$93),($6a,$4c,$26,$26),
 ($5a,$6c,$36,$36),($41,$7e,$3f,$3f),($02,$f5,$f7,$f7),($4f,$83,$cc,$cc),
 ($5c,$68,$34,$34),($f4,$51,$a5,$a5),($34,$d1,$e5,$e5),($08,$f9,$f1,$f1),
 ($93,$e2,$71,$71),($73,$ab,$d8,$d8),($53,$62,$31,$31),($3f,$2a,$15,$15),
 ($0c,$08,$04,$04),($52,$95,$c7,$c7),($65,$46,$23,$23),($5e,$9d,$c3,$c3),
 ($28,$30,$18,$18),($a1,$37,$96,$96),($0f,$0a,$05,$05),($b5,$2f,$9a,$9a),
 ($09,$0e,$07,$07),($36,$24,$12,$12),($9b,$1b,$80,$80),($3d,$df,$e2,$e2),
 ($26,$cd,$eb,$eb),($69,$4e,$27,$27),($cd,$7f,$b2,$b2),($9f,$ea,$75,$75),
 ($1b,$12,$09,$09),($9e,$1d,$83,$83),($74,$58,$2c,$2c),($2e,$34,$1a,$1a),
 ($2d,$36,$1b,$1b),($b2,$dc,$6e,$6e),($ee,$b4,$5a,$5a),($fb,$5b,$a0,$a0),
 ($f6,$a4,$52,$52),($4d,$76,$3b,$3b),($61,$b7,$d6,$d6),($ce,$7d,$b3,$b3),
 ($7b,$52,$29,$29),($3e,$dd,$e3,$e3),($71,$5e,$2f,$2f),($97,$13,$84,$84),
 ($f5,$a6,$53,$53),($68,$b9,$d1,$d1),($00,$00,$00,$00),($2c,$c1,$ed,$ed),
 ($60,$40,$20,$20),($1f,$e3,$fc,$fc),($c8,$79,$b1,$b1),($ed,$b6,$5b,$5b),
 ($be,$d4,$6a,$6a),($46,$8d,$cb,$cb),($d9,$67,$be,$be),($4b,$72,$39,$39),
 ($de,$94,$4a,$4a),($d4,$98,$4c,$4c),($e8,$b0,$58,$58),($4a,$85,$cf,$cf),
 ($6b,$bb,$d0,$d0),($2a,$c5,$ef,$ef),($e5,$4f,$aa,$aa),($16,$ed,$fb,$fb),
 ($c5,$86,$43,$43),($d7,$9a,$4d,$4d),($55,$66,$33,$33),($94,$11,$85,$85),
 ($cf,$8a,$45,$45),($10,$e9,$f9,$f9),($06,$04,$02,$02),($81,$fe,$7f,$7f),
 ($f0,$a0,$50,$50),($44,$78,$3c,$3c),($ba,$25,$9f,$9f),($e3,$4b,$a8,$a8),
 ($f3,$a2,$51,$51),($fe,$5d,$a3,$a3),($c0,$80,$40,$40),($8a,$05,$8f,$8f),
 ($ad,$3f,$92,$92),($bc,$21,$9d,$9d),($48,$70,$38,$38),($04,$f1,$f5,$f5),
 ($df,$63,$bc,$bc),($c1,$77,$b6,$b6),($75,$af,$da,$da),($63,$42,$21,$21),
 ($30,$20,$10,$10),($1a,$e5,$ff,$ff),($0e,$fd,$f3,$f3),($6d,$bf,$d2,$d2),
 ($4c,$81,$cd,$cd),($14,$18,$0c,$0c),($35,$26,$13,$13),($2f,$c3,$ec,$ec),
 ($e1,$be,$5f,$5f),($a2,$35,$97,$97),($cc,$88,$44,$44),($39,$2e,$17,$17),
 ($57,$93,$c4,$c4),($f2,$55,$a7,$a7),($82,$fc,$7e,$7e),($47,$7a,$3d,$3d),
 ($ac,$c8,$64,$64),($e7,$ba,$5d,$5d),($2b,$32,$19,$19),($95,$e6,$73,$73),
 ($a0,$c0,$60,$60),($98,$19,$81,$81),($d1,$9e,$4f,$4f),($7f,$a3,$dc,$dc),
 ($66,$44,$22,$22),($7e,$54,$2a,$2a),($ab,$3b,$90,$90),($83,$0b,$88,$88),
 ($ca,$8c,$46,$46),($29,$c7,$ee,$ee),($d3,$6b,$b8,$b8),($3c,$28,$14,$14),
 ($79,$a7,$de,$de),($e2,$bc,$5e,$5e),($1d,$16,$0b,$0b),($76,$ad,$db,$db),
 ($3b,$db,$e0,$e0),($56,$64,$32,$32),($4e,$74,$3a,$3a),($1e,$14,$0a,$0a),
 ($db,$92,$49,$49),($0a,$0c,$06,$06),($6c,$48,$24,$24),($e4,$b8,$5c,$5c),
 ($5d,$9f,$c2,$c2),($6e,$bd,$d3,$d3),($ef,$43,$ac,$ac),($a6,$c4,$62,$62),
 ($a8,$39,$91,$91),($a4,$31,$95,$95),($37,$d3,$e4,$e4),($8b,$f2,$79,$79),
 ($32,$d5,$e7,$e7),($43,$8b,$c8,$c8),($59,$6e,$37,$37),($b7,$da,$6d,$6d),
 ($8c,$01,$8d,$8d),($64,$b1,$d5,$d5),($d2,$9c,$4e,$4e),($e0,$49,$a9,$a9),
 ($b4,$d8,$6c,$6c),($fa,$ac,$56,$56),($07,$f3,$f4,$f4),($25,$cf,$ea,$ea),
 ($af,$ca,$65,$65),($8e,$f4,$7a,$7a),($e9,$47,$ae,$ae),($18,$10,$08,$08),
 ($d5,$6f,$ba,$ba),($88,$f0,$78,$78),($6f,$4a,$25,$25),($72,$5c,$2e,$2e),
 ($24,$38,$1c,$1c),($f1,$57,$a6,$a6),($c7,$73,$b4,$b4),($51,$97,$c6,$c6),
 ($23,$cb,$e8,$e8),($7c,$a1,$dd,$dd),($9c,$e8,$74,$74),($21,$3e,$1f,$1f),
 ($dd,$96,$4b,$4b),($dc,$61,$bd,$bd),($86,$0d,$8b,$8b),($85,$0f,$8a,$8a),
 ($90,$e0,$70,$70),($42,$7c,$3e,$3e),($c4,$71,$b5,$b5),($aa,$cc,$66,$66),
 ($d8,$90,$48,$48),($05,$06,$03,$03),($01,$f7,$f6,$f6),($12,$1c,$0e,$0e),
 ($a3,$c2,$61,$61),($5f,$6a,$35,$35),($f9,$ae,$57,$57),($d0,$69,$b9,$b9),
 ($91,$17,$86,$86),($58,$99,$c1,$c1),($27,$3a,$1d,$1d),($b9,$27,$9e,$9e),
 ($38,$d9,$e1,$e1),($13,$eb,$f8,$f8),($b3,$2b,$98,$98),($33,$22,$11,$11),
 ($bb,$d2,$69,$69),($70,$a9,$d9,$d9),($89,$07,$8e,$8e),($a7,$33,$94,$94),
 ($b6,$2d,$9b,$9b),($22,$3c,$1e,$1e),($92,$15,$87,$87),($20,$c9,$e9,$e9),
 ($49,$87,$ce,$ce),($ff,$aa,$55,$55),($78,$50,$28,$28),($7a,$a5,$df,$df),
 ($8f,$03,$8c,$8c),($f8,$59,$a1,$a1),($80,$09,$89,$89),($17,$1a,$0d,$0d),
 ($da,$65,$bf,$bf),($31,$d7,$e6,$e6),($c6,$84,$42,$42),($b8,$d0,$68,$68),
 ($c3,$82,$41,$41),($b0,$29,$99,$99),($77,$5a,$2d,$2d),($11,$1e,$0f,$0f),
 ($cb,$7b,$b0,$b0),($fc,$a8,$54,$54),($d6,$6d,$bb,$bb),($3a,$2c,$16,$16));
 T3:array[0..255,0..3] of byte=(
 ($63,$a5,$c6,$63),($7c,$84,$f8,$7c),($77,$99,$ee,$77),($7b,$8d,$f6,$7b),
 ($f2,$0d,$ff,$f2),($6b,$bd,$d6,$6b),($6f,$b1,$de,$6f),($c5,$54,$91,$c5),
 ($30,$50,$60,$30),($01,$03,$02,$01),($67,$a9,$ce,$67),($2b,$7d,$56,$2b),
 ($fe,$19,$e7,$fe),($d7,$62,$b5,$d7),($ab,$e6,$4d,$ab),($76,$9a,$ec,$76),
 ($ca,$45,$8f,$ca),($82,$9d,$1f,$82),($c9,$40,$89,$c9),($7d,$87,$fa,$7d),
 ($fa,$15,$ef,$fa),($59,$eb,$b2,$59),($47,$c9,$8e,$47),($f0,$0b,$fb,$f0),
 ($ad,$ec,$41,$ad),($d4,$67,$b3,$d4),($a2,$fd,$5f,$a2),($af,$ea,$45,$af),
 ($9c,$bf,$23,$9c),($a4,$f7,$53,$a4),($72,$96,$e4,$72),($c0,$5b,$9b,$c0),
 ($b7,$c2,$75,$b7),($fd,$1c,$e1,$fd),($93,$ae,$3d,$93),($26,$6a,$4c,$26),
 ($36,$5a,$6c,$36),($3f,$41,$7e,$3f),($f7,$02,$f5,$f7),($cc,$4f,$83,$cc),
 ($34,$5c,$68,$34),($a5,$f4,$51,$a5),($e5,$34,$d1,$e5),($f1,$08,$f9,$f1),
 ($71,$93,$e2,$71),($d8,$73,$ab,$d8),($31,$53,$62,$31),($15,$3f,$2a,$15),
 ($04,$0c,$08,$04),($c7,$52,$95,$c7),($23,$65,$46,$23),($c3,$5e,$9d,$c3),
 ($18,$28,$30,$18),($96,$a1,$37,$96),($05,$0f,$0a,$05),($9a,$b5,$2f,$9a),
 ($07,$09,$0e,$07),($12,$36,$24,$12),($80,$9b,$1b,$80),($e2,$3d,$df,$e2),
 ($eb,$26,$cd,$eb),($27,$69,$4e,$27),($b2,$cd,$7f,$b2),($75,$9f,$ea,$75),
 ($09,$1b,$12,$09),($83,$9e,$1d,$83),($2c,$74,$58,$2c),($1a,$2e,$34,$1a),
 ($1b,$2d,$36,$1b),($6e,$b2,$dc,$6e),($5a,$ee,$b4,$5a),($a0,$fb,$5b,$a0),
 ($52,$f6,$a4,$52),($3b,$4d,$76,$3b),($d6,$61,$b7,$d6),($b3,$ce,$7d,$b3),
 ($29,$7b,$52,$29),($e3,$3e,$dd,$e3),($2f,$71,$5e,$2f),($84,$97,$13,$84),
 ($53,$f5,$a6,$53),($d1,$68,$b9,$d1),($00,$00,$00,$00),($ed,$2c,$c1,$ed),
 ($20,$60,$40,$20),($fc,$1f,$e3,$fc),($b1,$c8,$79,$b1),($5b,$ed,$b6,$5b),
 ($6a,$be,$d4,$6a),($cb,$46,$8d,$cb),($be,$d9,$67,$be),($39,$4b,$72,$39),
 ($4a,$de,$94,$4a),($4c,$d4,$98,$4c),($58,$e8,$b0,$58),($cf,$4a,$85,$cf),
 ($d0,$6b,$bb,$d0),($ef,$2a,$c5,$ef),($aa,$e5,$4f,$aa),($fb,$16,$ed,$fb),
 ($43,$c5,$86,$43),($4d,$d7,$9a,$4d),($33,$55,$66,$33),($85,$94,$11,$85),
 ($45,$cf,$8a,$45),($f9,$10,$e9,$f9),($02,$06,$04,$02),($7f,$81,$fe,$7f),
 ($50,$f0,$a0,$50),($3c,$44,$78,$3c),($9f,$ba,$25,$9f),($a8,$e3,$4b,$a8),
 ($51,$f3,$a2,$51),($a3,$fe,$5d,$a3),($40,$c0,$80,$40),($8f,$8a,$05,$8f),
 ($92,$ad,$3f,$92),($9d,$bc,$21,$9d),($38,$48,$70,$38),($f5,$04,$f1,$f5),
 ($bc,$df,$63,$bc),($b6,$c1,$77,$b6),($da,$75,$af,$da),($21,$63,$42,$21),
 ($10,$30,$20,$10),($ff,$1a,$e5,$ff),($f3,$0e,$fd,$f3),($d2,$6d,$bf,$d2),
 ($cd,$4c,$81,$cd),($0c,$14,$18,$0c),($13,$35,$26,$13),($ec,$2f,$c3,$ec),
 ($5f,$e1,$be,$5f),($97,$a2,$35,$97),($44,$cc,$88,$44),($17,$39,$2e,$17),
 ($c4,$57,$93,$c4),($a7,$f2,$55,$a7),($7e,$82,$fc,$7e),($3d,$47,$7a,$3d),
 ($64,$ac,$c8,$64),($5d,$e7,$ba,$5d),($19,$2b,$32,$19),($73,$95,$e6,$73),
 ($60,$a0,$c0,$60),($81,$98,$19,$81),($4f,$d1,$9e,$4f),($dc,$7f,$a3,$dc),
 ($22,$66,$44,$22),($2a,$7e,$54,$2a),($90,$ab,$3b,$90),($88,$83,$0b,$88),
 ($46,$ca,$8c,$46),($ee,$29,$c7,$ee),($b8,$d3,$6b,$b8),($14,$3c,$28,$14),
 ($de,$79,$a7,$de),($5e,$e2,$bc,$5e),($0b,$1d,$16,$0b),($db,$76,$ad,$db),
 ($e0,$3b,$db,$e0),($32,$56,$64,$32),($3a,$4e,$74,$3a),($0a,$1e,$14,$0a),
 ($49,$db,$92,$49),($06,$0a,$0c,$06),($24,$6c,$48,$24),($5c,$e4,$b8,$5c),
 ($c2,$5d,$9f,$c2),($d3,$6e,$bd,$d3),($ac,$ef,$43,$ac),($62,$a6,$c4,$62),
 ($91,$a8,$39,$91),($95,$a4,$31,$95),($e4,$37,$d3,$e4),($79,$8b,$f2,$79),
 ($e7,$32,$d5,$e7),($c8,$43,$8b,$c8),($37,$59,$6e,$37),($6d,$b7,$da,$6d),
 ($8d,$8c,$01,$8d),($d5,$64,$b1,$d5),($4e,$d2,$9c,$4e),($a9,$e0,$49,$a9),
 ($6c,$b4,$d8,$6c),($56,$fa,$ac,$56),($f4,$07,$f3,$f4),($ea,$25,$cf,$ea),
 ($65,$af,$ca,$65),($7a,$8e,$f4,$7a),($ae,$e9,$47,$ae),($08,$18,$10,$08),
 ($ba,$d5,$6f,$ba),($78,$88,$f0,$78),($25,$6f,$4a,$25),($2e,$72,$5c,$2e),
 ($1c,$24,$38,$1c),($a6,$f1,$57,$a6),($b4,$c7,$73,$b4),($c6,$51,$97,$c6),
 ($e8,$23,$cb,$e8),($dd,$7c,$a1,$dd),($74,$9c,$e8,$74),($1f,$21,$3e,$1f),
 ($4b,$dd,$96,$4b),($bd,$dc,$61,$bd),($8b,$86,$0d,$8b),($8a,$85,$0f,$8a),
 ($70,$90,$e0,$70),($3e,$42,$7c,$3e),($b5,$c4,$71,$b5),($66,$aa,$cc,$66),
 ($48,$d8,$90,$48),($03,$05,$06,$03),($f6,$01,$f7,$f6),($0e,$12,$1c,$0e),
 ($61,$a3,$c2,$61),($35,$5f,$6a,$35),($57,$f9,$ae,$57),($b9,$d0,$69,$b9),
 ($86,$91,$17,$86),($c1,$58,$99,$c1),($1d,$27,$3a,$1d),($9e,$b9,$27,$9e),
 ($e1,$38,$d9,$e1),($f8,$13,$eb,$f8),($98,$b3,$2b,$98),($11,$33,$22,$11),
 ($69,$bb,$d2,$69),($d9,$70,$a9,$d9),($8e,$89,$07,$8e),($94,$a7,$33,$94),
 ($9b,$b6,$2d,$9b),($1e,$22,$3c,$1e),($87,$92,$15,$87),($e9,$20,$c9,$e9),
 ($ce,$49,$87,$ce),($55,$ff,$aa,$55),($28,$78,$50,$28),($df,$7a,$a5,$df),
 ($8c,$8f,$03,$8c),($a1,$f8,$59,$a1),($89,$80,$09,$89),($0d,$17,$1a,$0d),
 ($bf,$da,$65,$bf),($e6,$31,$d7,$e6),($42,$c6,$84,$42),($68,$b8,$d0,$68),
 ($41,$c3,$82,$41),($99,$b0,$29,$99),($2d,$77,$5a,$2d),($0f,$11,$1e,$0f),
 ($b0,$cb,$7b,$b0),($54,$fc,$a8,$54),($bb,$d6,$6d,$bb),($16,$3a,$2c,$16));
 T4:array[0..255,0..3] of byte=(
 ($63,$63,$a5,$c6),($7c,$7c,$84,$f8),($77,$77,$99,$ee),($7b,$7b,$8d,$f6),
 ($f2,$f2,$0d,$ff),($6b,$6b,$bd,$d6),($6f,$6f,$b1,$de),($c5,$c5,$54,$91),
 ($30,$30,$50,$60),($01,$01,$03,$02),($67,$67,$a9,$ce),($2b,$2b,$7d,$56),
 ($fe,$fe,$19,$e7),($d7,$d7,$62,$b5),($ab,$ab,$e6,$4d),($76,$76,$9a,$ec),
 ($ca,$ca,$45,$8f),($82,$82,$9d,$1f),($c9,$c9,$40,$89),($7d,$7d,$87,$fa),
 ($fa,$fa,$15,$ef),($59,$59,$eb,$b2),($47,$47,$c9,$8e),($f0,$f0,$0b,$fb),
 ($ad,$ad,$ec,$41),($d4,$d4,$67,$b3),($a2,$a2,$fd,$5f),($af,$af,$ea,$45),
 ($9c,$9c,$bf,$23),($a4,$a4,$f7,$53),($72,$72,$96,$e4),($c0,$c0,$5b,$9b),
 ($b7,$b7,$c2,$75),($fd,$fd,$1c,$e1),($93,$93,$ae,$3d),($26,$26,$6a,$4c),
 ($36,$36,$5a,$6c),($3f,$3f,$41,$7e),($f7,$f7,$02,$f5),($cc,$cc,$4f,$83),
 ($34,$34,$5c,$68),($a5,$a5,$f4,$51),($e5,$e5,$34,$d1),($f1,$f1,$08,$f9),
 ($71,$71,$93,$e2),($d8,$d8,$73,$ab),($31,$31,$53,$62),($15,$15,$3f,$2a),
 ($04,$04,$0c,$08),($c7,$c7,$52,$95),($23,$23,$65,$46),($c3,$c3,$5e,$9d),
 ($18,$18,$28,$30),($96,$96,$a1,$37),($05,$05,$0f,$0a),($9a,$9a,$b5,$2f),
 ($07,$07,$09,$0e),($12,$12,$36,$24),($80,$80,$9b,$1b),($e2,$e2,$3d,$df),
 ($eb,$eb,$26,$cd),($27,$27,$69,$4e),($b2,$b2,$cd,$7f),($75,$75,$9f,$ea),
 ($09,$09,$1b,$12),($83,$83,$9e,$1d),($2c,$2c,$74,$58),($1a,$1a,$2e,$34),
 ($1b,$1b,$2d,$36),($6e,$6e,$b2,$dc),($5a,$5a,$ee,$b4),($a0,$a0,$fb,$5b),
 ($52,$52,$f6,$a4),($3b,$3b,$4d,$76),($d6,$d6,$61,$b7),($b3,$b3,$ce,$7d),
 ($29,$29,$7b,$52),($e3,$e3,$3e,$dd),($2f,$2f,$71,$5e),($84,$84,$97,$13),
 ($53,$53,$f5,$a6),($d1,$d1,$68,$b9),($00,$00,$00,$00),($ed,$ed,$2c,$c1),
 ($20,$20,$60,$40),($fc,$fc,$1f,$e3),($b1,$b1,$c8,$79),($5b,$5b,$ed,$b6),
 ($6a,$6a,$be,$d4),($cb,$cb,$46,$8d),($be,$be,$d9,$67),($39,$39,$4b,$72),
 ($4a,$4a,$de,$94),($4c,$4c,$d4,$98),($58,$58,$e8,$b0),($cf,$cf,$4a,$85),
 ($d0,$d0,$6b,$bb),($ef,$ef,$2a,$c5),($aa,$aa,$e5,$4f),($fb,$fb,$16,$ed),
 ($43,$43,$c5,$86),($4d,$4d,$d7,$9a),($33,$33,$55,$66),($85,$85,$94,$11),
 ($45,$45,$cf,$8a),($f9,$f9,$10,$e9),($02,$02,$06,$04),($7f,$7f,$81,$fe),
 ($50,$50,$f0,$a0),($3c,$3c,$44,$78),($9f,$9f,$ba,$25),($a8,$a8,$e3,$4b),
 ($51,$51,$f3,$a2),($a3,$a3,$fe,$5d),($40,$40,$c0,$80),($8f,$8f,$8a,$05),
 ($92,$92,$ad,$3f),($9d,$9d,$bc,$21),($38,$38,$48,$70),($f5,$f5,$04,$f1),
 ($bc,$bc,$df,$63),($b6,$b6,$c1,$77),($da,$da,$75,$af),($21,$21,$63,$42),
 ($10,$10,$30,$20),($ff,$ff,$1a,$e5),($f3,$f3,$0e,$fd),($d2,$d2,$6d,$bf),
 ($cd,$cd,$4c,$81),($0c,$0c,$14,$18),($13,$13,$35,$26),($ec,$ec,$2f,$c3),
 ($5f,$5f,$e1,$be),($97,$97,$a2,$35),($44,$44,$cc,$88),($17,$17,$39,$2e),
 ($c4,$c4,$57,$93),($a7,$a7,$f2,$55),($7e,$7e,$82,$fc),($3d,$3d,$47,$7a),
 ($64,$64,$ac,$c8),($5d,$5d,$e7,$ba),($19,$19,$2b,$32),($73,$73,$95,$e6),
 ($60,$60,$a0,$c0),($81,$81,$98,$19),($4f,$4f,$d1,$9e),($dc,$dc,$7f,$a3),
 ($22,$22,$66,$44),($2a,$2a,$7e,$54),($90,$90,$ab,$3b),($88,$88,$83,$0b),
 ($46,$46,$ca,$8c),($ee,$ee,$29,$c7),($b8,$b8,$d3,$6b),($14,$14,$3c,$28),
 ($de,$de,$79,$a7),($5e,$5e,$e2,$bc),($0b,$0b,$1d,$16),($db,$db,$76,$ad),
 ($e0,$e0,$3b,$db),($32,$32,$56,$64),($3a,$3a,$4e,$74),($0a,$0a,$1e,$14),
 ($49,$49,$db,$92),($06,$06,$0a,$0c),($24,$24,$6c,$48),($5c,$5c,$e4,$b8),
 ($c2,$c2,$5d,$9f),($d3,$d3,$6e,$bd),($ac,$ac,$ef,$43),($62,$62,$a6,$c4),
 ($91,$91,$a8,$39),($95,$95,$a4,$31),($e4,$e4,$37,$d3),($79,$79,$8b,$f2),
 ($e7,$e7,$32,$d5),($c8,$c8,$43,$8b),($37,$37,$59,$6e),($6d,$6d,$b7,$da),
 ($8d,$8d,$8c,$01),($d5,$d5,$64,$b1),($4e,$4e,$d2,$9c),($a9,$a9,$e0,$49),
 ($6c,$6c,$b4,$d8),($56,$56,$fa,$ac),($f4,$f4,$07,$f3),($ea,$ea,$25,$cf),
 ($65,$65,$af,$ca),($7a,$7a,$8e,$f4),($ae,$ae,$e9,$47),($08,$08,$18,$10),
 ($ba,$ba,$d5,$6f),($78,$78,$88,$f0),($25,$25,$6f,$4a),($2e,$2e,$72,$5c),
 ($1c,$1c,$24,$38),($a6,$a6,$f1,$57),($b4,$b4,$c7,$73),($c6,$c6,$51,$97),
 ($e8,$e8,$23,$cb),($dd,$dd,$7c,$a1),($74,$74,$9c,$e8),($1f,$1f,$21,$3e),
 ($4b,$4b,$dd,$96),($bd,$bd,$dc,$61),($8b,$8b,$86,$0d),($8a,$8a,$85,$0f),
 ($70,$70,$90,$e0),($3e,$3e,$42,$7c),($b5,$b5,$c4,$71),($66,$66,$aa,$cc),
 ($48,$48,$d8,$90),($03,$03,$05,$06),($f6,$f6,$01,$f7),($0e,$0e,$12,$1c),
 ($61,$61,$a3,$c2),($35,$35,$5f,$6a),($57,$57,$f9,$ae),($b9,$b9,$d0,$69),
 ($86,$86,$91,$17),($c1,$c1,$58,$99),($1d,$1d,$27,$3a),($9e,$9e,$b9,$27),
 ($e1,$e1,$38,$d9),($f8,$f8,$13,$eb),($98,$98,$b3,$2b),($11,$11,$33,$22),
 ($69,$69,$bb,$d2),($d9,$d9,$70,$a9),($8e,$8e,$89,$07),($94,$94,$a7,$33),
 ($9b,$9b,$b6,$2d),($1e,$1e,$22,$3c),($87,$87,$92,$15),($e9,$e9,$20,$c9),
 ($ce,$ce,$49,$87),($55,$55,$ff,$aa),($28,$28,$78,$50),($df,$df,$7a,$a5),
 ($8c,$8c,$8f,$03),($a1,$a1,$f8,$59),($89,$89,$80,$09),($0d,$0d,$17,$1a),
 ($bf,$bf,$da,$65),($e6,$e6,$31,$d7),($42,$42,$c6,$84),($68,$68,$b8,$d0),
 ($41,$41,$c3,$82),($99,$99,$b0,$29),($2d,$2d,$77,$5a),($0f,$0f,$11,$1e),
 ($b0,$b0,$cb,$7b),($54,$54,$fc,$a8),($bb,$bb,$d6,$6d),($16,$16,$3a,$2c));
 T5:array[0..255,0..3] of byte=(
 ($51,$f4,$a7,$50),($7e,$41,$65,$53),($1a,$17,$a4,$c3),($3a,$27,$5e,$96),
 ($3b,$ab,$6b,$cb),($1f,$9d,$45,$f1),($ac,$fa,$58,$ab),($4b,$e3,$03,$93),
 ($20,$30,$fa,$55),($ad,$76,$6d,$f6),($88,$cc,$76,$91),($f5,$02,$4c,$25),
 ($4f,$e5,$d7,$fc),($c5,$2a,$cb,$d7),($26,$35,$44,$80),($b5,$62,$a3,$8f),
 ($de,$b1,$5a,$49),($25,$ba,$1b,$67),($45,$ea,$0e,$98),($5d,$fe,$c0,$e1),
 ($c3,$2f,$75,$02),($81,$4c,$f0,$12),($8d,$46,$97,$a3),($6b,$d3,$f9,$c6),
 ($03,$8f,$5f,$e7),($15,$92,$9c,$95),($bf,$6d,$7a,$eb),($95,$52,$59,$da),
 ($d4,$be,$83,$2d),($58,$74,$21,$d3),($49,$e0,$69,$29),($8e,$c9,$c8,$44),
 ($75,$c2,$89,$6a),($f4,$8e,$79,$78),($99,$58,$3e,$6b),($27,$b9,$71,$dd),
 ($be,$e1,$4f,$b6),($f0,$88,$ad,$17),($c9,$20,$ac,$66),($7d,$ce,$3a,$b4),
 ($63,$df,$4a,$18),($e5,$1a,$31,$82),($97,$51,$33,$60),($62,$53,$7f,$45),
 ($b1,$64,$77,$e0),($bb,$6b,$ae,$84),($fe,$81,$a0,$1c),($f9,$08,$2b,$94),
 ($70,$48,$68,$58),($8f,$45,$fd,$19),($94,$de,$6c,$87),($52,$7b,$f8,$b7),
 ($ab,$73,$d3,$23),($72,$4b,$02,$e2),($e3,$1f,$8f,$57),($66,$55,$ab,$2a),
 ($b2,$eb,$28,$07),($2f,$b5,$c2,$03),($86,$c5,$7b,$9a),($d3,$37,$08,$a5),
 ($30,$28,$87,$f2),($23,$bf,$a5,$b2),($02,$03,$6a,$ba),($ed,$16,$82,$5c),
 ($8a,$cf,$1c,$2b),($a7,$79,$b4,$92),($f3,$07,$f2,$f0),($4e,$69,$e2,$a1),
 ($65,$da,$f4,$cd),($06,$05,$be,$d5),($d1,$34,$62,$1f),($c4,$a6,$fe,$8a),
 ($34,$2e,$53,$9d),($a2,$f3,$55,$a0),($05,$8a,$e1,$32),($a4,$f6,$eb,$75),
 ($0b,$83,$ec,$39),($40,$60,$ef,$aa),($5e,$71,$9f,$06),($bd,$6e,$10,$51),
 ($3e,$21,$8a,$f9),($96,$dd,$06,$3d),($dd,$3e,$05,$ae),($4d,$e6,$bd,$46),
 ($91,$54,$8d,$b5),($71,$c4,$5d,$05),($04,$06,$d4,$6f),($60,$50,$15,$ff),
 ($19,$98,$fb,$24),($d6,$bd,$e9,$97),($89,$40,$43,$cc),($67,$d9,$9e,$77),
 ($b0,$e8,$42,$bd),($07,$89,$8b,$88),($e7,$19,$5b,$38),($79,$c8,$ee,$db),
 ($a1,$7c,$0a,$47),($7c,$42,$0f,$e9),($f8,$84,$1e,$c9),($00,$00,$00,$00),
 ($09,$80,$86,$83),($32,$2b,$ed,$48),($1e,$11,$70,$ac),($6c,$5a,$72,$4e),
 ($fd,$0e,$ff,$fb),($0f,$85,$38,$56),($3d,$ae,$d5,$1e),($36,$2d,$39,$27),
 ($0a,$0f,$d9,$64),($68,$5c,$a6,$21),($9b,$5b,$54,$d1),($24,$36,$2e,$3a),
 ($0c,$0a,$67,$b1),($93,$57,$e7,$0f),($b4,$ee,$96,$d2),($1b,$9b,$91,$9e),
 ($80,$c0,$c5,$4f),($61,$dc,$20,$a2),($5a,$77,$4b,$69),($1c,$12,$1a,$16),
 ($e2,$93,$ba,$0a),($c0,$a0,$2a,$e5),($3c,$22,$e0,$43),($12,$1b,$17,$1d),
 ($0e,$09,$0d,$0b),($f2,$8b,$c7,$ad),($2d,$b6,$a8,$b9),($14,$1e,$a9,$c8),
 ($57,$f1,$19,$85),($af,$75,$07,$4c),($ee,$99,$dd,$bb),($a3,$7f,$60,$fd),
 ($f7,$01,$26,$9f),($5c,$72,$f5,$bc),($44,$66,$3b,$c5),($5b,$fb,$7e,$34),
 ($8b,$43,$29,$76),($cb,$23,$c6,$dc),($b6,$ed,$fc,$68),($b8,$e4,$f1,$63),
 ($d7,$31,$dc,$ca),($42,$63,$85,$10),($13,$97,$22,$40),($84,$c6,$11,$20),
 ($85,$4a,$24,$7d),($d2,$bb,$3d,$f8),($ae,$f9,$32,$11),($c7,$29,$a1,$6d),
 ($1d,$9e,$2f,$4b),($dc,$b2,$30,$f3),($0d,$86,$52,$ec),($77,$c1,$e3,$d0),
 ($2b,$b3,$16,$6c),($a9,$70,$b9,$99),($11,$94,$48,$fa),($47,$e9,$64,$22),
 ($a8,$fc,$8c,$c4),($a0,$f0,$3f,$1a),($56,$7d,$2c,$d8),($22,$33,$90,$ef),
 ($87,$49,$4e,$c7),($d9,$38,$d1,$c1),($8c,$ca,$a2,$fe),($98,$d4,$0b,$36),
 ($a6,$f5,$81,$cf),($a5,$7a,$de,$28),($da,$b7,$8e,$26),($3f,$ad,$bf,$a4),
 ($2c,$3a,$9d,$e4),($50,$78,$92,$0d),($6a,$5f,$cc,$9b),($54,$7e,$46,$62),
 ($f6,$8d,$13,$c2),($90,$d8,$b8,$e8),($2e,$39,$f7,$5e),($82,$c3,$af,$f5),
 ($9f,$5d,$80,$be),($69,$d0,$93,$7c),($6f,$d5,$2d,$a9),($cf,$25,$12,$b3),
 ($c8,$ac,$99,$3b),($10,$18,$7d,$a7),($e8,$9c,$63,$6e),($db,$3b,$bb,$7b),
 ($cd,$26,$78,$09),($6e,$59,$18,$f4),($ec,$9a,$b7,$01),($83,$4f,$9a,$a8),
 ($e6,$95,$6e,$65),($aa,$ff,$e6,$7e),($21,$bc,$cf,$08),($ef,$15,$e8,$e6),
 ($ba,$e7,$9b,$d9),($4a,$6f,$36,$ce),($ea,$9f,$09,$d4),($29,$b0,$7c,$d6),
 ($31,$a4,$b2,$af),($2a,$3f,$23,$31),($c6,$a5,$94,$30),($35,$a2,$66,$c0),
 ($74,$4e,$bc,$37),($fc,$82,$ca,$a6),($e0,$90,$d0,$b0),($33,$a7,$d8,$15),
 ($f1,$04,$98,$4a),($41,$ec,$da,$f7),($7f,$cd,$50,$0e),($17,$91,$f6,$2f),
 ($76,$4d,$d6,$8d),($43,$ef,$b0,$4d),($cc,$aa,$4d,$54),($e4,$96,$04,$df),
 ($9e,$d1,$b5,$e3),($4c,$6a,$88,$1b),($c1,$2c,$1f,$b8),($46,$65,$51,$7f),
 ($9d,$5e,$ea,$04),($01,$8c,$35,$5d),($fa,$87,$74,$73),($fb,$0b,$41,$2e),
 ($b3,$67,$1d,$5a),($92,$db,$d2,$52),($e9,$10,$56,$33),($6d,$d6,$47,$13),
 ($9a,$d7,$61,$8c),($37,$a1,$0c,$7a),($59,$f8,$14,$8e),($eb,$13,$3c,$89),
 ($ce,$a9,$27,$ee),($b7,$61,$c9,$35),($e1,$1c,$e5,$ed),($7a,$47,$b1,$3c),
 ($9c,$d2,$df,$59),($55,$f2,$73,$3f),($18,$14,$ce,$79),($73,$c7,$37,$bf),
 ($53,$f7,$cd,$ea),($5f,$fd,$aa,$5b),($df,$3d,$6f,$14),($78,$44,$db,$86),
 ($ca,$af,$f3,$81),($b9,$68,$c4,$3e),($38,$24,$34,$2c),($c2,$a3,$40,$5f),
 ($16,$1d,$c3,$72),($bc,$e2,$25,$0c),($28,$3c,$49,$8b),($ff,$0d,$95,$41),
 ($39,$a8,$01,$71),($08,$0c,$b3,$de),($d8,$b4,$e4,$9c),($64,$56,$c1,$90),
 ($7b,$cb,$84,$61),($d5,$32,$b6,$70),($48,$6c,$5c,$74),($d0,$b8,$57,$42));
 T6:array[0..255,0..3] of byte=(
 ($50,$51,$f4,$a7),($53,$7e,$41,$65),($c3,$1a,$17,$a4),($96,$3a,$27,$5e),
 ($cb,$3b,$ab,$6b),($f1,$1f,$9d,$45),($ab,$ac,$fa,$58),($93,$4b,$e3,$03),
 ($55,$20,$30,$fa),($f6,$ad,$76,$6d),($91,$88,$cc,$76),($25,$f5,$02,$4c),
 ($fc,$4f,$e5,$d7),($d7,$c5,$2a,$cb),($80,$26,$35,$44),($8f,$b5,$62,$a3),
 ($49,$de,$b1,$5a),($67,$25,$ba,$1b),($98,$45,$ea,$0e),($e1,$5d,$fe,$c0),
 ($02,$c3,$2f,$75),($12,$81,$4c,$f0),($a3,$8d,$46,$97),($c6,$6b,$d3,$f9),
 ($e7,$03,$8f,$5f),($95,$15,$92,$9c),($eb,$bf,$6d,$7a),($da,$95,$52,$59),
 ($2d,$d4,$be,$83),($d3,$58,$74,$21),($29,$49,$e0,$69),($44,$8e,$c9,$c8),
 ($6a,$75,$c2,$89),($78,$f4,$8e,$79),($6b,$99,$58,$3e),($dd,$27,$b9,$71),
 ($b6,$be,$e1,$4f),($17,$f0,$88,$ad),($66,$c9,$20,$ac),($b4,$7d,$ce,$3a),
 ($18,$63,$df,$4a),($82,$e5,$1a,$31),($60,$97,$51,$33),($45,$62,$53,$7f),
 ($e0,$b1,$64,$77),($84,$bb,$6b,$ae),($1c,$fe,$81,$a0),($94,$f9,$08,$2b),
 ($58,$70,$48,$68),($19,$8f,$45,$fd),($87,$94,$de,$6c),($b7,$52,$7b,$f8),
 ($23,$ab,$73,$d3),($e2,$72,$4b,$02),($57,$e3,$1f,$8f),($2a,$66,$55,$ab),
 ($07,$b2,$eb,$28),($03,$2f,$b5,$c2),($9a,$86,$c5,$7b),($a5,$d3,$37,$08),
 ($f2,$30,$28,$87),($b2,$23,$bf,$a5),($ba,$02,$03,$6a),($5c,$ed,$16,$82),
 ($2b,$8a,$cf,$1c),($92,$a7,$79,$b4),($f0,$f3,$07,$f2),($a1,$4e,$69,$e2),
 ($cd,$65,$da,$f4),($d5,$06,$05,$be),($1f,$d1,$34,$62),($8a,$c4,$a6,$fe),
 ($9d,$34,$2e,$53),($a0,$a2,$f3,$55),($32,$05,$8a,$e1),($75,$a4,$f6,$eb),
 ($39,$0b,$83,$ec),($aa,$40,$60,$ef),($06,$5e,$71,$9f),($51,$bd,$6e,$10),
 ($f9,$3e,$21,$8a),($3d,$96,$dd,$06),($ae,$dd,$3e,$05),($46,$4d,$e6,$bd),
 ($b5,$91,$54,$8d),($05,$71,$c4,$5d),($6f,$04,$06,$d4),($ff,$60,$50,$15),
 ($24,$19,$98,$fb),($97,$d6,$bd,$e9),($cc,$89,$40,$43),($77,$67,$d9,$9e),
 ($bd,$b0,$e8,$42),($88,$07,$89,$8b),($38,$e7,$19,$5b),($db,$79,$c8,$ee),
 ($47,$a1,$7c,$0a),($e9,$7c,$42,$0f),($c9,$f8,$84,$1e),($00,$00,$00,$00),
 ($83,$09,$80,$86),($48,$32,$2b,$ed),($ac,$1e,$11,$70),($4e,$6c,$5a,$72),
 ($fb,$fd,$0e,$ff),($56,$0f,$85,$38),($1e,$3d,$ae,$d5),($27,$36,$2d,$39),
 ($64,$0a,$0f,$d9),($21,$68,$5c,$a6),($d1,$9b,$5b,$54),($3a,$24,$36,$2e),
 ($b1,$0c,$0a,$67),($0f,$93,$57,$e7),($d2,$b4,$ee,$96),($9e,$1b,$9b,$91),
 ($4f,$80,$c0,$c5),($a2,$61,$dc,$20),($69,$5a,$77,$4b),($16,$1c,$12,$1a),
 ($0a,$e2,$93,$ba),($e5,$c0,$a0,$2a),($43,$3c,$22,$e0),($1d,$12,$1b,$17),
 ($0b,$0e,$09,$0d),($ad,$f2,$8b,$c7),($b9,$2d,$b6,$a8),($c8,$14,$1e,$a9),
 ($85,$57,$f1,$19),($4c,$af,$75,$07),($bb,$ee,$99,$dd),($fd,$a3,$7f,$60),
 ($9f,$f7,$01,$26),($bc,$5c,$72,$f5),($c5,$44,$66,$3b),($34,$5b,$fb,$7e),
 ($76,$8b,$43,$29),($dc,$cb,$23,$c6),($68,$b6,$ed,$fc),($63,$b8,$e4,$f1),
 ($ca,$d7,$31,$dc),($10,$42,$63,$85),($40,$13,$97,$22),($20,$84,$c6,$11),
 ($7d,$85,$4a,$24),($f8,$d2,$bb,$3d),($11,$ae,$f9,$32),($6d,$c7,$29,$a1),
 ($4b,$1d,$9e,$2f),($f3,$dc,$b2,$30),($ec,$0d,$86,$52),($d0,$77,$c1,$e3),
 ($6c,$2b,$b3,$16),($99,$a9,$70,$b9),($fa,$11,$94,$48),($22,$47,$e9,$64),
 ($c4,$a8,$fc,$8c),($1a,$a0,$f0,$3f),($d8,$56,$7d,$2c),($ef,$22,$33,$90),
 ($c7,$87,$49,$4e),($c1,$d9,$38,$d1),($fe,$8c,$ca,$a2),($36,$98,$d4,$0b),
 ($cf,$a6,$f5,$81),($28,$a5,$7a,$de),($26,$da,$b7,$8e),($a4,$3f,$ad,$bf),
 ($e4,$2c,$3a,$9d),($0d,$50,$78,$92),($9b,$6a,$5f,$cc),($62,$54,$7e,$46),
 ($c2,$f6,$8d,$13),($e8,$90,$d8,$b8),($5e,$2e,$39,$f7),($f5,$82,$c3,$af),
 ($be,$9f,$5d,$80),($7c,$69,$d0,$93),($a9,$6f,$d5,$2d),($b3,$cf,$25,$12),
 ($3b,$c8,$ac,$99),($a7,$10,$18,$7d),($6e,$e8,$9c,$63),($7b,$db,$3b,$bb),
 ($09,$cd,$26,$78),($f4,$6e,$59,$18),($01,$ec,$9a,$b7),($a8,$83,$4f,$9a),
 ($65,$e6,$95,$6e),($7e,$aa,$ff,$e6),($08,$21,$bc,$cf),($e6,$ef,$15,$e8),
 ($d9,$ba,$e7,$9b),($ce,$4a,$6f,$36),($d4,$ea,$9f,$09),($d6,$29,$b0,$7c),
 ($af,$31,$a4,$b2),($31,$2a,$3f,$23),($30,$c6,$a5,$94),($c0,$35,$a2,$66),
 ($37,$74,$4e,$bc),($a6,$fc,$82,$ca),($b0,$e0,$90,$d0),($15,$33,$a7,$d8),
 ($4a,$f1,$04,$98),($f7,$41,$ec,$da),($0e,$7f,$cd,$50),($2f,$17,$91,$f6),
 ($8d,$76,$4d,$d6),($4d,$43,$ef,$b0),($54,$cc,$aa,$4d),($df,$e4,$96,$04),
 ($e3,$9e,$d1,$b5),($1b,$4c,$6a,$88),($b8,$c1,$2c,$1f),($7f,$46,$65,$51),
 ($04,$9d,$5e,$ea),($5d,$01,$8c,$35),($73,$fa,$87,$74),($2e,$fb,$0b,$41),
 ($5a,$b3,$67,$1d),($52,$92,$db,$d2),($33,$e9,$10,$56),($13,$6d,$d6,$47),
 ($8c,$9a,$d7,$61),($7a,$37,$a1,$0c),($8e,$59,$f8,$14),($89,$eb,$13,$3c),
 ($ee,$ce,$a9,$27),($35,$b7,$61,$c9),($ed,$e1,$1c,$e5),($3c,$7a,$47,$b1),
 ($59,$9c,$d2,$df),($3f,$55,$f2,$73),($79,$18,$14,$ce),($bf,$73,$c7,$37),
 ($ea,$53,$f7,$cd),($5b,$5f,$fd,$aa),($14,$df,$3d,$6f),($86,$78,$44,$db),
 ($81,$ca,$af,$f3),($3e,$b9,$68,$c4),($2c,$38,$24,$34),($5f,$c2,$a3,$40),
 ($72,$16,$1d,$c3),($0c,$bc,$e2,$25),($8b,$28,$3c,$49),($41,$ff,$0d,$95),
 ($71,$39,$a8,$01),($de,$08,$0c,$b3),($9c,$d8,$b4,$e4),($90,$64,$56,$c1),
 ($61,$7b,$cb,$84),($70,$d5,$32,$b6),($74,$48,$6c,$5c),($42,$d0,$b8,$57));
 T7:array[0..255,0..3] of byte=(
 ($a7,$50,$51,$f4),($65,$53,$7e,$41),($a4,$c3,$1a,$17),($5e,$96,$3a,$27),
 ($6b,$cb,$3b,$ab),($45,$f1,$1f,$9d),($58,$ab,$ac,$fa),($03,$93,$4b,$e3),
 ($fa,$55,$20,$30),($6d,$f6,$ad,$76),($76,$91,$88,$cc),($4c,$25,$f5,$02),
 ($d7,$fc,$4f,$e5),($cb,$d7,$c5,$2a),($44,$80,$26,$35),($a3,$8f,$b5,$62),
 ($5a,$49,$de,$b1),($1b,$67,$25,$ba),($0e,$98,$45,$ea),($c0,$e1,$5d,$fe),
 ($75,$02,$c3,$2f),($f0,$12,$81,$4c),($97,$a3,$8d,$46),($f9,$c6,$6b,$d3),
 ($5f,$e7,$03,$8f),($9c,$95,$15,$92),($7a,$eb,$bf,$6d),($59,$da,$95,$52),
 ($83,$2d,$d4,$be),($21,$d3,$58,$74),($69,$29,$49,$e0),($c8,$44,$8e,$c9),
 ($89,$6a,$75,$c2),($79,$78,$f4,$8e),($3e,$6b,$99,$58),($71,$dd,$27,$b9),
 ($4f,$b6,$be,$e1),($ad,$17,$f0,$88),($ac,$66,$c9,$20),($3a,$b4,$7d,$ce),
 ($4a,$18,$63,$df),($31,$82,$e5,$1a),($33,$60,$97,$51),($7f,$45,$62,$53),
 ($77,$e0,$b1,$64),($ae,$84,$bb,$6b),($a0,$1c,$fe,$81),($2b,$94,$f9,$08),
 ($68,$58,$70,$48),($fd,$19,$8f,$45),($6c,$87,$94,$de),($f8,$b7,$52,$7b),
 ($d3,$23,$ab,$73),($02,$e2,$72,$4b),($8f,$57,$e3,$1f),($ab,$2a,$66,$55),
 ($28,$07,$b2,$eb),($c2,$03,$2f,$b5),($7b,$9a,$86,$c5),($08,$a5,$d3,$37),
 ($87,$f2,$30,$28),($a5,$b2,$23,$bf),($6a,$ba,$02,$03),($82,$5c,$ed,$16),
 ($1c,$2b,$8a,$cf),($b4,$92,$a7,$79),($f2,$f0,$f3,$07),($e2,$a1,$4e,$69),
 ($f4,$cd,$65,$da),($be,$d5,$06,$05),($62,$1f,$d1,$34),($fe,$8a,$c4,$a6),
 ($53,$9d,$34,$2e),($55,$a0,$a2,$f3),($e1,$32,$05,$8a),($eb,$75,$a4,$f6),
 ($ec,$39,$0b,$83),($ef,$aa,$40,$60),($9f,$06,$5e,$71),($10,$51,$bd,$6e),
 ($8a,$f9,$3e,$21),($06,$3d,$96,$dd),($05,$ae,$dd,$3e),($bd,$46,$4d,$e6),
 ($8d,$b5,$91,$54),($5d,$05,$71,$c4),($d4,$6f,$04,$06),($15,$ff,$60,$50),
 ($fb,$24,$19,$98),($e9,$97,$d6,$bd),($43,$cc,$89,$40),($9e,$77,$67,$d9),
 ($42,$bd,$b0,$e8),($8b,$88,$07,$89),($5b,$38,$e7,$19),($ee,$db,$79,$c8),
 ($0a,$47,$a1,$7c),($0f,$e9,$7c,$42),($1e,$c9,$f8,$84),($00,$00,$00,$00),
 ($86,$83,$09,$80),($ed,$48,$32,$2b),($70,$ac,$1e,$11),($72,$4e,$6c,$5a),
 ($ff,$fb,$fd,$0e),($38,$56,$0f,$85),($d5,$1e,$3d,$ae),($39,$27,$36,$2d),
 ($d9,$64,$0a,$0f),($a6,$21,$68,$5c),($54,$d1,$9b,$5b),($2e,$3a,$24,$36),
 ($67,$b1,$0c,$0a),($e7,$0f,$93,$57),($96,$d2,$b4,$ee),($91,$9e,$1b,$9b),
 ($c5,$4f,$80,$c0),($20,$a2,$61,$dc),($4b,$69,$5a,$77),($1a,$16,$1c,$12),
 ($ba,$0a,$e2,$93),($2a,$e5,$c0,$a0),($e0,$43,$3c,$22),($17,$1d,$12,$1b),
 ($0d,$0b,$0e,$09),($c7,$ad,$f2,$8b),($a8,$b9,$2d,$b6),($a9,$c8,$14,$1e),
 ($19,$85,$57,$f1),($07,$4c,$af,$75),($dd,$bb,$ee,$99),($60,$fd,$a3,$7f),
 ($26,$9f,$f7,$01),($f5,$bc,$5c,$72),($3b,$c5,$44,$66),($7e,$34,$5b,$fb),
 ($29,$76,$8b,$43),($c6,$dc,$cb,$23),($fc,$68,$b6,$ed),($f1,$63,$b8,$e4),
 ($dc,$ca,$d7,$31),($85,$10,$42,$63),($22,$40,$13,$97),($11,$20,$84,$c6),
 ($24,$7d,$85,$4a),($3d,$f8,$d2,$bb),($32,$11,$ae,$f9),($a1,$6d,$c7,$29),
 ($2f,$4b,$1d,$9e),($30,$f3,$dc,$b2),($52,$ec,$0d,$86),($e3,$d0,$77,$c1),
 ($16,$6c,$2b,$b3),($b9,$99,$a9,$70),($48,$fa,$11,$94),($64,$22,$47,$e9),
 ($8c,$c4,$a8,$fc),($3f,$1a,$a0,$f0),($2c,$d8,$56,$7d),($90,$ef,$22,$33),
 ($4e,$c7,$87,$49),($d1,$c1,$d9,$38),($a2,$fe,$8c,$ca),($0b,$36,$98,$d4),
 ($81,$cf,$a6,$f5),($de,$28,$a5,$7a),($8e,$26,$da,$b7),($bf,$a4,$3f,$ad),
 ($9d,$e4,$2c,$3a),($92,$0d,$50,$78),($cc,$9b,$6a,$5f),($46,$62,$54,$7e),
 ($13,$c2,$f6,$8d),($b8,$e8,$90,$d8),($f7,$5e,$2e,$39),($af,$f5,$82,$c3),
 ($80,$be,$9f,$5d),($93,$7c,$69,$d0),($2d,$a9,$6f,$d5),($12,$b3,$cf,$25),
 ($99,$3b,$c8,$ac),($7d,$a7,$10,$18),($63,$6e,$e8,$9c),($bb,$7b,$db,$3b),
 ($78,$09,$cd,$26),($18,$f4,$6e,$59),($b7,$01,$ec,$9a),($9a,$a8,$83,$4f),
 ($6e,$65,$e6,$95),($e6,$7e,$aa,$ff),($cf,$08,$21,$bc),($e8,$e6,$ef,$15),
 ($9b,$d9,$ba,$e7),($36,$ce,$4a,$6f),($09,$d4,$ea,$9f),($7c,$d6,$29,$b0),
 ($b2,$af,$31,$a4),($23,$31,$2a,$3f),($94,$30,$c6,$a5),($66,$c0,$35,$a2),
 ($bc,$37,$74,$4e),($ca,$a6,$fc,$82),($d0,$b0,$e0,$90),($d8,$15,$33,$a7),
 ($98,$4a,$f1,$04),($da,$f7,$41,$ec),($50,$0e,$7f,$cd),($f6,$2f,$17,$91),
 ($d6,$8d,$76,$4d),($b0,$4d,$43,$ef),($4d,$54,$cc,$aa),($04,$df,$e4,$96),
 ($b5,$e3,$9e,$d1),($88,$1b,$4c,$6a),($1f,$b8,$c1,$2c),($51,$7f,$46,$65),
 ($ea,$04,$9d,$5e),($35,$5d,$01,$8c),($74,$73,$fa,$87),($41,$2e,$fb,$0b),
 ($1d,$5a,$b3,$67),($d2,$52,$92,$db),($56,$33,$e9,$10),($47,$13,$6d,$d6),
 ($61,$8c,$9a,$d7),($0c,$7a,$37,$a1),($14,$8e,$59,$f8),($3c,$89,$eb,$13),
 ($27,$ee,$ce,$a9),($c9,$35,$b7,$61),($e5,$ed,$e1,$1c),($b1,$3c,$7a,$47),
 ($df,$59,$9c,$d2),($73,$3f,$55,$f2),($ce,$79,$18,$14),($37,$bf,$73,$c7),
 ($cd,$ea,$53,$f7),($aa,$5b,$5f,$fd),($6f,$14,$df,$3d),($db,$86,$78,$44),
 ($f3,$81,$ca,$af),($c4,$3e,$b9,$68),($34,$2c,$38,$24),($40,$5f,$c2,$a3),
 ($c3,$72,$16,$1d),($25,$0c,$bc,$e2),($49,$8b,$28,$3c),($95,$41,$ff,$0d),
 ($01,$71,$39,$a8),($b3,$de,$08,$0c),($e4,$9c,$d8,$b4),($c1,$90,$64,$56),
 ($84,$61,$7b,$cb),($b6,$70,$d5,$32),($5c,$74,$48,$6c),($57,$42,$d0,$b8));
 T8:array[0..255,0..3] of byte=(
 ($f4,$a7,$50,$51),($41,$65,$53,$7e),($17,$a4,$c3,$1a),($27,$5e,$96,$3a),
 ($ab,$6b,$cb,$3b),($9d,$45,$f1,$1f),($fa,$58,$ab,$ac),($e3,$03,$93,$4b),
 ($30,$fa,$55,$20),($76,$6d,$f6,$ad),($cc,$76,$91,$88),($02,$4c,$25,$f5),
 ($e5,$d7,$fc,$4f),($2a,$cb,$d7,$c5),($35,$44,$80,$26),($62,$a3,$8f,$b5),
 ($b1,$5a,$49,$de),($ba,$1b,$67,$25),($ea,$0e,$98,$45),($fe,$c0,$e1,$5d),
 ($2f,$75,$02,$c3),($4c,$f0,$12,$81),($46,$97,$a3,$8d),($d3,$f9,$c6,$6b),
 ($8f,$5f,$e7,$03),($92,$9c,$95,$15),($6d,$7a,$eb,$bf),($52,$59,$da,$95),
 ($be,$83,$2d,$d4),($74,$21,$d3,$58),($e0,$69,$29,$49),($c9,$c8,$44,$8e),
 ($c2,$89,$6a,$75),($8e,$79,$78,$f4),($58,$3e,$6b,$99),($b9,$71,$dd,$27),
 ($e1,$4f,$b6,$be),($88,$ad,$17,$f0),($20,$ac,$66,$c9),($ce,$3a,$b4,$7d),
 ($df,$4a,$18,$63),($1a,$31,$82,$e5),($51,$33,$60,$97),($53,$7f,$45,$62),
 ($64,$77,$e0,$b1),($6b,$ae,$84,$bb),($81,$a0,$1c,$fe),($08,$2b,$94,$f9),
 ($48,$68,$58,$70),($45,$fd,$19,$8f),($de,$6c,$87,$94),($7b,$f8,$b7,$52),
 ($73,$d3,$23,$ab),($4b,$02,$e2,$72),($1f,$8f,$57,$e3),($55,$ab,$2a,$66),
 ($eb,$28,$07,$b2),($b5,$c2,$03,$2f),($c5,$7b,$9a,$86),($37,$08,$a5,$d3),
 ($28,$87,$f2,$30),($bf,$a5,$b2,$23),($03,$6a,$ba,$02),($16,$82,$5c,$ed),
 ($cf,$1c,$2b,$8a),($79,$b4,$92,$a7),($07,$f2,$f0,$f3),($69,$e2,$a1,$4e),
 ($da,$f4,$cd,$65),($05,$be,$d5,$06),($34,$62,$1f,$d1),($a6,$fe,$8a,$c4),
 ($2e,$53,$9d,$34),($f3,$55,$a0,$a2),($8a,$e1,$32,$05),($f6,$eb,$75,$a4),
 ($83,$ec,$39,$0b),($60,$ef,$aa,$40),($71,$9f,$06,$5e),($6e,$10,$51,$bd),
 ($21,$8a,$f9,$3e),($dd,$06,$3d,$96),($3e,$05,$ae,$dd),($e6,$bd,$46,$4d),
 ($54,$8d,$b5,$91),($c4,$5d,$05,$71),($06,$d4,$6f,$04),($50,$15,$ff,$60),
 ($98,$fb,$24,$19),($bd,$e9,$97,$d6),($40,$43,$cc,$89),($d9,$9e,$77,$67),
 ($e8,$42,$bd,$b0),($89,$8b,$88,$07),($19,$5b,$38,$e7),($c8,$ee,$db,$79),
 ($7c,$0a,$47,$a1),($42,$0f,$e9,$7c),($84,$1e,$c9,$f8),($00,$00,$00,$00),
 ($80,$86,$83,$09),($2b,$ed,$48,$32),($11,$70,$ac,$1e),($5a,$72,$4e,$6c),
 ($0e,$ff,$fb,$fd),($85,$38,$56,$0f),($ae,$d5,$1e,$3d),($2d,$39,$27,$36),
 ($0f,$d9,$64,$0a),($5c,$a6,$21,$68),($5b,$54,$d1,$9b),($36,$2e,$3a,$24),
 ($0a,$67,$b1,$0c),($57,$e7,$0f,$93),($ee,$96,$d2,$b4),($9b,$91,$9e,$1b),
 ($c0,$c5,$4f,$80),($dc,$20,$a2,$61),($77,$4b,$69,$5a),($12,$1a,$16,$1c),
 ($93,$ba,$0a,$e2),($a0,$2a,$e5,$c0),($22,$e0,$43,$3c),($1b,$17,$1d,$12),
 ($09,$0d,$0b,$0e),($8b,$c7,$ad,$f2),($b6,$a8,$b9,$2d),($1e,$a9,$c8,$14),
 ($f1,$19,$85,$57),($75,$07,$4c,$af),($99,$dd,$bb,$ee),($7f,$60,$fd,$a3),
 ($01,$26,$9f,$f7),($72,$f5,$bc,$5c),($66,$3b,$c5,$44),($fb,$7e,$34,$5b),
 ($43,$29,$76,$8b),($23,$c6,$dc,$cb),($ed,$fc,$68,$b6),($e4,$f1,$63,$b8),
 ($31,$dc,$ca,$d7),($63,$85,$10,$42),($97,$22,$40,$13),($c6,$11,$20,$84),
 ($4a,$24,$7d,$85),($bb,$3d,$f8,$d2),($f9,$32,$11,$ae),($29,$a1,$6d,$c7),
 ($9e,$2f,$4b,$1d),($b2,$30,$f3,$dc),($86,$52,$ec,$0d),($c1,$e3,$d0,$77),
 ($b3,$16,$6c,$2b),($70,$b9,$99,$a9),($94,$48,$fa,$11),($e9,$64,$22,$47),
 ($fc,$8c,$c4,$a8),($f0,$3f,$1a,$a0),($7d,$2c,$d8,$56),($33,$90,$ef,$22),
 ($49,$4e,$c7,$87),($38,$d1,$c1,$d9),($ca,$a2,$fe,$8c),($d4,$0b,$36,$98),
 ($f5,$81,$cf,$a6),($7a,$de,$28,$a5),($b7,$8e,$26,$da),($ad,$bf,$a4,$3f),
 ($3a,$9d,$e4,$2c),($78,$92,$0d,$50),($5f,$cc,$9b,$6a),($7e,$46,$62,$54),
 ($8d,$13,$c2,$f6),($d8,$b8,$e8,$90),($39,$f7,$5e,$2e),($c3,$af,$f5,$82),
 ($5d,$80,$be,$9f),($d0,$93,$7c,$69),($d5,$2d,$a9,$6f),($25,$12,$b3,$cf),
 ($ac,$99,$3b,$c8),($18,$7d,$a7,$10),($9c,$63,$6e,$e8),($3b,$bb,$7b,$db),
 ($26,$78,$09,$cd),($59,$18,$f4,$6e),($9a,$b7,$01,$ec),($4f,$9a,$a8,$83),
 ($95,$6e,$65,$e6),($ff,$e6,$7e,$aa),($bc,$cf,$08,$21),($15,$e8,$e6,$ef),
 ($e7,$9b,$d9,$ba),($6f,$36,$ce,$4a),($9f,$09,$d4,$ea),($b0,$7c,$d6,$29),
 ($a4,$b2,$af,$31),($3f,$23,$31,$2a),($a5,$94,$30,$c6),($a2,$66,$c0,$35),
 ($4e,$bc,$37,$74),($82,$ca,$a6,$fc),($90,$d0,$b0,$e0),($a7,$d8,$15,$33),
 ($04,$98,$4a,$f1),($ec,$da,$f7,$41),($cd,$50,$0e,$7f),($91,$f6,$2f,$17),
 ($4d,$d6,$8d,$76),($ef,$b0,$4d,$43),($aa,$4d,$54,$cc),($96,$04,$df,$e4),
 ($d1,$b5,$e3,$9e),($6a,$88,$1b,$4c),($2c,$1f,$b8,$c1),($65,$51,$7f,$46),
 ($5e,$ea,$04,$9d),($8c,$35,$5d,$01),($87,$74,$73,$fa),($0b,$41,$2e,$fb),
 ($67,$1d,$5a,$b3),($db,$d2,$52,$92),($10,$56,$33,$e9),($d6,$47,$13,$6d),
 ($d7,$61,$8c,$9a),($a1,$0c,$7a,$37),($f8,$14,$8e,$59),($13,$3c,$89,$eb),
 ($a9,$27,$ee,$ce),($61,$c9,$35,$b7),($1c,$e5,$ed,$e1),($47,$b1,$3c,$7a),
 ($d2,$df,$59,$9c),($f2,$73,$3f,$55),($14,$ce,$79,$18),($c7,$37,$bf,$73),
 ($f7,$cd,$ea,$53),($fd,$aa,$5b,$5f),($3d,$6f,$14,$df),($44,$db,$86,$78),
 ($af,$f3,$81,$ca),($68,$c4,$3e,$b9),($24,$34,$2c,$38),($a3,$40,$5f,$c2),
 ($1d,$c3,$72,$16),($e2,$25,$0c,$bc),($3c,$49,$8b,$28),($0d,$95,$41,$ff),
 ($a8,$01,$71,$39),($0c,$b3,$de,$08),($b4,$e4,$9c,$d8),($56,$c1,$90,$64),
 ($cb,$84,$61,$7b),($32,$b6,$70,$d5),($6c,$5c,$74,$48),($b8,$57,$42,$d0));
 S5:array[0..255] of byte=(
 $52,$09,$6a,$d5, $30,$36,$a5,$38, $bf,$40,$a3,$9e, $81,$f3,$d7,$fb,
 $7c,$e3,$39,$82, $9b,$2f,$ff,$87, $34,$8e,$43,$44, $c4,$de,$e9,$cb,
 $54,$7b,$94,$32, $a6,$c2,$23,$3d, $ee,$4c,$95,$0b, $42,$fa,$c3,$4e,
 $08,$2e,$a1,$66, $28,$d9,$24,$b2, $76,$5b,$a2,$49, $6d,$8b,$d1,$25,
 $72,$f8,$f6,$64, $86,$68,$98,$16, $d4,$a4,$5c,$cc, $5d,$65,$b6,$92,
 $6c,$70,$48,$50, $fd,$ed,$b9,$da, $5e,$15,$46,$57, $a7,$8d,$9d,$84,
 $90,$d8,$ab,$00, $8c,$bc,$d3,$0a, $f7,$e4,$58,$05, $b8,$b3,$45,$06,
 $d0,$2c,$1e,$8f, $ca,$3f,$0f,$02, $c1,$af,$bd,$03, $01,$13,$8a,$6b,
 $3a,$91,$11,$41, $4f,$67,$dc,$ea, $97,$f2,$cf,$ce, $f0,$b4,$e6,$73,
 $96,$ac,$74,$22, $e7,$ad,$35,$85, $e2,$f9,$37,$e8, $1c,$75,$df,$6e,
 $47,$f1,$1a,$71, $1d,$29,$c5,$89, $6f,$b7,$62,$0e, $aa,$18,$be,$1b,
 $fc,$56,$3e,$4b, $c6,$d2,$79,$20, $9a,$db,$c0,$fe, $78,$cd,$5a,$f4,
 $1f,$dd,$a8,$33, $88,$07,$c7,$31, $b1,$12,$10,$59, $27,$80,$ec,$5f,
 $60,$51,$7f,$a9, $19,$b5,$4a,$0d, $2d,$e5,$7a,$9f, $93,$c9,$9c,$ef,
 $a0,$e0,$3b,$4d, $ae,$2a,$f5,$b0, $c8,$eb,$bb,$3c, $83,$53,$99,$61,
 $17,$2b,$04,$7e, $ba,$77,$d6,$26, $e1,$69,$14,$63, $55,$21,$0c,$7d);
 U1:array[0..255,0..3] of byte=(
 ($00,$00,$00,$00),($0e,$09,$0d,$0b),($1c,$12,$1a,$16),($12,$1b,$17,$1d),
 ($38,$24,$34,$2c),($36,$2d,$39,$27),($24,$36,$2e,$3a),($2a,$3f,$23,$31),
 ($70,$48,$68,$58),($7e,$41,$65,$53),($6c,$5a,$72,$4e),($62,$53,$7f,$45),
 ($48,$6c,$5c,$74),($46,$65,$51,$7f),($54,$7e,$46,$62),($5a,$77,$4b,$69),
 ($e0,$90,$d0,$b0),($ee,$99,$dd,$bb),($fc,$82,$ca,$a6),($f2,$8b,$c7,$ad),
 ($d8,$b4,$e4,$9c),($d6,$bd,$e9,$97),($c4,$a6,$fe,$8a),($ca,$af,$f3,$81),
 ($90,$d8,$b8,$e8),($9e,$d1,$b5,$e3),($8c,$ca,$a2,$fe),($82,$c3,$af,$f5),
 ($a8,$fc,$8c,$c4),($a6,$f5,$81,$cf),($b4,$ee,$96,$d2),($ba,$e7,$9b,$d9),
 ($db,$3b,$bb,$7b),($d5,$32,$b6,$70),($c7,$29,$a1,$6d),($c9,$20,$ac,$66),
 ($e3,$1f,$8f,$57),($ed,$16,$82,$5c),($ff,$0d,$95,$41),($f1,$04,$98,$4a),
 ($ab,$73,$d3,$23),($a5,$7a,$de,$28),($b7,$61,$c9,$35),($b9,$68,$c4,$3e),
 ($93,$57,$e7,$0f),($9d,$5e,$ea,$04),($8f,$45,$fd,$19),($81,$4c,$f0,$12),
 ($3b,$ab,$6b,$cb),($35,$a2,$66,$c0),($27,$b9,$71,$dd),($29,$b0,$7c,$d6),
 ($03,$8f,$5f,$e7),($0d,$86,$52,$ec),($1f,$9d,$45,$f1),($11,$94,$48,$fa),
 ($4b,$e3,$03,$93),($45,$ea,$0e,$98),($57,$f1,$19,$85),($59,$f8,$14,$8e),
 ($73,$c7,$37,$bf),($7d,$ce,$3a,$b4),($6f,$d5,$2d,$a9),($61,$dc,$20,$a2),
 ($ad,$76,$6d,$f6),($a3,$7f,$60,$fd),($b1,$64,$77,$e0),($bf,$6d,$7a,$eb),
 ($95,$52,$59,$da),($9b,$5b,$54,$d1),($89,$40,$43,$cc),($87,$49,$4e,$c7),
 ($dd,$3e,$05,$ae),($d3,$37,$08,$a5),($c1,$2c,$1f,$b8),($cf,$25,$12,$b3),
 ($e5,$1a,$31,$82),($eb,$13,$3c,$89),($f9,$08,$2b,$94),($f7,$01,$26,$9f),
 ($4d,$e6,$bd,$46),($43,$ef,$b0,$4d),($51,$f4,$a7,$50),($5f,$fd,$aa,$5b),
 ($75,$c2,$89,$6a),($7b,$cb,$84,$61),($69,$d0,$93,$7c),($67,$d9,$9e,$77),
 ($3d,$ae,$d5,$1e),($33,$a7,$d8,$15),($21,$bc,$cf,$08),($2f,$b5,$c2,$03),
 ($05,$8a,$e1,$32),($0b,$83,$ec,$39),($19,$98,$fb,$24),($17,$91,$f6,$2f),
 ($76,$4d,$d6,$8d),($78,$44,$db,$86),($6a,$5f,$cc,$9b),($64,$56,$c1,$90),
 ($4e,$69,$e2,$a1),($40,$60,$ef,$aa),($52,$7b,$f8,$b7),($5c,$72,$f5,$bc),
 ($06,$05,$be,$d5),($08,$0c,$b3,$de),($1a,$17,$a4,$c3),($14,$1e,$a9,$c8),
 ($3e,$21,$8a,$f9),($30,$28,$87,$f2),($22,$33,$90,$ef),($2c,$3a,$9d,$e4),
 ($96,$dd,$06,$3d),($98,$d4,$0b,$36),($8a,$cf,$1c,$2b),($84,$c6,$11,$20),
 ($ae,$f9,$32,$11),($a0,$f0,$3f,$1a),($b2,$eb,$28,$07),($bc,$e2,$25,$0c),
 ($e6,$95,$6e,$65),($e8,$9c,$63,$6e),($fa,$87,$74,$73),($f4,$8e,$79,$78),
 ($de,$b1,$5a,$49),($d0,$b8,$57,$42),($c2,$a3,$40,$5f),($cc,$aa,$4d,$54),
 ($41,$ec,$da,$f7),($4f,$e5,$d7,$fc),($5d,$fe,$c0,$e1),($53,$f7,$cd,$ea),
 ($79,$c8,$ee,$db),($77,$c1,$e3,$d0),($65,$da,$f4,$cd),($6b,$d3,$f9,$c6),
 ($31,$a4,$b2,$af),($3f,$ad,$bf,$a4),($2d,$b6,$a8,$b9),($23,$bf,$a5,$b2),
 ($09,$80,$86,$83),($07,$89,$8b,$88),($15,$92,$9c,$95),($1b,$9b,$91,$9e),
 ($a1,$7c,$0a,$47),($af,$75,$07,$4c),($bd,$6e,$10,$51),($b3,$67,$1d,$5a),
 ($99,$58,$3e,$6b),($97,$51,$33,$60),($85,$4a,$24,$7d),($8b,$43,$29,$76),
 ($d1,$34,$62,$1f),($df,$3d,$6f,$14),($cd,$26,$78,$09),($c3,$2f,$75,$02),
 ($e9,$10,$56,$33),($e7,$19,$5b,$38),($f5,$02,$4c,$25),($fb,$0b,$41,$2e),
 ($9a,$d7,$61,$8c),($94,$de,$6c,$87),($86,$c5,$7b,$9a),($88,$cc,$76,$91),
 ($a2,$f3,$55,$a0),($ac,$fa,$58,$ab),($be,$e1,$4f,$b6),($b0,$e8,$42,$bd),
 ($ea,$9f,$09,$d4),($e4,$96,$04,$df),($f6,$8d,$13,$c2),($f8,$84,$1e,$c9),
 ($d2,$bb,$3d,$f8),($dc,$b2,$30,$f3),($ce,$a9,$27,$ee),($c0,$a0,$2a,$e5),
 ($7a,$47,$b1,$3c),($74,$4e,$bc,$37),($66,$55,$ab,$2a),($68,$5c,$a6,$21),
 ($42,$63,$85,$10),($4c,$6a,$88,$1b),($5e,$71,$9f,$06),($50,$78,$92,$0d),
 ($0a,$0f,$d9,$64),($04,$06,$d4,$6f),($16,$1d,$c3,$72),($18,$14,$ce,$79),
 ($32,$2b,$ed,$48),($3c,$22,$e0,$43),($2e,$39,$f7,$5e),($20,$30,$fa,$55),
 ($ec,$9a,$b7,$01),($e2,$93,$ba,$0a),($f0,$88,$ad,$17),($fe,$81,$a0,$1c),
 ($d4,$be,$83,$2d),($da,$b7,$8e,$26),($c8,$ac,$99,$3b),($c6,$a5,$94,$30),
 ($9c,$d2,$df,$59),($92,$db,$d2,$52),($80,$c0,$c5,$4f),($8e,$c9,$c8,$44),
 ($a4,$f6,$eb,$75),($aa,$ff,$e6,$7e),($b8,$e4,$f1,$63),($b6,$ed,$fc,$68),
 ($0c,$0a,$67,$b1),($02,$03,$6a,$ba),($10,$18,$7d,$a7),($1e,$11,$70,$ac),
 ($34,$2e,$53,$9d),($3a,$27,$5e,$96),($28,$3c,$49,$8b),($26,$35,$44,$80),
 ($7c,$42,$0f,$e9),($72,$4b,$02,$e2),($60,$50,$15,$ff),($6e,$59,$18,$f4),
 ($44,$66,$3b,$c5),($4a,$6f,$36,$ce),($58,$74,$21,$d3),($56,$7d,$2c,$d8),
 ($37,$a1,$0c,$7a),($39,$a8,$01,$71),($2b,$b3,$16,$6c),($25,$ba,$1b,$67),
 ($0f,$85,$38,$56),($01,$8c,$35,$5d),($13,$97,$22,$40),($1d,$9e,$2f,$4b),
 ($47,$e9,$64,$22),($49,$e0,$69,$29),($5b,$fb,$7e,$34),($55,$f2,$73,$3f),
 ($7f,$cd,$50,$0e),($71,$c4,$5d,$05),($63,$df,$4a,$18),($6d,$d6,$47,$13),
 ($d7,$31,$dc,$ca),($d9,$38,$d1,$c1),($cb,$23,$c6,$dc),($c5,$2a,$cb,$d7),
 ($ef,$15,$e8,$e6),($e1,$1c,$e5,$ed),($f3,$07,$f2,$f0),($fd,$0e,$ff,$fb),
 ($a7,$79,$b4,$92),($a9,$70,$b9,$99),($bb,$6b,$ae,$84),($b5,$62,$a3,$8f),
 ($9f,$5d,$80,$be),($91,$54,$8d,$b5),($83,$4f,$9a,$a8),($8d,$46,$97,$a3));
 U2:array[0..255,0..3] of byte=(
 ($00,$00,$00,$00),($0b,$0e,$09,$0d),($16,$1c,$12,$1a),($1d,$12,$1b,$17),
 ($2c,$38,$24,$34),($27,$36,$2d,$39),($3a,$24,$36,$2e),($31,$2a,$3f,$23),
 ($58,$70,$48,$68),($53,$7e,$41,$65),($4e,$6c,$5a,$72),($45,$62,$53,$7f),
 ($74,$48,$6c,$5c),($7f,$46,$65,$51),($62,$54,$7e,$46),($69,$5a,$77,$4b),
 ($b0,$e0,$90,$d0),($bb,$ee,$99,$dd),($a6,$fc,$82,$ca),($ad,$f2,$8b,$c7),
 ($9c,$d8,$b4,$e4),($97,$d6,$bd,$e9),($8a,$c4,$a6,$fe),($81,$ca,$af,$f3),
 ($e8,$90,$d8,$b8),($e3,$9e,$d1,$b5),($fe,$8c,$ca,$a2),($f5,$82,$c3,$af),
 ($c4,$a8,$fc,$8c),($cf,$a6,$f5,$81),($d2,$b4,$ee,$96),($d9,$ba,$e7,$9b),
 ($7b,$db,$3b,$bb),($70,$d5,$32,$b6),($6d,$c7,$29,$a1),($66,$c9,$20,$ac),
 ($57,$e3,$1f,$8f),($5c,$ed,$16,$82),($41,$ff,$0d,$95),($4a,$f1,$04,$98),
 ($23,$ab,$73,$d3),($28,$a5,$7a,$de),($35,$b7,$61,$c9),($3e,$b9,$68,$c4),
 ($0f,$93,$57,$e7),($04,$9d,$5e,$ea),($19,$8f,$45,$fd),($12,$81,$4c,$f0),
 ($cb,$3b,$ab,$6b),($c0,$35,$a2,$66),($dd,$27,$b9,$71),($d6,$29,$b0,$7c),
 ($e7,$03,$8f,$5f),($ec,$0d,$86,$52),($f1,$1f,$9d,$45),($fa,$11,$94,$48),
 ($93,$4b,$e3,$03),($98,$45,$ea,$0e),($85,$57,$f1,$19),($8e,$59,$f8,$14),
 ($bf,$73,$c7,$37),($b4,$7d,$ce,$3a),($a9,$6f,$d5,$2d),($a2,$61,$dc,$20),
 ($f6,$ad,$76,$6d),($fd,$a3,$7f,$60),($e0,$b1,$64,$77),($eb,$bf,$6d,$7a),
 ($da,$95,$52,$59),($d1,$9b,$5b,$54),($cc,$89,$40,$43),($c7,$87,$49,$4e),
 ($ae,$dd,$3e,$05),($a5,$d3,$37,$08),($b8,$c1,$2c,$1f),($b3,$cf,$25,$12),
 ($82,$e5,$1a,$31),($89,$eb,$13,$3c),($94,$f9,$08,$2b),($9f,$f7,$01,$26),
 ($46,$4d,$e6,$bd),($4d,$43,$ef,$b0),($50,$51,$f4,$a7),($5b,$5f,$fd,$aa),
 ($6a,$75,$c2,$89),($61,$7b,$cb,$84),($7c,$69,$d0,$93),($77,$67,$d9,$9e),
 ($1e,$3d,$ae,$d5),($15,$33,$a7,$d8),($08,$21,$bc,$cf),($03,$2f,$b5,$c2),
 ($32,$05,$8a,$e1),($39,$0b,$83,$ec),($24,$19,$98,$fb),($2f,$17,$91,$f6),
 ($8d,$76,$4d,$d6),($86,$78,$44,$db),($9b,$6a,$5f,$cc),($90,$64,$56,$c1),
 ($a1,$4e,$69,$e2),($aa,$40,$60,$ef),($b7,$52,$7b,$f8),($bc,$5c,$72,$f5),
 ($d5,$06,$05,$be),($de,$08,$0c,$b3),($c3,$1a,$17,$a4),($c8,$14,$1e,$a9),
 ($f9,$3e,$21,$8a),($f2,$30,$28,$87),($ef,$22,$33,$90),($e4,$2c,$3a,$9d),
 ($3d,$96,$dd,$06),($36,$98,$d4,$0b),($2b,$8a,$cf,$1c),($20,$84,$c6,$11),
 ($11,$ae,$f9,$32),($1a,$a0,$f0,$3f),($07,$b2,$eb,$28),($0c,$bc,$e2,$25),
 ($65,$e6,$95,$6e),($6e,$e8,$9c,$63),($73,$fa,$87,$74),($78,$f4,$8e,$79),
 ($49,$de,$b1,$5a),($42,$d0,$b8,$57),($5f,$c2,$a3,$40),($54,$cc,$aa,$4d),
 ($f7,$41,$ec,$da),($fc,$4f,$e5,$d7),($e1,$5d,$fe,$c0),($ea,$53,$f7,$cd),
 ($db,$79,$c8,$ee),($d0,$77,$c1,$e3),($cd,$65,$da,$f4),($c6,$6b,$d3,$f9),
 ($af,$31,$a4,$b2),($a4,$3f,$ad,$bf),($b9,$2d,$b6,$a8),($b2,$23,$bf,$a5),
 ($83,$09,$80,$86),($88,$07,$89,$8b),($95,$15,$92,$9c),($9e,$1b,$9b,$91),
 ($47,$a1,$7c,$0a),($4c,$af,$75,$07),($51,$bd,$6e,$10),($5a,$b3,$67,$1d),
 ($6b,$99,$58,$3e),($60,$97,$51,$33),($7d,$85,$4a,$24),($76,$8b,$43,$29),
 ($1f,$d1,$34,$62),($14,$df,$3d,$6f),($09,$cd,$26,$78),($02,$c3,$2f,$75),
 ($33,$e9,$10,$56),($38,$e7,$19,$5b),($25,$f5,$02,$4c),($2e,$fb,$0b,$41),
 ($8c,$9a,$d7,$61),($87,$94,$de,$6c),($9a,$86,$c5,$7b),($91,$88,$cc,$76),
 ($a0,$a2,$f3,$55),($ab,$ac,$fa,$58),($b6,$be,$e1,$4f),($bd,$b0,$e8,$42),
 ($d4,$ea,$9f,$09),($df,$e4,$96,$04),($c2,$f6,$8d,$13),($c9,$f8,$84,$1e),
 ($f8,$d2,$bb,$3d),($f3,$dc,$b2,$30),($ee,$ce,$a9,$27),($e5,$c0,$a0,$2a),
 ($3c,$7a,$47,$b1),($37,$74,$4e,$bc),($2a,$66,$55,$ab),($21,$68,$5c,$a6),
 ($10,$42,$63,$85),($1b,$4c,$6a,$88),($06,$5e,$71,$9f),($0d,$50,$78,$92),
 ($64,$0a,$0f,$d9),($6f,$04,$06,$d4),($72,$16,$1d,$c3),($79,$18,$14,$ce),
 ($48,$32,$2b,$ed),($43,$3c,$22,$e0),($5e,$2e,$39,$f7),($55,$20,$30,$fa),
 ($01,$ec,$9a,$b7),($0a,$e2,$93,$ba),($17,$f0,$88,$ad),($1c,$fe,$81,$a0),
 ($2d,$d4,$be,$83),($26,$da,$b7,$8e),($3b,$c8,$ac,$99),($30,$c6,$a5,$94),
 ($59,$9c,$d2,$df),($52,$92,$db,$d2),($4f,$80,$c0,$c5),($44,$8e,$c9,$c8),
 ($75,$a4,$f6,$eb),($7e,$aa,$ff,$e6),($63,$b8,$e4,$f1),($68,$b6,$ed,$fc),
 ($b1,$0c,$0a,$67),($ba,$02,$03,$6a),($a7,$10,$18,$7d),($ac,$1e,$11,$70),
 ($9d,$34,$2e,$53),($96,$3a,$27,$5e),($8b,$28,$3c,$49),($80,$26,$35,$44),
 ($e9,$7c,$42,$0f),($e2,$72,$4b,$02),($ff,$60,$50,$15),($f4,$6e,$59,$18),
 ($c5,$44,$66,$3b),($ce,$4a,$6f,$36),($d3,$58,$74,$21),($d8,$56,$7d,$2c),
 ($7a,$37,$a1,$0c),($71,$39,$a8,$01),($6c,$2b,$b3,$16),($67,$25,$ba,$1b),
 ($56,$0f,$85,$38),($5d,$01,$8c,$35),($40,$13,$97,$22),($4b,$1d,$9e,$2f),
 ($22,$47,$e9,$64),($29,$49,$e0,$69),($34,$5b,$fb,$7e),($3f,$55,$f2,$73),
 ($0e,$7f,$cd,$50),($05,$71,$c4,$5d),($18,$63,$df,$4a),($13,$6d,$d6,$47),
 ($ca,$d7,$31,$dc),($c1,$d9,$38,$d1),($dc,$cb,$23,$c6),($d7,$c5,$2a,$cb),
 ($e6,$ef,$15,$e8),($ed,$e1,$1c,$e5),($f0,$f3,$07,$f2),($fb,$fd,$0e,$ff),
 ($92,$a7,$79,$b4),($99,$a9,$70,$b9),($84,$bb,$6b,$ae),($8f,$b5,$62,$a3),
 ($be,$9f,$5d,$80),($b5,$91,$54,$8d),($a8,$83,$4f,$9a),($a3,$8d,$46,$97));
 U3:array[0..255,0..3] of byte=(
 ($00,$00,$00,$00),($0d,$0b,$0e,$09),($1a,$16,$1c,$12),($17,$1d,$12,$1b),
 ($34,$2c,$38,$24),($39,$27,$36,$2d),($2e,$3a,$24,$36),($23,$31,$2a,$3f),
 ($68,$58,$70,$48),($65,$53,$7e,$41),($72,$4e,$6c,$5a),($7f,$45,$62,$53),
 ($5c,$74,$48,$6c),($51,$7f,$46,$65),($46,$62,$54,$7e),($4b,$69,$5a,$77),
 ($d0,$b0,$e0,$90),($dd,$bb,$ee,$99),($ca,$a6,$fc,$82),($c7,$ad,$f2,$8b),
 ($e4,$9c,$d8,$b4),($e9,$97,$d6,$bd),($fe,$8a,$c4,$a6),($f3,$81,$ca,$af),
 ($b8,$e8,$90,$d8),($b5,$e3,$9e,$d1),($a2,$fe,$8c,$ca),($af,$f5,$82,$c3),
 ($8c,$c4,$a8,$fc),($81,$cf,$a6,$f5),($96,$d2,$b4,$ee),($9b,$d9,$ba,$e7),
 ($bb,$7b,$db,$3b),($b6,$70,$d5,$32),($a1,$6d,$c7,$29),($ac,$66,$c9,$20),
 ($8f,$57,$e3,$1f),($82,$5c,$ed,$16),($95,$41,$ff,$0d),($98,$4a,$f1,$04),
 ($d3,$23,$ab,$73),($de,$28,$a5,$7a),($c9,$35,$b7,$61),($c4,$3e,$b9,$68),
 ($e7,$0f,$93,$57),($ea,$04,$9d,$5e),($fd,$19,$8f,$45),($f0,$12,$81,$4c),
 ($6b,$cb,$3b,$ab),($66,$c0,$35,$a2),($71,$dd,$27,$b9),($7c,$d6,$29,$b0),
 ($5f,$e7,$03,$8f),($52,$ec,$0d,$86),($45,$f1,$1f,$9d),($48,$fa,$11,$94),
 ($03,$93,$4b,$e3),($0e,$98,$45,$ea),($19,$85,$57,$f1),($14,$8e,$59,$f8),
 ($37,$bf,$73,$c7),($3a,$b4,$7d,$ce),($2d,$a9,$6f,$d5),($20,$a2,$61,$dc),
 ($6d,$f6,$ad,$76),($60,$fd,$a3,$7f),($77,$e0,$b1,$64),($7a,$eb,$bf,$6d),
 ($59,$da,$95,$52),($54,$d1,$9b,$5b),($43,$cc,$89,$40),($4e,$c7,$87,$49),
 ($05,$ae,$dd,$3e),($08,$a5,$d3,$37),($1f,$b8,$c1,$2c),($12,$b3,$cf,$25),
 ($31,$82,$e5,$1a),($3c,$89,$eb,$13),($2b,$94,$f9,$08),($26,$9f,$f7,$01),
 ($bd,$46,$4d,$e6),($b0,$4d,$43,$ef),($a7,$50,$51,$f4),($aa,$5b,$5f,$fd),
 ($89,$6a,$75,$c2),($84,$61,$7b,$cb),($93,$7c,$69,$d0),($9e,$77,$67,$d9),
 ($d5,$1e,$3d,$ae),($d8,$15,$33,$a7),($cf,$08,$21,$bc),($c2,$03,$2f,$b5),
 ($e1,$32,$05,$8a),($ec,$39,$0b,$83),($fb,$24,$19,$98),($f6,$2f,$17,$91),
 ($d6,$8d,$76,$4d),($db,$86,$78,$44),($cc,$9b,$6a,$5f),($c1,$90,$64,$56),
 ($e2,$a1,$4e,$69),($ef,$aa,$40,$60),($f8,$b7,$52,$7b),($f5,$bc,$5c,$72),
 ($be,$d5,$06,$05),($b3,$de,$08,$0c),($a4,$c3,$1a,$17),($a9,$c8,$14,$1e),
 ($8a,$f9,$3e,$21),($87,$f2,$30,$28),($90,$ef,$22,$33),($9d,$e4,$2c,$3a),
 ($06,$3d,$96,$dd),($0b,$36,$98,$d4),($1c,$2b,$8a,$cf),($11,$20,$84,$c6),
 ($32,$11,$ae,$f9),($3f,$1a,$a0,$f0),($28,$07,$b2,$eb),($25,$0c,$bc,$e2),
 ($6e,$65,$e6,$95),($63,$6e,$e8,$9c),($74,$73,$fa,$87),($79,$78,$f4,$8e),
 ($5a,$49,$de,$b1),($57,$42,$d0,$b8),($40,$5f,$c2,$a3),($4d,$54,$cc,$aa),
 ($da,$f7,$41,$ec),($d7,$fc,$4f,$e5),($c0,$e1,$5d,$fe),($cd,$ea,$53,$f7),
 ($ee,$db,$79,$c8),($e3,$d0,$77,$c1),($f4,$cd,$65,$da),($f9,$c6,$6b,$d3),
 ($b2,$af,$31,$a4),($bf,$a4,$3f,$ad),($a8,$b9,$2d,$b6),($a5,$b2,$23,$bf),
 ($86,$83,$09,$80),($8b,$88,$07,$89),($9c,$95,$15,$92),($91,$9e,$1b,$9b),
 ($0a,$47,$a1,$7c),($07,$4c,$af,$75),($10,$51,$bd,$6e),($1d,$5a,$b3,$67),
 ($3e,$6b,$99,$58),($33,$60,$97,$51),($24,$7d,$85,$4a),($29,$76,$8b,$43),
 ($62,$1f,$d1,$34),($6f,$14,$df,$3d),($78,$09,$cd,$26),($75,$02,$c3,$2f),
 ($56,$33,$e9,$10),($5b,$38,$e7,$19),($4c,$25,$f5,$02),($41,$2e,$fb,$0b),
 ($61,$8c,$9a,$d7),($6c,$87,$94,$de),($7b,$9a,$86,$c5),($76,$91,$88,$cc),
 ($55,$a0,$a2,$f3),($58,$ab,$ac,$fa),($4f,$b6,$be,$e1),($42,$bd,$b0,$e8),
 ($09,$d4,$ea,$9f),($04,$df,$e4,$96),($13,$c2,$f6,$8d),($1e,$c9,$f8,$84),
 ($3d,$f8,$d2,$bb),($30,$f3,$dc,$b2),($27,$ee,$ce,$a9),($2a,$e5,$c0,$a0),
 ($b1,$3c,$7a,$47),($bc,$37,$74,$4e),($ab,$2a,$66,$55),($a6,$21,$68,$5c),
 ($85,$10,$42,$63),($88,$1b,$4c,$6a),($9f,$06,$5e,$71),($92,$0d,$50,$78),
 ($d9,$64,$0a,$0f),($d4,$6f,$04,$06),($c3,$72,$16,$1d),($ce,$79,$18,$14),
 ($ed,$48,$32,$2b),($e0,$43,$3c,$22),($f7,$5e,$2e,$39),($fa,$55,$20,$30),
 ($b7,$01,$ec,$9a),($ba,$0a,$e2,$93),($ad,$17,$f0,$88),($a0,$1c,$fe,$81),
 ($83,$2d,$d4,$be),($8e,$26,$da,$b7),($99,$3b,$c8,$ac),($94,$30,$c6,$a5),
 ($df,$59,$9c,$d2),($d2,$52,$92,$db),($c5,$4f,$80,$c0),($c8,$44,$8e,$c9),
 ($eb,$75,$a4,$f6),($e6,$7e,$aa,$ff),($f1,$63,$b8,$e4),($fc,$68,$b6,$ed),
 ($67,$b1,$0c,$0a),($6a,$ba,$02,$03),($7d,$a7,$10,$18),($70,$ac,$1e,$11),
 ($53,$9d,$34,$2e),($5e,$96,$3a,$27),($49,$8b,$28,$3c),($44,$80,$26,$35),
 ($0f,$e9,$7c,$42),($02,$e2,$72,$4b),($15,$ff,$60,$50),($18,$f4,$6e,$59),
 ($3b,$c5,$44,$66),($36,$ce,$4a,$6f),($21,$d3,$58,$74),($2c,$d8,$56,$7d),
 ($0c,$7a,$37,$a1),($01,$71,$39,$a8),($16,$6c,$2b,$b3),($1b,$67,$25,$ba),
 ($38,$56,$0f,$85),($35,$5d,$01,$8c),($22,$40,$13,$97),($2f,$4b,$1d,$9e),
 ($64,$22,$47,$e9),($69,$29,$49,$e0),($7e,$34,$5b,$fb),($73,$3f,$55,$f2),
 ($50,$0e,$7f,$cd),($5d,$05,$71,$c4),($4a,$18,$63,$df),($47,$13,$6d,$d6),
 ($dc,$ca,$d7,$31),($d1,$c1,$d9,$38),($c6,$dc,$cb,$23),($cb,$d7,$c5,$2a),
 ($e8,$e6,$ef,$15),($e5,$ed,$e1,$1c),($f2,$f0,$f3,$07),($ff,$fb,$fd,$0e),
 ($b4,$92,$a7,$79),($b9,$99,$a9,$70),($ae,$84,$bb,$6b),($a3,$8f,$b5,$62),
 ($80,$be,$9f,$5d),($8d,$b5,$91,$54),($9a,$a8,$83,$4f),($97,$a3,$8d,$46));
 U4:array[0..255,0..3] of byte=(
 ($00,$00,$00,$00),($09,$0d,$0b,$0e),($12,$1a,$16,$1c),($1b,$17,$1d,$12),
 ($24,$34,$2c,$38),($2d,$39,$27,$36),($36,$2e,$3a,$24),($3f,$23,$31,$2a),
 ($48,$68,$58,$70),($41,$65,$53,$7e),($5a,$72,$4e,$6c),($53,$7f,$45,$62),
 ($6c,$5c,$74,$48),($65,$51,$7f,$46),($7e,$46,$62,$54),($77,$4b,$69,$5a),
 ($90,$d0,$b0,$e0),($99,$dd,$bb,$ee),($82,$ca,$a6,$fc),($8b,$c7,$ad,$f2),
 ($b4,$e4,$9c,$d8),($bd,$e9,$97,$d6),($a6,$fe,$8a,$c4),($af,$f3,$81,$ca),
 ($d8,$b8,$e8,$90),($d1,$b5,$e3,$9e),($ca,$a2,$fe,$8c),($c3,$af,$f5,$82),
 ($fc,$8c,$c4,$a8),($f5,$81,$cf,$a6),($ee,$96,$d2,$b4),($e7,$9b,$d9,$ba),
 ($3b,$bb,$7b,$db),($32,$b6,$70,$d5),($29,$a1,$6d,$c7),($20,$ac,$66,$c9),
 ($1f,$8f,$57,$e3),($16,$82,$5c,$ed),($0d,$95,$41,$ff),($04,$98,$4a,$f1),
 ($73,$d3,$23,$ab),($7a,$de,$28,$a5),($61,$c9,$35,$b7),($68,$c4,$3e,$b9),
 ($57,$e7,$0f,$93),($5e,$ea,$04,$9d),($45,$fd,$19,$8f),($4c,$f0,$12,$81),
 ($ab,$6b,$cb,$3b),($a2,$66,$c0,$35),($b9,$71,$dd,$27),($b0,$7c,$d6,$29),
 ($8f,$5f,$e7,$03),($86,$52,$ec,$0d),($9d,$45,$f1,$1f),($94,$48,$fa,$11),
 ($e3,$03,$93,$4b),($ea,$0e,$98,$45),($f1,$19,$85,$57),($f8,$14,$8e,$59),
 ($c7,$37,$bf,$73),($ce,$3a,$b4,$7d),($d5,$2d,$a9,$6f),($dc,$20,$a2,$61),
 ($76,$6d,$f6,$ad),($7f,$60,$fd,$a3),($64,$77,$e0,$b1),($6d,$7a,$eb,$bf),
 ($52,$59,$da,$95),($5b,$54,$d1,$9b),($40,$43,$cc,$89),($49,$4e,$c7,$87),
 ($3e,$05,$ae,$dd),($37,$08,$a5,$d3),($2c,$1f,$b8,$c1),($25,$12,$b3,$cf),
 ($1a,$31,$82,$e5),($13,$3c,$89,$eb),($08,$2b,$94,$f9),($01,$26,$9f,$f7),
 ($e6,$bd,$46,$4d),($ef,$b0,$4d,$43),($f4,$a7,$50,$51),($fd,$aa,$5b,$5f),
 ($c2,$89,$6a,$75),($cb,$84,$61,$7b),($d0,$93,$7c,$69),($d9,$9e,$77,$67),
 ($ae,$d5,$1e,$3d),($a7,$d8,$15,$33),($bc,$cf,$08,$21),($b5,$c2,$03,$2f),
 ($8a,$e1,$32,$05),($83,$ec,$39,$0b),($98,$fb,$24,$19),($91,$f6,$2f,$17),
 ($4d,$d6,$8d,$76),($44,$db,$86,$78),($5f,$cc,$9b,$6a),($56,$c1,$90,$64),
 ($69,$e2,$a1,$4e),($60,$ef,$aa,$40),($7b,$f8,$b7,$52),($72,$f5,$bc,$5c),
 ($05,$be,$d5,$06),($0c,$b3,$de,$08),($17,$a4,$c3,$1a),($1e,$a9,$c8,$14),
 ($21,$8a,$f9,$3e),($28,$87,$f2,$30),($33,$90,$ef,$22),($3a,$9d,$e4,$2c),
 ($dd,$06,$3d,$96),($d4,$0b,$36,$98),($cf,$1c,$2b,$8a),($c6,$11,$20,$84),
 ($f9,$32,$11,$ae),($f0,$3f,$1a,$a0),($eb,$28,$07,$b2),($e2,$25,$0c,$bc),
 ($95,$6e,$65,$e6),($9c,$63,$6e,$e8),($87,$74,$73,$fa),($8e,$79,$78,$f4),
 ($b1,$5a,$49,$de),($b8,$57,$42,$d0),($a3,$40,$5f,$c2),($aa,$4d,$54,$cc),
 ($ec,$da,$f7,$41),($e5,$d7,$fc,$4f),($fe,$c0,$e1,$5d),($f7,$cd,$ea,$53),
 ($c8,$ee,$db,$79),($c1,$e3,$d0,$77),($da,$f4,$cd,$65),($d3,$f9,$c6,$6b),
 ($a4,$b2,$af,$31),($ad,$bf,$a4,$3f),($b6,$a8,$b9,$2d),($bf,$a5,$b2,$23),
 ($80,$86,$83,$09),($89,$8b,$88,$07),($92,$9c,$95,$15),($9b,$91,$9e,$1b),
 ($7c,$0a,$47,$a1),($75,$07,$4c,$af),($6e,$10,$51,$bd),($67,$1d,$5a,$b3),
 ($58,$3e,$6b,$99),($51,$33,$60,$97),($4a,$24,$7d,$85),($43,$29,$76,$8b),
 ($34,$62,$1f,$d1),($3d,$6f,$14,$df),($26,$78,$09,$cd),($2f,$75,$02,$c3),
 ($10,$56,$33,$e9),($19,$5b,$38,$e7),($02,$4c,$25,$f5),($0b,$41,$2e,$fb),
 ($d7,$61,$8c,$9a),($de,$6c,$87,$94),($c5,$7b,$9a,$86),($cc,$76,$91,$88),
 ($f3,$55,$a0,$a2),($fa,$58,$ab,$ac),($e1,$4f,$b6,$be),($e8,$42,$bd,$b0),
 ($9f,$09,$d4,$ea),($96,$04,$df,$e4),($8d,$13,$c2,$f6),($84,$1e,$c9,$f8),
 ($bb,$3d,$f8,$d2),($b2,$30,$f3,$dc),($a9,$27,$ee,$ce),($a0,$2a,$e5,$c0),
 ($47,$b1,$3c,$7a),($4e,$bc,$37,$74),($55,$ab,$2a,$66),($5c,$a6,$21,$68),
 ($63,$85,$10,$42),($6a,$88,$1b,$4c),($71,$9f,$06,$5e),($78,$92,$0d,$50),
 ($0f,$d9,$64,$0a),($06,$d4,$6f,$04),($1d,$c3,$72,$16),($14,$ce,$79,$18),
 ($2b,$ed,$48,$32),($22,$e0,$43,$3c),($39,$f7,$5e,$2e),($30,$fa,$55,$20),
 ($9a,$b7,$01,$ec),($93,$ba,$0a,$e2),($88,$ad,$17,$f0),($81,$a0,$1c,$fe),
 ($be,$83,$2d,$d4),($b7,$8e,$26,$da),($ac,$99,$3b,$c8),($a5,$94,$30,$c6),
 ($d2,$df,$59,$9c),($db,$d2,$52,$92),($c0,$c5,$4f,$80),($c9,$c8,$44,$8e),
 ($f6,$eb,$75,$a4),($ff,$e6,$7e,$aa),($e4,$f1,$63,$b8),($ed,$fc,$68,$b6),
 ($0a,$67,$b1,$0c),($03,$6a,$ba,$02),($18,$7d,$a7,$10),($11,$70,$ac,$1e),
 ($2e,$53,$9d,$34),($27,$5e,$96,$3a),($3c,$49,$8b,$28),($35,$44,$80,$26),
 ($42,$0f,$e9,$7c),($4b,$02,$e2,$72),($50,$15,$ff,$60),($59,$18,$f4,$6e),
 ($66,$3b,$c5,$44),($6f,$36,$ce,$4a),($74,$21,$d3,$58),($7d,$2c,$d8,$56),
 ($a1,$0c,$7a,$37),($a8,$01,$71,$39),($b3,$16,$6c,$2b),($ba,$1b,$67,$25),
 ($85,$38,$56,$0f),($8c,$35,$5d,$01),($97,$22,$40,$13),($9e,$2f,$4b,$1d),
 ($e9,$64,$22,$47),($e0,$69,$29,$49),($fb,$7e,$34,$5b),($f2,$73,$3f,$55),
 ($cd,$50,$0e,$7f),($c4,$5d,$05,$71),($df,$4a,$18,$63),($d6,$47,$13,$6d),
 ($31,$dc,$ca,$d7),($38,$d1,$c1,$d9),($23,$c6,$dc,$cb),($2a,$cb,$d7,$c5),
 ($15,$e8,$e6,$ef),($1c,$e5,$ed,$e1),($07,$f2,$f0,$f3),($0e,$ff,$fb,$fd),
 ($79,$b4,$92,$a7),($70,$b9,$99,$a9),($6b,$ae,$84,$bb),($62,$a3,$8f,$b5),
 ($5d,$80,$be,$9f),($54,$8d,$b5,$91),($4f,$9a,$a8,$83),($46,$97,$a3,$8d));
  rcon:array[0..29] of word=(
 $01,$02,$04,$08,$10,$20,$40,$80,$1b,$36,$6c,$d8,$ab,$4d,$9a,
 $2f,$5e,$bc,$63,$c6,$97,$35,$6a,$d4,$b3,$7d,$fa,$ef,$c5,$91);

const
 MAXBC=8;
 MAXKC=8;

procedure RijndaelEncryptECB;
var
 r:longint;
 temp:array[0..MAXBC-1,0..3] of byte;
 a:array[0..MAXBC,0..3] of byte;
begin
 with Data do begin
  Move(InBlock,a,16);
  for r:=0 to (numrounds-2) do begin
   PDWord(@temp[0])^:=PDWord(@a[0])^ xor rk[r,0];
   PDWord(@temp[1])^:=PDWord(@a[1])^ xor rk[r,1];
   PDWord(@temp[2])^:=PDWord(@a[2])^ xor rk[r,2];
   PDWord(@temp[3])^:=PDWord(@a[3])^ xor rk[r,3];
   PDWord(@a[0])^:=PDWord(@T1[temp[0,0]])^ xor
                   PDWord(@T2[temp[1,1]])^ xor
                   PDWord(@T3[temp[2,2]])^ xor
                   PDWord(@T4[temp[3,3]])^;
   PDWord(@a[1])^:=PDWord(@T1[temp[1,0]])^ xor
                   PDWord(@T2[temp[2,1]])^ xor
                   PDWord(@T3[temp[3,2]])^ xor
                   PDWord(@T4[temp[0,3]])^;
   PDWord(@a[2])^:=PDWord(@T1[temp[2,0]])^ xor
                   PDWord(@T2[temp[3,1]])^ xor
                   PDWord(@T3[temp[0,2]])^ xor
                   PDWord(@T4[temp[1,3]])^;
   PDWord(@a[3])^:=PDWord(@T1[temp[3,0]])^ xor
                   PDWord(@T2[temp[0,1]])^ xor
                   PDWord(@T3[temp[1,2]])^ xor
                   PDWord(@T4[temp[2,3]])^;
  end;
  PDWord(@temp[0])^:=PDWord(@a[0])^ xor rk[numrounds-1,0];
  PDWord(@temp[1])^:=PDWord(@a[1])^ xor rk[numrounds-1,1];
  PDWord(@temp[2])^:=PDWord(@a[2])^ xor rk[numrounds-1,2];
  PDWord(@temp[3])^:=PDWord(@a[3])^ xor rk[numrounds-1,3];
  a[0,0]:=T1[temp[0,0],1];
  a[0,1]:=T1[temp[1,1],1];
  a[0,2]:=T1[temp[2,2],1];
  a[0,3]:=T1[temp[3,3],1];
  a[1,0]:=T1[temp[1,0],1];
  a[1,1]:=T1[temp[2,1],1];
  a[1,2]:=T1[temp[3,2],1];
  a[1,3]:=T1[temp[0,3],1];
  a[2,0]:=T1[temp[2,0],1];
  a[2,1]:=T1[temp[3,1],1];
  a[2,2]:=T1[temp[0,2],1];
  a[2,3]:=T1[temp[1,3],1];
  a[3,0]:=T1[temp[3,0],1];
  a[3,1]:=T1[temp[0,1],1];
  a[3,2]:=T1[temp[1,2],1];
  a[3,3]:=T1[temp[2,3],1];
  PDWord(@a[0])^:=PDWord(@a[0])^ xor rk[numrounds,0];
  PDWord(@a[1])^:=PDWord(@a[1])^ xor rk[numrounds,1];
  PDWord(@a[2])^:=PDWord(@a[2])^ xor rk[numrounds,2];
  PDWord(@a[3])^:=PDWord(@a[3])^ xor rk[numrounds,3];
  Move(a,OutBlock,16);
 end;
end;

procedure RijndaelDecryptECB;
var
 r:longint;
 temp:array[0..MAXBC-1,0..3] of byte;
 a:array[0..MAXBC,0..3] of byte;
begin
 with Data do begin
  Move(InBlock,a,16);
  for r:=NumRounds downto 2 do begin
   PDWord(@temp[0])^:=PDWord(@a[0])^ xor drk[r,0];
   PDWord(@temp[1])^:=PDWord(@a[1])^ xor drk[r,1];
   PDWord(@temp[2])^:=PDWord(@a[2])^ xor drk[r,2];
   PDWord(@temp[3])^:=PDWord(@a[3])^ xor drk[r,3];
   PDWord(@a[0])^:=PDWord(@T5[temp[0,0]])^ xor
                   PDWord(@T6[temp[3,1]])^ xor
                   PDWord(@T7[temp[2,2]])^ xor
                   PDWord(@T8[temp[1,3]])^;
   PDWord(@a[1])^:=PDWord(@T5[temp[1,0]])^ xor
                   PDWord(@T6[temp[0,1]])^ xor
                   PDWord(@T7[temp[3,2]])^ xor
                   PDWord(@T8[temp[2,3]])^;
   PDWord(@a[2])^:=PDWord(@T5[temp[2,0]])^ xor
                   PDWord(@T6[temp[1,1]])^ xor
                   PDWord(@T7[temp[0,2]])^ xor
                   PDWord(@T8[temp[3,3]])^;
   PDWord(@a[3])^:=PDWord(@T5[temp[3,0]])^ xor
                   PDWord(@T6[temp[2,1]])^ xor
                   PDWord(@T7[temp[1,2]])^ xor
                   PDWord(@T8[temp[0,3]])^;
  end;
  PDWord(@temp[0])^:=PDWord(@a[0])^ xor drk[1,0];
  PDWord(@temp[1])^:=PDWord(@a[1])^ xor drk[1,1];
  PDWord(@temp[2])^:=PDWord(@a[2])^ xor drk[1,2];
  PDWord(@temp[3])^:=PDWord(@a[3])^ xor drk[1,3];
  a[0,0]:=S5[temp[0,0]];
  a[0,1]:=S5[temp[3,1]];
  a[0,2]:=S5[temp[2,2]];
  a[0,3]:=S5[temp[1,3]];
  a[1,0]:=S5[temp[1,0]];
  a[1,1]:=S5[temp[0,1]];
  a[1,2]:=S5[temp[3,2]];
  a[1,3]:=S5[temp[2,3]];
  a[2,0]:=S5[temp[2,0]];
  a[2,1]:=S5[temp[1,1]];
  a[2,2]:=S5[temp[0,2]];
  a[2,3]:=S5[temp[3,3]];
  a[3,0]:=S5[temp[3,0]];
  a[3,1]:=S5[temp[2,1]];
  a[3,2]:=S5[temp[1,2]];
  a[3,3]:=S5[temp[0,3]];
  PDWord(@a[0])^:=PDWord(@a[0])^ xor drk[0,0];
  PDWord(@a[1])^:=PDWord(@a[1])^ xor drk[0,1];
  PDWord(@a[2])^:=PDWord(@a[2])^ xor drk[0,2];
  PDWord(@a[3])^:=PDWord(@a[3])^ xor drk[0,3];
  Move(a,OutBlock,16);
 end;
end;

procedure InvMixColumn(a:PByteArray;BC:byte);
var
 j:longint;
begin
 for j:=0 to (BC-1) do PDWord(@(a^[j*4]))^:=
  PDWord(@U1[a^[j*4+0]])^ xor
  PDWord(@U2[a^[j*4+1]])^ xor
  PDWord(@U3[a^[j*4+2]])^ xor
  PDWord(@U4[a^[j*4+3]])^;
end;

procedure RijndaelInit;
var
  KC,ROUNDS,j,r,t,rconpointer:longint;
  tk:array[0..MAXKC-1,0..3] of byte;
begin
 if (Size> 256) or (Size<=0) or ((Size mod 8)<> 0) then Exit;
 with Data do begin
  Size:=Size div 8;
  FillChar(tk,Sizeof(tk),0);
  Move(Key,tk,Size);
  if Size<=16 then begin
   KC:=4;
   Rounds:=10;
  end else if Size<=24 then begin
   KC:=6;
   Rounds:=12;
  end else begin
   KC:=8;
   Rounds:=14;
  end;
  numrounds:=rounds;
  r:=0;
  t:=0;
  j:=0;
  while (j<KC) and (r<(rounds+1)) do begin
   while (j<KC) and (t<BC) do begin
    rk[r,t]:=PDWord(@tk[j])^;
    Inc(j);
    Inc(t);
   end;
   if t=BC then begin
    t:=0;
    Inc(r);
   end;
  end;
  rconpointer:=0;
  while (r<(rounds+1)) do begin
   tk[0,0]:=tk[0,0] xor S[tk[KC-1,1]];
   tk[0,1]:=tk[0,1] xor S[tk[KC-1,2]];
   tk[0,2]:=tk[0,2] xor S[tk[KC-1,3]];
   tk[0,3]:=tk[0,3] xor S[tk[KC-1,0]];
   tk[0,0]:=tk[0,0] xor rcon[rconpointer];
   Inc(rconpointer);
   if KC<> 8 then begin
    for j:=1 to (KC-1) do
     PDWord(@tk[j])^:=PDWord(@tk[j])^ xor PDWord(@tk[j-1])^;
   end else begin
    for j:=1 to ((KC div 2)-1) do
     PDWord(@tk[j])^:=PDWord(@tk[j])^ xor PDWord(@tk[j-1])^;
    tk[KC div 2,0]:=tk[KC div 2,0] xor S[tk[KC div 2-1,0]];
    tk[KC div 2,1]:=tk[KC div 2,1] xor S[tk[KC div 2-1,1]];
    tk[KC div 2,2]:=tk[KC div 2,2] xor S[tk[KC div 2-1,2]];
    tk[KC div 2,3]:=tk[KC div 2,3] xor S[tk[KC div 2-1,3]];
    for j:=((KC div 2)+1) to (KC-1) do
      PDWord(@tk[j])^:=PDWord(@tk[j])^ xor PDWord(@tk[j-1])^;
   end;
   j:=0;
   while (j<KC) and (r<(rounds+1)) do begin
    while (j<KC) and (t<BC) do begin
     rk[r,t]:=PDWord(@tk[j])^;
     Inc(j);
     Inc(t);
    end;
    if t=BC then begin
     Inc(r);
     t:=0;
    end;
   end;
  end;
  Move(rk,drk,Sizeof(rk));
  for r:=1 to (numrounds-1) do InvMixColumn(@drk[r],BC);
  if IVector=nil then begin
   FillChar(IV,Sizeof(IV),$FF);
   RijndaelEncryptECB(Data,IV,IV);
   Move(IV,LB,Sizeof(LB));
  end else begin
   Move(IVector^,IV,Sizeof(IV));
   Move(IV,LB,Sizeof(IV));
  end;
 end;
end;

procedure RijndaelBurn;
begin
 with Data do begin
  FillChar(rk,Sizeof(rk),$FF);
  FillChar(drk,Sizeof(drk),$FF);
  FillChar(IV,Sizeof(IV),$FF);
  FillChar(LB,Sizeof(LB),$FF);
  NumRounds:=0;
 end;
end;

procedure RijndaelReset;
begin
 with Data do Move(IV,LB,Sizeof(LB));
end;

procedure RijndaelEncryptCBC;
var
 TB:array[0..15] of byte;
 i:longint;
begin
 with Data do begin
  for i:=1 to (Size div 16) do begin
   XorBlock(pointer(longint(@InData)+((i-1)*16)),@LB,@TB,Sizeof(TB));
   RijndaelEncryptECB(Data,TB,TB);
   Move(TB,pointer(longint(@OutData)+((i-1)*16))^,Sizeof(TB));
   Move(TB,LB,Sizeof(TB));
  end;
  if (Size mod 16)<> 0 then begin
   RijndaelEncryptECB(Data,LB,TB);
   XorBlock(@TB,@pointer(longint(@InData)+Size-(Size mod 16))^,@pointer(longint(@OutData)+Size-(Size mod 16))^,Size mod 16);
  end;
  FillChar(TB,Sizeof(TB),$FF);
 end;
end;

procedure RijndaelDecryptCBC;
var
 TB:array[0..15] of byte;
 i:longint;
begin
 with Data do begin
  for i:=1 to (Size div 16) do begin
   Move(pointer(longint(@InData)+((i-1)*16))^,TB,Sizeof(TB));
   RijndaelDecryptECB(Data,pointer(longint(@InData)+((i-1)*16))^,pointer(longint(@OutData)+((i-1)*16))^);
   XorBlock(@LB,pointer(longint(@OutData)+((i-1)*16)),pointer(longint(@OutData)+((i-1)*16)),Sizeof(TB));
   Move(TB,LB,Sizeof(TB));
  end;
  if (Size mod 16)<> 0 then begin
   RijndaelEncryptECB(Data,LB,TB);
   XorBlock(@TB,@pointer(longint(@InData)+Size-(Size mod 16))^,@pointer(longint(@OutData)+Size-(Size mod 16))^,Size mod 16);
  end;
  FillChar(TB,Sizeof(TB),$FF);
 end;
end;

procedure RijndaelEncryptCFB;
var
 i:longint;
 TB:array[0..15] of byte;
begin
 with Data do begin
  for i:=0 to Size-1 do begin
   RijndaelEncryptECB(Data,LB,TB);
   PByteArray(@OutData)^[i]:=PByteArray(@InData)^[i] xor TB[0];
   Move(LB[1],LB[0],15);
   LB[15]:=PByteArray(@OutData)^[i];
  end;
 end;
end;

procedure RijndaelDecryptCFB;
var
 i:longint;
 TB:array[0..15] of byte;
 b:byte;
begin
 with Data do begin
  for i:=0 to Size-1 do begin
   b:=PByteArray(@InData)^[i];
   RijndaelEncryptECB(Data,LB,TB);
   PByteArray(@OutData)^[i]:=PByteArray(@InData)^[i] xor TB[0];
   Move(LB[1],LB[0],15);
   LB[15]:=b;
  end;
 end;
end;

{** Startof: Cast128 **}

const
cast_sbox1: array[0..255]of DWord= (
 $30FB40D4,$9FA0FF0B,$6BECCD2F,$3F258C7A,
 $1E213F2F,$9C004DD3,$6003E540,$CF9FC949,
 $BFD4AF27,$88BBBDB5,$E2034090,$98D09675,
 $6E63A0E0,$15C361D2,$C2E7661D,$22D4FF8E,
 $28683B6F,$C07FD059,$FF2379C8,$775F50E2,
 $43C340D3,$DF2F8656,$887CA41A,$A2D2BD2D,
 $A1C9E0D6,$346C4819,$61B76D87,$22540F2F,
 $2ABE32E1,$AA54166B,$22568E3A,$A2D341D0,
 $66DB40C8,$A784392F,$004DFF2F,$2DB9D2DE,
 $97943FAC,$4A97C1D8,$527644B7,$B5F437A7,
 $B82CBAEF,$D751D159,$6FF7F0ED,$5A097A1F,
 $827B68D0,$90ECF52E,$22B0C054,$BC8E5935,
 $4B6D2F7F,$50BB64A2,$D2664910,$BEE5812D,
 $B7332290,$E93B159F,$B48EE411,$4BFF345D,
 $FD45C240,$AD31973F,$C4F6D02E,$55FC8165,
 $D5B1CAAD,$A1AC2DAE,$A2D4B76D,$C19B0C50,
 $882240F2,$0C6E4F38,$A4E4BFD7,$4F5BA272,
 $564C1D2F,$C59C5319,$B949E354,$B04669FE,
 $B1B6AB8A,$C71358DD,$6385C545,$110F935D,
 $57538AD5,$6A390493,$E63D37E0,$2A54F6B3,
 $3A787D5F,$6276A0B5,$19A6FCDF,$7A42206A,
 $29F9D4D5,$F61B1891,$BB72275E,$AA508167,
 $38901091,$C6B505EB,$84C7CB8C,$2AD75A0F,
 $874A1427,$A2D1936B, $2AD286AF,$AA56D291,
 $D7894360,$425C750D,$93B39E26,$187184C9,
 $6C00B32D,$73E2BB14,$A0BEBC3C,$54623779,
 $64459EAB,$3F328B82,$7718CF82,$59A2CEA6,
 $04EE002E,$89FE78E6,$3FAB0950,$325FF6C2,
 $81383F05,$6963C5C8,$76CB5AD6,$D49974C9,
 $CA180DCF,$380782D5,$C7FA5CF6,$8AC31511,
 $35E79E13,$47DA91D0,$F40F9086,$A7E2419E,
 $31366241,$051EF495,$AA573B04,$4A805D8D,
 $548300D0,$00322A3C,$BF64CDDF,$BA57A68E,
 $75C6372B,$50AFD341,$A7C13275,$915A0BF5,
 $6B54BFAB,$2B0B1426,$AB4CC9D7,$449CCD82,
 $F7FBF265,$AB85C5F3,$1B55DB94,$AAD4E324,
 $CFA4BD3F,$2DEAA3E2,$9E204D02,$C8BD25AC,
 $EADF55B3,$D5BD9E98,$E31231B2,$2AD5AD6C,
 $954329DE,$ADBE4528,$D8710F69,$AA51C90F,
 $AA786BF6,$22513F1E,$AA51A79B,$2AD344CC,
 $7B5A41F0,$D37CFBAD,$1B069505,$41ECE491,
 $B4C332E6,$032268D4,$C9600ACC,$CE387E6D,
 $BF6BB16C,$6A70FB78,$0D03D9C9,$D4DF39DE,
 $E01063DA,$4736F464,$5AD328D8,$B347CC96,
 $75BB0FC3,$98511BFB,$4FFBCC35,$B58BCF6A,
 $E11F0ABC,$BFC5FE4A,$A70AEC10,$AC39570A,
 $3F04442F,$6188B153,$E0397A2E,$5727CB79,
 $9CEB418F,$1CACD68D,$2AD37C96,$0175CB9D,
 $C69DFF09,$C75B65F0,$D9DB40D8,$EC0E7779,
 $4744EAD4,$B11C3274,$DD24CB9E,$7E1C54BD,
 $F01144F9,$D2240EB1,$9675B3FD,$A3AC3755,
 $D47C27AF,$51C85F4D,$56907596,$A5BB15E6,
 $580304F0,$CA042CF1,$011A37EA,$8DBFAADB,
 $35BA3E4A,$3526FFA0,$C37B4D09,$BC306ED9,
 $98A52666,$5648F725,$FF5E569D,$0CED63D0,
 $7C63B2CF,$700B45E1,$D5EA50F1,$85A92872,
 $AF1FBDA7,$D4234870,$A7870BF3,$2D3B4D79,
 $42E04198,$0CD0EDE7,$26470DB8,$F881814C,
 $474D6AD7,$7C0C5E5C,$D1231959,$381B7298,
 $F5D2F4DB,$AB838653,$6E2F1E23,$83719C9E,
 $BD91E046,$9A56456E,$DC39200C,$20C8C571,
 $962BDA1C,$E1E696FF,$B141AB08,$7CCA89B9,
 $1A69E783,$02CC4843,$A2F7C579,$429EF47D,
 $427B169C,$5AC9F049,$DD8F0F00,$5C8165BF
);

cast_sbox2: array[0..255] of DWord = (
 $1F201094,$EF0BA75B,$69E3CF7E,$393F4380,
 $FE61CF7A,$EEC5207A,$55889C94,$72FC0651,
 $ADA7EF79,$4E1D7235,$D55A63CE,$DE0436BA,
 $99C430EF,$5F0C0794,$18DCDB7D,$A1D6EFF3,
 $A0B52F7B,$59E83605,$EE15B094,$E9FFD909,
 $DC440086,$EF944459,$BA83CCB3,$E0C3CDFB,
 $D1DA4181,$3B092AB1,$F997F1C1,$A5E6CF7B,
 $01420DDB,$E4E7EF5B,$25A1FF41,$E180F806,
 $1FC41080,$179BEE7A,$D37AC6A9,$FE5830A4,
 $98DE8B7F,$77E83F4E,$79929269,$24FA9F7B,
 $E113C85B,$ACC40083,$D7503525,$F7EA615F,
 $62143154,$0D554B63,$5D681121,$C866C359,
 $3D63CF73,$CEE234C0,$D4D87E87,$5C672B21,
 $071F6181,$39F7627F,$361E3084,$E4EB573B,
 $602F64A4,$D63ACD9C,$1BBC4635,$9E81032D,
 $2701F50C,$99847AB4,$A0E3DF79,$BA6CF38C,
 $10843094,$2537A95E,$F46F6FFE,$A1FF3B1F,
 $208CFB6A,$8F458C74,$D9E0A227,$4EC73A34,
 $FC884F69,$3E4DE8DF,$EF0E0088,$3559648D,
 $8A45388C,$1D804366,$721D9BFD,$A58684BB,
 $E8256333,$844E8212,$128D8098,$FED33FB4,
 $CE280AE1,$27E19BA5,$D5A6C252,$E49754BD,
 $C5D655DD,$EB667064,$77840B4D,$A1B6A801,
 $84DB26A9,$E0B56714,$21F043B7,$E5D05860,
 $54F03084,$066FF472,$A31AA153,$DADC4755,
 $B5625DBF,$68561BE6,$83CA6B94,$2D6ED23B,
 $ECCF01DB,$A6D3D0BA,$B6803D5C,$AF77A709,
 $33B4A34C,$397BC8D6,$5EE22B95,$5F0E5304,
 $81ED6F61,$20E74364,$B45E1378,$DE18639B,
 $881CA122,$B96726D1,$8049A7E8,$22B7DA7B,
 $5E552D25,$5272D237,$79D2951C,$C60D894C,
 $488CB402,$1BA4FE5B,$A4B09F6B,$1CA815CF,
 $A20C3005,$8871DF63,$B9DE2FCB,$0CC6C9E9,
 $0BEEFF53,$E3214517,$B4542835,$9F63293C,
 $EE41E729,$6E1D2D7C,$50045286,$1E6685F3,
 $F33401C6,$30A22C95,$31A70850,$60930F13,
 $73F98417,$A1269859,$EC645C44,$52C877A9,
 $CDFF33A6,$A02B1741,$7CBAD9A2,$2180036F,
 $50D99C08,$CB3F4861,$C26BD765,$64A3F6AB,
 $80342676,$25A75E7B,$E4E6D1FC,$20C710E6,
 $CDF0B680,$17844D3B,$31EEF84D,$7E0824E4,
 $2CCB49EB,$846A3BAE,$8FF77888,$EE5D60F6,
 $7AF75673,$2FDD5CDB,$A11631C1,$30F66F43,
 $B3FAEC54,$157FD7FA,$EF8579CC,$D152DE58,
 $DB2FFD5E,$8F32CE19,$306AF97A,$02F03EF8,
 $99319AD5,$C242FA0F,$A7E3EBB0,$C68E4906,
 $B8DA230C,$80823028,$DCDEF3C8,$D35FB171,
 $088A1BC8,$BEC0C560,$61A3C9E8,$BCA8F54D,
 $C72FEFFA,$22822E99,$82C570B4,$D8D94E89,
 $8B1C34BC,$301E16E6,$273BE979,$B0FFEAA6,
 $61D9B8C6,$00B24869,$B7FFCE3F,$08DC283B,
 $43DAF65A,$F7E19798,$7619B72F,$8F1C9BA4,
 $DC8637A0,$16A7D3B1,$9FC393B7,$A7136EEB,
 $C6BCC63E,$1A513742,$EF6828BC,$520365D6,
 $2D6A77AB,$3527ED4B,$821FD216,$095C6E2E,
 $DB92F2FB,$5EEA29CB,$145892F5,$91584F7F,
 $5483697B,$2667A8CC,$85196048,$8C4BACEA,
 $833860D4,$0D23E0F9,$6C387E8A,$0AE6D249,
 $B284600C,$D835731D,$DCB1C647,$AC4C56EA,
 $3EBD81B3,$230EABB0,$6438BC87,$F0B5B1FA,
 $8F5EA2B3,$FC184642,$0A036B7A,$4FB089BD,
 $649DA589,$A345415E,$5C038323,$3E5D3BB9,
 $43D79572,$7E6DD07C,$06DFDF1E,$6C6CC4EF,
 $7160A539,$73BFBE70,$83877605,$4523ECF1
);

cast_sbox3: array[0..255] of DWord = (
 $8DEFC240,$25FA5D9F,$EB903DBF,$E810C907,
 $47607FFF,$369FE44B,$8C1FC644,$AECECA90,
 $BEB1F9BF,$EEFBCAEA,$E8CF1950,$51DF07AE,
 $920E8806,$F0AD0548,$E13C8D83,$927010D5,
 $11107D9F,$07647DB9,$B2E3E4D4,$3D4F285E,
 $B9AFA820,$FADE82E0,$A067268B,$8272792E,
 $553FB2C0,$489AE22B,$D4EF9794,$125E3FBC,
 $21FFFCEE,$825B1BFD,$9255C5ED,$1257A240,
 $4E1A8302,$BAE07FFF,$528246E7,$8E57140E,
 $3373F7BF,$8C9F8188,$A6FC4EE8,$C982B5A5,
 $A8C01DB7,$579FC264,$67094F31,$F2BD3F5F,
 $40FFF7C1,$1FB78DFC,$8E6BD2C1,$437BE59B,
 $99B03DBF,$B5DBC64B,$638DC0E6,$55819D99,
 $A197C81C,$4A012D6E,$C5884A28,$CCC36F71,
 $B843C213,$6C0743F1,$8309893C,$0FEDDD5F,
 $2F7FE850,$D7C07F7E,$02507FBF,$5AFB9A04,
 $A747D2D0,$1651192E,$AF70BF3E,$58C31380,
 $5F98302E,$727CC3C4,$0A0FB402,$0F7FEF82,
 $8C96FDAD,$5D2C2AAE,$8EE99A49,$50DA88B8,
 $8427F4A0,$1EAC5790,$796FB449,$8252DC15,
 $EFBD7D9B,$A672597D,$ADA840D8,$45F54504,
 $FA5D7403,$E83EC305,$4F91751A,$925669C2,
 $23EFE941,$A903F12E,$60270DF2,$0276E4B6,
 $94FD6574,$927985B2,$8276DBCB,$02778176,
 $F8AF918D,$4E48F79E,$8F616DDF,$E29D840E,
 $842F7D83,$340CE5C8,$96BBB682,$93B4B148,
 $EF303CAB,$984FAF28,$779FAF9B,$92DC560D,
 $224D1E20,$8437AA88,$7D29DC96,$2756D3DC,
 $8B907CEE,$B51FD240,$E7C07CE3,$E566B4A1,
 $C3E9615E,$3CF8209D,$6094D1E3,$CD9CA341,
 $5C76460E,$00EA983B,$D4D67881,$FD47572C,
 $F76CEDD9,$BDA8229C,$127DADAA,$438A074E,
 $1F97C090,$081BDB8A,$93A07EBE,$B938CA15,
 $97B03CFF,$3DC2C0F8,$8D1AB2EC,$64380E51,
 $68CC7BFB,$D90F2788,$12490181,$5DE5FFD4,
 $DD7EF86A,$76A2E214,$B9A40368,$925D958F,
 $4B39FFFA,$BA39AEE9,$A4FFD30B,$FAF7933B,
 $6D498623,$193CBCFA,$27627545,$825CF47A,
 $61BD8BA0,$D11E42D1,$CEAD04F4,$127EA392,
 $10428DB7,$8272A972,$9270C4A8,$127DE50B,
 $285BA1C8,$3C62F44F,$35C0EAA5,$E805D231,
 $428929FB,$B4FCDF82,$4FB66A53,$0E7DC15B,
 $1F081FAB,$108618AE,$FCFD086D,$F9FF2889,
 $694BCC11,$236A5CAE,$12DECA4D,$2C3F8CC5,
 $D2D02DFE,$F8EF5896,$E4CF52DA,$95155B67,
 $494A488C,$B9B6A80C,$5C8F82BC,$89D36B45,
 $3A609437,$EC00C9A9,$44715253,$0A874B49,
 $D773BC40,$7C34671C,$02717EF6,$4FEB5536,
 $A2D02FFF,$D2BF60C4,$D43F03C0,$50B4EF6D,
 $07478CD1,$006E1888,$A2E53F55,$B9E6D4BC,
 $A2048016,$97573833,$D7207D67,$DE0F8F3D,
 $72F87B33,$ABCC4F33,$7688C55D,$7B00A6B0,
 $947B0001,$570075D2,$F9BB88F8,$8942019E,
 $4264A5FF,$856302E0,$72DBD92B,$EE971B69,
 $6EA22FDE,$5F08AE2B,$AF7A616D,$E5C98767,
 $CF1FEBD2,$61EFC8C2,$F1AC2571,$CC8239C2,
 $67214CB8,$B1E583D1,$B7DC3E62,$7F10BDCE,
 $F90A5C38,$0FF0443D,$606E6DC6,$60543A49,
 $5727C148,$2BE98A1D,$8AB41738,$20E1BE24,
 $AF96DA0F,$68458425,$99833BE5,$600D457D,
 $282F9350,$8334B362,$D91D1120,$2B6D8DA0,
 $642B1E31,$9C305A00,$52BCE688,$1B03588A,
 $F7BAEFD5,$4142ED9C,$A4315C11,$83323EC5,
 $DFEF4636,$A133C501,$E9D3531C,$EE353783
);

cast_sbox4: array[0..255] of DWord = (
 $9DB30420,$1FB6E9DE,$A7BE7BEF,$D273A298,
 $4A4F7BDB,$64AD8C57,$85510443,$FA020ED1,
 $7E287AFF,$E60FB663,$095F35A1,$79EBF120,
 $FD059D43,$6497B7B1,$F3641F63,$241E4ADF,
 $28147F5F,$4FA2B8CD,$C9430040,$0CC32220,
 $FDD30B30,$C0A5374F,$1D2D00D9,$24147B15,
 $EE4D111A,$0FCA5167,$71FF904C,$2D195FFE,
 $1A05645F,$0C13FEFE,$081B08CA,$05170121,
 $80530100,$E83E5EFE,$AC9AF4F8,$7FE72701,
 $D2B8EE5F,$06DF4261,$BB9E9B8A,$7293EA25,
 $CE84FFDF,$F5718801,$3DD64B04,$A26F263B,
 $7ED48400,$547EEBE6,$446D4CA0,$6CF3D6F5,
 $2649ABDF,$AEA0C7F5,$36338CC1,$503F7E93,
 $D3772061,$11B638E1,$72500E03,$F80EB2BB,
 $ABE0502E,$EC8D77DE,$57971E81,$E14F6746,
 $C9335400,$6920318F,$081DBB99,$FFC304A5,
 $4D351805,$7F3D5CE3,$A6C866C6,$5D5BCCA9,
 $DAEC6FEA,$9F926F91,$9F46222F,$3991467D,
 $A5BF6D8E,$1143C44F,$43958302,$D0214EEB,
 $022083B8,$3FB6180C,$18F8931E,$281658E6,
 $26486E3E,$8BD78A70,$7477E4C1,$B506E07C,
 $F32D0A25,$79098B02,$E4EABB81,$28123B23,
 $69DEAD38,$1574CA16,$DF871B62,$211C40B7,
 $A51A9EF9,$0014377B,$041E8AC8,$09114003,
 $BD59E4D2,$E3D156D5,$4FE876D5,$2F91A340,
 $557BE8DE,$00EAE4A7,$0CE5C2EC,$4DB4BBA6,
 $E756BDFF,$DD3369AC,$EC17B035,$06572327,
 $99AFC8B0,$56C8C391,$6B65811C,$5E146119,
 $6E85CB75,$BE07C002,$C2325577,$893FF4EC,
 $5BBFC92D,$D0EC3B25,$B7801AB7,$8D6D3B24,
 $20C763EF,$C366A5FC,$9C382880,$0ACE3205,
 $AAC9548A,$ECA1D7C7,$041AFA32,$1D16625A,
 $6701902C,$9B757A54,$31D477F7,$9126B031,
 $36CC6FDB,$C70B8B46,$D9E66A48,$56E55A79,
 $026A4CEB,$52437EFF,$2F8F76B4,$0DF980A5,
 $8674CDE3,$EDDA04EB,$17A9BE04,$2C18F4DF,
 $B7747F9D,$AB2AF7B4,$EFC34D20,$2E096B7C,
 $1741A254,$E5B6A035,$213D42F6,$2C1C7C26,
 $61C2F50F,$6552DAF9,$D2C231F8,$25130F69,
 $D8167FA2,$0418F2C8,$001A96A6,$0D1526AB,
 $63315C21,$5E0A72EC,$49BAFEFD,$187908D9,
 $8D0DBD86,$311170A7,$3E9B640C,$CC3E10D7,
 $D5CAD3B6,$0CAEC388,$F73001E1,$6C728AFF,
 $71EAE2A1,$1F9AF36E,$CFCBD12F,$C1DE8417,
 $AC07BE6B,$CB44A1D8,$8B9B0F56,$013988C3,
 $B1C52FCA,$B4BE31CD,$D8782806,$12A3A4E2,
 $6F7DE532,$58FD7EB6,$D01EE900,$24ADFFC2,
 $F4990FC5,$9711AAC5,$001D7B95,$82E5E7D2,
 $109873F6,$00613096,$C32D9521,$ADA121FF,
 $29908415,$7FBB977F,$AF9EB3DB,$29C9ED2A,
 $5CE2A465,$A730F32C,$D0AA3FE8,$8A5CC091,
 $D49E2CE7,$0CE454A9,$D60ACD86,$015F1919,
 $77079103,$DEA03AF6,$78A8565E,$DEE356DF,
 $21F05CBE,$8B75E387,$B3C50651,$B8A5C3EF,
 $D8EEB6D2,$E523BE77,$C2154529,$2F69EFDF,
 $AFE67AFB,$F470C4B2,$F3E0EB5B,$D6CC9876,
 $39E4460C,$1FDA8538,$1987832F,$CA007367,
 $A99144F8,$296B299E,$492FC295,$9266BEAB,
 $B5676E69,$9BD3DDDA,$DF7E052F,$DB25701C,
 $1B5E51EE,$F65324E6,$6AFCE36C,$0316CC04,
 $8644213E,$B7DC59D0,$7965291F,$CCD6FD43,
 $41823979,$932BCDF6,$B657C34D,$4EDFD282,
 $7AE5290C,$3CB9536B,$851E20FE,$9833557E,
 $13ECF0B0,$D3FFB372,$3F85C5C1,$0AEF7ED2
);

cast_sbox5: array[0..255] of DWord = (
 $7EC90C04,$2C6E74B9,$9B0E66DF,$A6337911,
 $B86A7FFF,$1DD358F5,$44DD9D44,$1731167F,
 $08FBF1FA,$E7F511CC,$D2051B00,$735ABA00,
 $2AB722D8,$386381CB,$ACF6243A,$69BEFD7A,
 $E6A2E77F,$F0C720CD,$C4494816,$CCF5C180,
 $38851640,$15B0A848,$E68B18CB,$4CAADEFF,
 $5F480A01,$0412B2AA,$259814FC,$41D0EFE2,
 $4E40B48D,$248EB6FB,$8DBA1CFE,$41A99B02,
 $1A550A04,$BA8F65CB,$7251F4E7,$95A51725,
 $C106ECD7,$97A5980A,$C539B9AA,$4D79FE6A,
 $F2F3F763,$68AF8040,$ED0C9E56,$11B4958B,
 $E1EB5A88,$8709E6B0,$D7E07156,$4E29FEA7,
 $6366E52D,$02D1C000,$C4AC8E05,$9377F571,
 $0C05372A,$578535F2,$2261BE02,$D642A0C9,
 $DF13A280,$74B55BD2,$682199C0,$D421E5EC,
 $53FB3CE8,$C8ADEDB3,$28A87FC9,$3D959981,
 $5C1FF900,$FE38D399,$0C4EFF0B,$062407EA,
 $AA2F4FB1,$4FB96976,$90C79505,$B0A8A774,
 $EF55A1FF,$E59CA2C2,$A6B62D27,$E66A4263,
 $DF65001F,$0EC50966,$DFDD55BC,$29DE0655,
 $911E739A,$17AF8975,$32C7911C,$89F89468,
 $0D01E980,$524755F4,$03B63CC9,$0CC844B2,
 $BCF3F0AA,$87AC36E9,$E53A7426,$01B3D82B,
 $1A9E7449,$64EE2D7E,$CDDBB1DA,$01C94910,
 $B868BF80,$0D26F3FD,$9342EDE7,$04A5C284,
 $636737B6,$50F5B616,$F24766E3,$8ECA36C1,
 $136E05DB,$FEF18391,$FB887A37,$D6E7F7D4,
 $C7FB7DC9,$3063FCDF,$B6F589DE,$EC2941DA,
 $26E46695,$B7566419,$F654EFC5,$D08D58B7,
 $48925401,$C1BACB7F,$E5FF550F,$B6083049,
 $5BB5D0E8,$87D72E5A,$AB6A6EE1,$223A66CE,
 $C62BF3CD,$9E0885F9,$68CB3E47,$086C010F,
 $A21DE820,$D18B69DE,$F3F65777,$FA02C3F6,
 $407EDAC3,$CBB3D550,$1793084D,$B0D70EBA,
 $0AB378D5,$D951FB0C,$DED7DA56,$4124BBE4,
 $94CA0B56,$0F5755D1,$E0E1E56E,$6184B5BE,
 $580A249F,$94F74BC0,$E327888E,$9F7B5561,
 $C3DC0280,$05687715,$646C6BD7,$44904DB3,
 $66B4F0A3,$C0F1648A,$697ED5AF,$49E92FF6,
 $309E374F,$2CB6356A,$85808573,$4991F840,
 $76F0AE02,$083BE84D,$28421C9A,$44489406,
 $736E4CB8,$C1092910,$8BC95FC6,$7D869CF4,
 $134F616F,$2E77118D,$B31B2BE1,$AA90B472,
 $3CA5D717,$7D161BBA,$9CAD9010,$AF462BA2,
 $9FE459D2,$45D34559,$D9F2DA13,$DBC65487,
 $F3E4F94E,$176D486F,$097C13EA,$631DA5C7,
 $445F7382,$175683F4,$CDC66A97,$70BE0288,
 $B3CDCF72,$6E5DD2F3,$20936079,$459B80A5,
 $BE60E2DB,$A9C23101,$EBA5315C,$224E42F2,
 $1C5C1572,$F6721B2C,$1AD2FFF3,$8C25404E,
 $324ED72F,$4067B7FD,$0523138E,$5CA3BC78,
 $DC0FD66E,$75922283,$784D6B17,$58EBB16E,
 $44094F85,$3F481D87,$FCFEAE7B,$77B5FF76,
 $8C2302BF,$AAF47556,$5F46B02A,$2B092801,
 $3D38F5F7,$0CA81F36,$52AF4A8A,$66D5E7C0,
 $DF3B0874,$95055110,$1B5AD7A8,$F61ED5AD,
 $6CF6E479,$20758184,$D0CEFA65,$88F7BE58,
 $4A046826,$0FF6F8F3,$A09C7F70,$5346ABA0,
 $5CE96C28,$E176EDA3,$6BAC307F,$376829D2,
 $85360FA9,$17E3FE2A,$24B79767,$F5A96B20,
 $D6CD2595,$68FF1EBF,$7555442C,$F19F06BE,
 $F9E0659A,$EEB9491D,$34010718,$BB30CAB8,
 $E822FE15,$88570983,$750E6249,$DA627E55,
 $5E76FFA8,$B1534546,$6D47DE08,$EFE9E7D4
);

cast_sbox6: array[0..255] of DWord = (
 $F6FA8F9D,$2CAC6CE1,$4CA34867,$E2337F7C,
 $95DB08E7,$016843B4,$ECED5CBC,$325553AC,
 $BF9F0960,$DFA1E2ED,$83F0579D,$63ED86B9,
 $1AB6A6B8,$DE5EBE39,$F38FF732,$8989B138,
 $33F14961,$C01937BD,$F506C6DA,$E4625E7E,
 $A308EA99,$4E23E33C,$79CBD7CC,$48A14367,
 $A3149619,$FEC94BD5,$A114174A,$EAA01866,
 $A084DB2D,$09A8486F,$A888614A,$2900AF98,
 $01665991,$E1992863,$C8F30C60,$2E78EF3C,
 $D0D51932,$CF0FEC14,$F7CA07D2,$D0A82072,
 $FD41197E,$9305A6B0,$E86BE3DA,$74BED3CD,
 $372DA53C,$4C7F4448,$DAB5D440,$6DBA0EC3,
 $083919A7,$9FBAEED9,$49DBCFB0,$4E670C53,
 $5C3D9C01,$64BDB941,$2C0E636A,$BA7DD9CD,
 $EA6F7388,$E70BC762,$35F29ADB,$5C4CDD8D,
 $F0D48D8C,$B88153E2,$08A19866,$1AE2EAC8,
 $284CAF89,$AA928223,$9334BE53,$3B3A21BF,
 $16434BE3,$9AEA3906,$EFE8C36E,$F890CDD9,
 $80226DAE,$C340A4A3,$DF7E9C09,$A694A807,
 $5B7C5ECC,$221DB3A6,$9A69A02F,$68818A54,
 $CEB2296F,$53C0843A,$FE893655,$25BFE68A,
 $B4628ABC,$CF222EBF,$25AC6F48,$A9A99387,
 $53BDDB65,$E76FFBE7,$E967FD78,$0BA93563,
 $8E342BC1,$E8A11BE9,$4980740D,$C8087DFC,
 $8DE4BF99,$A11101A0,$7FD37975,$DA5A26C0,
 $E81F994F,$9528CD89,$FD339FED,$B87834BF,
 $5F04456D,$22258698,$C9C4C83B,$2DC156BE,
 $4F628DAA,$57F55EC5,$E2220ABE,$D2916EBF,
 $4EC75B95,$24F2C3C0,$42D15D99,$CD0D7FA0,
 $7B6E27FF,$A8DC8AF0,$7345C106,$F41E232F,
 $35162386,$E6EA8926,$3333B094,$157EC6F2,
 $372B74AF,$692573E4,$E9A9D848,$F3160289,
 $3A62EF1D,$A787E238,$F3A5F676,$74364853,
 $20951063,$4576698D,$B6FAD407,$592AF950,
 $36F73523,$4CFB6E87,$7DA4CEC0,$6C152DAA,
 $CB0396A8,$C50DFE5D,$FCD707AB,$0921C42F,
 $89DFF0BB,$5FE2BE78,$448F4F33,$754613C9,
 $2B05D08D,$48B9D585,$DC049441,$C8098F9B,
 $7DEDE786,$C39A3373,$42410005,$6A091751,
 $0EF3C8A6,$890072D6,$28207682,$A9A9F7BE,
 $BF32679D,$D45B5B75,$B353FD00,$CBB0E358,
 $830F220A,$1F8FB214,$D372CF08,$CC3C4A13,
 $8CF63166,$061C87BE,$88C98F88,$6062E397,
 $47CF8E7A,$B6C85283,$3CC2ACFB,$3FC06976,
 $4E8F0252,$64D8314D,$DA3870E3,$1E665459,
 $C10908F0,$513021A5,$6C5B68B7,$822F8AA0,
 $3007CD3E,$74719EEF,$DC872681,$073340D4,
 $7E432FD9,$0C5EC241,$8809286C,$F592D891,
 $08A930F6,$957EF305,$B7FBFFBD,$C266E96F,
 $6FE4AC98,$B173ECC0,$BC60B42A,$953498DA,
 $FBA1AE12,$2D4BD736,$0F25FAAB,$A4F3FCEB,
 $E2969123,$257F0C3D,$9348AF49,$361400BC,
 $E8816F4A,$3814F200,$A3F94043,$9C7A54C2,
 $BC704F57,$DA41E7F9,$C25AD33A,$54F4A084,
 $B17F5505,$59357CBE,$EDBD15C8,$7F97C5AB,
 $BA5AC7B5,$B6F6DEAF,$3A479C3A,$5302DA25,
 $653D7E6A,$54268D49,$51A477EA,$5017D55B,
 $D7D25D88,$44136C76,$0404A8C8,$B8E5A121,
 $B81A928A,$60ED5869,$97C55B96,$EAEC991B,
 $29935913,$01FDB7F1,$088E8DFA,$9AB6F6F5,
 $3B4CBF9F,$4A5DE3AB,$E6051D35,$A0E1D855,
 $D36B4CF1,$F544EDEB,$B0E93524,$BEBB8FBD,
 $A2D762CF,$49C92F54,$38B5F331,$7128A454,
 $48392905,$A65B1DB8,$851C97BD,$D675CF2F
);

cast_sbox7: array[0..255] of DWord = (
 $85E04019,$332BF567,$662DBFFF,$CFC65693,
 $2A8D7F6F,$AB9BC912,$DE6008A1,$2028DA1F,
 $0227BCE7,$4D642916,$18FAC300,$50F18B82,
 $2CB2CB11,$B232E75C,$4B3695F2,$B28707DE,
 $A05FBCF6,$CD4181E9,$E150210C,$E24EF1BD,
 $B168C381,$FDE4E789,$5C79B0D8,$1E8BFD43,
 $4D495001,$38BE4341,$913CEE1D,$92A79C3F,
 $089766BE,$BAEEADF4,$1286BECF,$B6EACB19,
 $2660C200,$7565BDE4,$64241F7A,$8248DCA9,
 $C3B3AD66,$28136086,$0BD8DFA8,$356D1CF2,
 $107789BE,$B3B2E9CE,$0502AA8F,$0BC0351E,
 $166BF52A,$EB12FF82,$E3486911,$D34D7516,
 $4E7B3AFF,$5F43671B,$9CF6E037,$4981AC83,
 $334266CE,$8C9341B7,$D0D854C0,$CB3A6C88,
 $47BC2829,$4725BA37,$A66AD22B,$7AD61F1E,
 $0C5CBAFA,$4437F107,$B6E79962,$42D2D816,
 $0A961288,$E1A5C06E,$13749E67,$72FC081A,
 $B1D139F7,$F9583745,$CF19DF58,$BEC3F756,
 $C06EBA30,$07211B24,$45C28829,$C95E317F,
 $BC8EC511,$38BC46E9,$C6E6FA14,$BAE8584A,
 $AD4EBC46,$468F508B,$7829435F,$F124183B,
 $821DBA9F,$AFF60FF4,$EA2C4E6D,$16E39264,
 $92544A8B,$009B4FC3,$ABA68CED,$9AC96F78,
 $06A5B79A,$B2856E6E,$1AEC3CA9,$BE838688,
 $0E0804E9,$55F1BE56,$E7E5363B,$B3A1F25D,
 $F7DEBB85,$61FE033C,$16746233,$3C034C28,
 $DA6D0C74,$79AAC56C,$3CE4E1AD,$51F0C802,
 $98F8F35A,$1626A49F,$EED82B29,$1D382FE3,
 $0C4FB99A,$BB325778,$3EC6D97B,$6E77A6A9,
 $CB658B5C,$D45230C7,$2BD1408B,$60C03EB7,
 $B9068D78,$A33754F4,$F430C87D,$C8A71302,
 $B96D8C32,$EBD4E7BE,$BE8B9D2D,$7979FB06,
 $E7225308,$8B75CF77,$11EF8DA4,$E083C858,
 $8D6B786F,$5A6317A6,$FA5CF7A0,$5DDA0033,
 $F28EBFB0,$F5B9C310,$A0EAC280,$08B9767A,
 $A3D9D2B0,$79D34217,$021A718D,$9AC6336A,
 $2711FD60,$438050E3,$069908A8,$3D7FEDC4,
 $826D2BEF,$4EEB8476,$488DCF25,$36C9D566,
 $28E74E41,$C2610ACA,$3D49A9CF,$BAE3B9DF,
 $B65F8DE6,$92AEAF64,$3AC7D5E6,$9EA80509,
 $F22B017D,$A4173F70,$DD1E16C3,$15E0D7F9,
 $50B1B887,$2B9F4FD5,$625ABA82,$6A017962,
 $2EC01B9C,$15488AA9,$D716E740,$40055A2C,
 $93D29A22,$E32DBF9A,$058745B9,$3453DC1E,
 $D699296E,$496CFF6F,$1C9F4986,$DFE2ED07,
 $B87242D1,$19DE7EAE,$053E561A,$15AD6F8C,
 $66626C1C,$7154C24C,$EA082B2A,$93EB2939,
 $17DCB0F0,$58D4F2AE,$9EA294FB,$52CF564C,
 $9883FE66,$2EC40581,$763953C3,$01D6692E,
 $D3A0C108,$A1E7160E,$E4F2DFA6,$693ED285,
 $74904698,$4C2B0EDD,$4F757656,$5D393378,
 $A132234F,$3D321C5D,$C3F5E194,$4B269301,
 $C79F022F,$3C997E7E,$5E4F9504,$3FFAFBBD,
 $76F7AD0E,$296693F4,$3D1FCE6F,$C61E45BE,
 $D3B5AB34,$F72BF9B7,$1B0434C0,$4E72B567,
 $5592A33D,$B5229301,$CFD2A87F,$60AEB767,
 $1814386B,$30BCC33D,$38A0C07D,$FD1606F2,
 $C363519B,$589DD390,$5479F8E6,$1CB8D647,
 $97FD61A9,$EA7759F4,$2D57539D,$569A58CF,
 $E84E63AD,$462E1B78,$6580F87E,$F3817914,
 $91DA55F4,$40A230F3,$D1988F35,$B6E318D2,
 $3FFA50BC,$3D40F021,$C3C0BDAE,$4958C24C,
 $518F36B2,$84B1D370,$0FEDCE83,$878DDADA,
 $F2A279C7,$94E01BE8,$90716F4B,$954B8AA3
);

cast_sbox8: array[0..255] of DWord = (
 $E216300D,$BBDDFFFC,$A7EBDABD,$35648095,
 $7789F8B7,$E6C1121B,$0E241600,$052CE8B5,
 $11A9CFB0,$E5952F11,$ECE7990A,$9386D174,
 $2A42931C,$76E38111,$B12DEF3A,$37DDDDFC,
 $DE9ADEB1,$0A0CC32C,$BE197029,$84A00940,
 $BB243A0F,$B4D137CF,$B44E79F0,$049EEDFD,
 $0B15A15D,$480D3168,$8BBBDE5A,$669DED42,
 $C7ECE831,$3F8F95E7,$72DF191B,$7580330D,
 $94074251,$5C7DCDFA,$ABBE6D63,$AA402164,
 $B301D40A,$02E7D1CA,$53571DAE,$7A3182A2,
 $12A8DDEC,$FDAA335D,$176F43E8,$71FB46D4,
 $38129022,$CE949AD4,$B84769AD,$965BD862,
 $82F3D055,$66FB9767,$15B80B4E,$1D5B47A0,
 $4CFDE06F,$C28EC4B8,$57E8726E,$647A78FC,
 $99865D44,$608BD593,$6C200E03,$39DC5FF6,
 $5D0B00A3,$AE63AFF2,$7E8BD632,$70108C0C,
 $BBD35049,$2998DF04,$980CF42A,$9B6DF491,
 $9E7EDD53,$06918548,$58CB7E07,$3B74EF2E,
 $522FFFB1,$D24708CC,$1C7E27CD,$A4EB215B,
 $3CF1D2E2,$19B47A38,$424F7618,$35856039,
 $9D17DEE7,$27EB35E6,$C9AFF67B,$36BAF5B8,
 $09C467CD,$C18910B1,$E11DBF7B,$06CD1AF8,
 $7170C608,$2D5E3354,$D4DE495A,$64C6D006,
 $BCC0C62C,$3DD00DB3,$708F8F34,$77D51B42,
 $264F620F,$24B8D2BF,$15C1B79E,$46A52564,
 $F8D7E54E,$3E378160,$7895CDA5,$859C15A5,
 $E6459788,$C37BC75F,$DB07BA0C,$0676A3AB,
 $7F229B1E,$31842E7B,$24259FD7,$F8BEF472,
 $835FFCB8,$6DF4C1F2,$96F5B195,$FD0AF0FC,
 $B0FE134C,$E2506D3D,$4F9B12EA,$F215F225,
 $A223736F,$9FB4C428,$25D04979,$34C713F8,
 $C4618187,$EA7A6E98,$7CD16EFC,$1436876C,
 $F1544107,$BEDEEE14,$56E9AF27,$A04AA441,
 $3CF7C899,$92ECBAE6,$DD67016D,$151682EB,
 $A842EEDF,$FDBA60B4,$F1907B75,$20E3030F,
 $24D8C29E,$E139673B,$EFA63FB8,$71873054,
 $B6F2CF3B,$9F326442,$CB15A4CC,$B01A4504,
 $F1E47D8D,$844A1BE5,$BAE7DFDC,$42CBDA70,
 $CD7DAE0A,$57E85B7A,$D53F5AF6,$20CF4D8C,
 $CEA4D428,$79D130A4,$3486EBFB,$33D3CDDC,
 $77853B53,$37EFFCB5,$C5068778,$E580B3E6,
 $4E68B8F4,$C5C8B37E,$0D809EA2,$398FEB7C,
 $132A4F94,$43B7950E,$2FEE7D1C,$223613BD,
 $DD06CAA2,$37DF932B,$C4248289,$ACF3EBC3,
 $5715F6B7,$EF3478DD,$F267616F,$C148CBE4,
 $9052815E,$5E410FAB,$B48A2465,$2EDA7FA4,
 $E87B40E4,$E98EA084,$5889E9E1,$EFD390FC,
 $DD07D35B,$DB485694,$38D7E5B2,$57720101,
 $730EDEBC,$5B643113,$94917E4F,$503C2FBA,
 $646F1282,$7523D24A,$E0779695,$F9C17A8F,
 $7A5B2121,$D187B896,$29263A4D,$BA510CDF,
 $81F47C9F,$AD1163ED,$EA7B5965,$1A00726E,
 $11403092,$00DA6D77,$4A0CDD61,$AD1F4603,
 $605BDFB0,$9EEDC364,$22EBE6A8,$CEE7D28A,
 $A0E736A0,$5564A6B9,$10853209,$C7EB8F37,
 $2DE705CA,$8951570F,$DF09822B,$BD691A6C,
 $AA12E4F2,$87451C0F,$E0F6A27A,$3ADA4819,
 $4CF1764F,$0D771C2B,$67CDB156,$350D8384,
 $5938FA0F,$42399EF3,$36997B07,$0E84093D,
 $4AA93E61,$8360D87B,$1FA98B0C,$1149382C,
 $E97625A5,$0614D1B7,$0E25244B,$0C768347,
 $589E8D82,$0D2059D1,$A466BB1E,$F8DA0A82,
 $04F19130,$BA6E4EC0,$99265164,$1EE7230D,
 $50B2AD80,$EAEE6801,$8DB2A283,$EA8BF59E
);

procedure Cast128EncryptECB;
var
  t,l,r:DWord;
begin
 with Data do begin
  Move(InBlock,l,Sizeof(l));
  Move(pointer(longint(@InBlock)+4)^,r,Sizeof(r));
  {$ifdef win32}
   l:= (l shr 24) or ((l shr 8) and $FF00) or ((l shl 8) and $FF0000) or (l shl 24);
   r:= (r shr 24) or ((r shr 8) and $FF00) or ((r shl 8) and $FF0000) or (r shl 24);
  t:= LRot32(KeyData[0]+r, KeyData[0+16]);
  l:= l xor (((cast_sbox1[t shr 24] xor cast_sbox2[(t shr 16) and $FF]) -
    cast_sbox3[(t shr 8) and $FF]) + cast_sbox4[t and $FF]);
  t:= LRot32(KeyData[1] xor l, KeyData[1+16]);
  r:= r xor (((cast_sbox1[t shr 24] - cast_sbox2[(t shr 16) and $FF]) +
    cast_sbox3[(t shr 8) and $FF]) xor cast_sbox4[t and $FF]);
  t:= LRot32(KeyData[2]-r, KeyData[2+16]);
  l:= l xor (((cast_sbox1[t shr 24] + cast_sbox2[(t shr 16) and $FF]) xor
    cast_sbox3[(t shr 8) and $FF]) - cast_sbox4[t and $FF]);
  t:= LRot32(KeyData[3]+l, KeyData[3+16]);
  r:= r xor (((cast_sbox1[t shr 24] xor cast_sbox2[(t shr 16) and $FF]) -
    cast_sbox3[(t shr 8) and $FF]) + cast_sbox4[t and $FF]);
  t:= LRot32(KeyData[4] xor r, KeyData[4+16]);
  l:= l xor (((cast_sbox1[t shr 24] - cast_sbox2[(t shr 16) and $FF]) +
    cast_sbox3[(t shr 8) and $FF]) xor cast_sbox4[t and $FF]);
  t:= LRot32(KeyData[5]-l, KeyData[5+16]);
  r:= r xor (((cast_sbox1[t shr 24] + cast_sbox2[(t shr 16) and $FF]) xor
    cast_sbox3[(t shr 8) and $FF]) - cast_sbox4[t and $FF]);
  t:= LRot32(KeyData[6]+r, KeyData[6+16]);
  l:= l xor (((cast_sbox1[t shr 24] xor cast_sbox2[(t shr 16) and $FF]) -
    cast_sbox3[(t shr 8) and $FF]) + cast_sbox4[t and $FF]);
  t:= LRot32(KeyData[7] xor l, KeyData[7+16]);
  r:= r xor (((cast_sbox1[t shr 24] - cast_sbox2[(t shr 16) and $FF]) +
    cast_sbox3[(t shr 8) and $FF]) xor cast_sbox4[t and $FF]);
  t:= LRot32(KeyData[8]-r, KeyData[8+16]);
  l:= l xor (((cast_sbox1[t shr 24] + cast_sbox2[(t shr 16) and $FF]) xor
    cast_sbox3[(t shr 8) and $FF]) - cast_sbox4[t and $FF]);
  t:= LRot32(KeyData[9]+l, KeyData[9+16]);
  r:= r xor (((cast_sbox1[t shr 24] xor cast_sbox2[(t shr 16) and $FF]) -
    cast_sbox3[(t shr 8) and $FF]) + cast_sbox4[t and $FF]);
  t:= LRot32(KeyData[10] xor r, KeyData[10+16]);
  l:= l xor (((cast_sbox1[t shr 24] - cast_sbox2[(t shr 16) and $FF]) +
    cast_sbox3[(t shr 8) and $FF]) xor cast_sbox4[t and $FF]);
  t:= LRot32(KeyData[11]-l, KeyData[11+16]);
  r:= r xor (((cast_sbox1[t shr 24] + cast_sbox2[(t shr 16) and $FF]) xor
    cast_sbox3[(t shr 8) and $FF]) - cast_sbox4[t and $FF]);
  if Rounds> 12 then
  begin
    t:= LRot32(KeyData[12]+r, KeyData[12+16]);
    l:= l xor (((cast_sbox1[t shr 24] xor cast_sbox2[(t shr 16) and $FF]) -
      cast_sbox3[(t shr 8) and $FF]) + cast_sbox4[t and $FF]);
    t:= LRot32(KeyData[13] xor l, KeyData[13+16]);
    r:= r xor (((cast_sbox1[t shr 24] - cast_sbox2[(t shr 16) and $FF]) +
      cast_sbox3[(t shr 8) and $FF]) xor cast_sbox4[t and $FF]);
    t:= LRot32(KeyData[14]-r, KeyData[14+16]);
    l:= l xor (((cast_sbox1[t shr 24] + cast_sbox2[(t shr 16) and $FF]) xor
      cast_sbox3[(t shr 8) and $FF]) - cast_sbox4[t and $FF]);
    t:= LRot32(KeyData[15]+l, KeyData[15+16]);
    r:= r xor (((cast_sbox1[t shr 24] xor cast_sbox2[(t shr 16) and $FF]) -
      cast_sbox3[(t shr 8) and $FF]) + cast_sbox4[t and $FF]);
  end;
   l:= (l shr 24) or ((l shr 8) and $FF00) or ((l shl 8) and $FF0000) or (l shl 24);
   r:= (r shr 24) or ((r shr 8) and $FF00) or ((r shl 8) and $FF0000) or (r shl 24);
  {$else}
   l:=bswap(l);
   r:=bswap(R);
  t:= LRot32(KeyData[0]+r, KeyData[0+16]);
  l:= l xor (((cast_sbox1[dw(t).b4] xor cast_sbox2[dw(t).b3]) -
    cast_sbox3[dw(t).b2]) + cast_sbox4[dw(t).b1]);
  t:= LRot32(KeyData[1] xor l, KeyData[1+16]);
  r:= r xor (((cast_sbox1[dw(t).b4] - cast_sbox2[dw(t).b3]) +
    cast_sbox3[dw(t).b2]) xor cast_sbox4[dw(t).b1]);
  t:= LRot32(KeyData[2]-r, KeyData[2+16]);
  l:= l xor (((cast_sbox1[dw(t).b4] + cast_sbox2[dw(t).b3]) xor
    cast_sbox3[dw(t).b2]) - cast_sbox4[dw(t).b1]);
  t:= LRot32(KeyData[3]+l, KeyData[3+16]);
  r:= r xor (((cast_sbox1[dw(t).b4] xor cast_sbox2[dw(t).b3]) -
    cast_sbox3[dw(t).b2]) + cast_sbox4[dw(t).b1]);
  t:= LRot32(KeyData[4] xor r, KeyData[4+16]);
  l:= l xor (((cast_sbox1[dw(t).b4] - cast_sbox2[dw(t).b3]) +
    cast_sbox3[dw(t).b2]) xor cast_sbox4[dw(t).b1]);
  t:= LRot32(KeyData[5]-l, KeyData[5+16]);
  r:= r xor (((cast_sbox1[dw(t).b4] + cast_sbox2[dw(t).b3]) xor
    cast_sbox3[dw(t).b2]) - cast_sbox4[dw(t).b1]);
  t:= LRot32(KeyData[6]+r, KeyData[6+16]);
  l:= l xor (((cast_sbox1[dw(t).b4] xor cast_sbox2[dw(t).b3]) -
    cast_sbox3[dw(t).b2]) + cast_sbox4[dw(t).b1]);
  t:= LRot32(KeyData[7] xor l, KeyData[7+16]);
  r:= r xor (((cast_sbox1[dw(t).b4] - cast_sbox2[dw(t).b3]) +
    cast_sbox3[dw(t).b2]) xor cast_sbox4[dw(t).b1]);
  t:= LRot32(KeyData[8]-r, KeyData[8+16]);
  l:= l xor (((cast_sbox1[dw(t).b4] + cast_sbox2[dw(t).b3]) xor
    cast_sbox3[dw(t).b2]) - cast_sbox4[dw(t).b1]);
  t:= LRot32(KeyData[9]+l, KeyData[9+16]);
  r:= r xor (((cast_sbox1[dw(t).b4] xor cast_sbox2[dw(t).b3]) -
    cast_sbox3[dw(t).b2]) + cast_sbox4[dw(t).b1]);
  t:= LRot32(KeyData[10] xor r, KeyData[10+16]);
  l:= l xor (((cast_sbox1[dw(t).b4] - cast_sbox2[dw(t).b3]) +
    cast_sbox3[dw(t).b2]) xor cast_sbox4[dw(t).b1]);
  t:= LRot32(KeyData[11]-l, KeyData[11+16]);
  r:= r xor (((cast_sbox1[dw(t).b4] + cast_sbox2[dw(t).b3]) xor
    cast_sbox3[dw(t).b2]) - cast_sbox4[dw(t).b1]);
  if Rounds> 12 then
  begin
    t:= LRot32(KeyData[12]+r, KeyData[12+16]);
    l:= l xor (((cast_sbox1[dw(t).b4] xor cast_sbox2[dw(t).b3]) -
      cast_sbox3[dw(t).b2]) + cast_sbox4[dw(t).b1]);
    t:= LRot32(KeyData[13] xor l, KeyData[13+16]);
    r:= r xor (((cast_sbox1[dw(t).b4] - cast_sbox2[dw(t).b3]) +
      cast_sbox3[dw(t).b2]) xor cast_sbox4[dw(t).b1]);
    t:= LRot32(KeyData[14]-r, KeyData[14+16]);
    l:= l xor (((cast_sbox1[dw(t).b4] + cast_sbox2[dw(t).b3]) xor
      cast_sbox3[dw(t).b2]) - cast_sbox4[dw(t).b1]);
    t:= LRot32(KeyData[15]+l, KeyData[15+16]);
    r:= r xor (((cast_sbox1[dw(t).b4] xor cast_sbox2[dw(t).b3]) -
      cast_sbox3[dw(t).b2]) + cast_sbox4[dw(t).b1]);
  end;
   l:=bswap(l);
   r:=bswap(R);
  {$endif}
  Move(r,OutBlock,Sizeof(r));
  Move(l,pointer(longint(@OutBlock)+4)^,Sizeof(l));
 end;
end;

procedure Cast128DecryptECB;
var
  t, l, r:DWord;
begin
 with Data do begin
  Move(InBlock,r,Sizeof(l));
  Move(pointer(longint(@InBlock)+4)^,l,Sizeof(l));
  {$ifdef win32}
   l:= (l shr 24) or ((l shr 8) and $FF00) or ((l shl 8) and $FF0000) or (l shl 24);
   r:= (r shr 24) or ((r shr 8) and $FF00) or ((r shl 8) and $FF0000) or (r shl 24);
  if Rounds> 12 then
  begin
    t:= LRot32(KeyData[15]+l, KeyData[15+16]);
    r:= r xor (((cast_sbox1[t shr 24] xor cast_sbox2[(t shr 16) and $FF]) -
      cast_sbox3[(t shr 8) and $FF]) + cast_sbox4[t and $FF]);
    t:= LRot32(KeyData[14]-r, KeyData[14+16]);
    l:= l xor (((cast_sbox1[t shr 24] + cast_sbox2[(t shr 16) and $FF]) xor
      cast_sbox3[(t shr 8) and $FF]) - cast_sbox4[t and $FF]);
    t:= LRot32(KeyData[13] xor l, KeyData[13+16]);
    r:= r xor (((cast_sbox1[t shr 24] - cast_sbox2[(t shr 16) and $FF]) +
      cast_sbox3[(t shr 8) and $FF]) xor cast_sbox4[t and $FF]);
    t:= LRot32(KeyData[12]+r, KeyData[12+16]);
    l:= l xor (((cast_sbox1[t shr 24] xor cast_sbox2[(t shr 16) and $FF]) -
      cast_sbox3[(t shr 8) and $FF]) + cast_sbox4[t and $FF]);
  end;
  t:= LRot32(KeyData[11]-l, KeyData[11+16]);
  r:= r xor (((cast_sbox1[t shr 24] + cast_sbox2[(t shr 16) and $FF]) xor
    cast_sbox3[(t shr 8) and $FF]) - cast_sbox4[t and $FF]);
  t:= LRot32(KeyData[10] xor r, KeyData[10+16]);
  l:= l xor (((cast_sbox1[t shr 24] - cast_sbox2[(t shr 16) and $FF]) +
    cast_sbox3[(t shr 8) and $FF]) xor cast_sbox4[t and $FF]);
  t:= LRot32(KeyData[9]+l, KeyData[9+16]);
  r:= r xor (((cast_sbox1[t shr 24] xor cast_sbox2[(t shr 16) and $FF]) -
    cast_sbox3[(t shr 8) and $FF]) + cast_sbox4[t and $FF]);
  t:= LRot32(KeyData[8]-r, KeyData[8+16]);
  l:= l xor (((cast_sbox1[t shr 24] + cast_sbox2[(t shr 16) and $FF]) xor
    cast_sbox3[(t shr 8) and $FF]) - cast_sbox4[t and $FF]);
  t:= LRot32(KeyData[7] xor l, KeyData[7+16]);
  r:= r xor (((cast_sbox1[t shr 24] - cast_sbox2[(t shr 16) and $FF]) +
    cast_sbox3[(t shr 8) and $FF]) xor cast_sbox4[t and $FF]);
  t:= LRot32(KeyData[6]+r, KeyData[6+16]);
  l:= l xor (((cast_sbox1[t shr 24] xor cast_sbox2[(t shr 16) and $FF]) -
    cast_sbox3[(t shr 8) and $FF]) + cast_sbox4[t and $FF]);
  t:= LRot32(KeyData[5]-l, KeyData[5+16]);
  r:= r xor (((cast_sbox1[t shr 24] + cast_sbox2[(t shr 16) and $FF]) xor
    cast_sbox3[(t shr 8) and $FF]) - cast_sbox4[t and $FF]);
  t:= LRot32(KeyData[4] xor r, KeyData[4+16]);
  l:= l xor (((cast_sbox1[t shr 24] - cast_sbox2[(t shr 16) and $FF]) +
    cast_sbox3[(t shr 8) and $FF]) xor cast_sbox4[t and $FF]);
  t:= LRot32(KeyData[3]+l, KeyData[3+16]);
  r:= r xor (((cast_sbox1[t shr 24] xor cast_sbox2[(t shr 16) and $FF]) -
    cast_sbox3[(t shr 8) and $FF]) + cast_sbox4[t and $FF]);
  t:= LRot32(KeyData[2]-r, KeyData[2+16]);
  l:= l xor (((cast_sbox1[t shr 24] + cast_sbox2[(t shr 16) and $FF]) xor
    cast_sbox3[(t shr 8) and $FF]) - cast_sbox4[t and $FF]);
  t:= LRot32(KeyData[1] xor l, KeyData[1+16]);
  r:= r xor (((cast_sbox1[t shr 24] - cast_sbox2[(t shr 16) and $FF]) +
    cast_sbox3[(t shr 8) and $FF]) xor cast_sbox4[t and $FF]);
  t:= LRot32(KeyData[0]+r, KeyData[0+16]);
  l:= l xor (((cast_sbox1[t shr 24] xor cast_sbox2[(t shr 16) and $FF]) -
    cast_sbox3[(t shr 8) and $FF]) + cast_sbox4[t and $FF]);
   l:= (l shr 24) or ((l shr 8) and $FF00) or ((l shl 8) and $FF0000) or (l shl 24);
   r:= (r shr 24) or ((r shr 8) and $FF00) or ((r shl 8) and $FF0000) or (r shl 24);
  {$else}
   l:=bswap(l);
   r:=bswap(R);
  if Rounds> 12 then
  begin
    t:= LRot32(KeyData[15]+l, KeyData[15+16]);
    r:= r xor (((cast_sbox1[dw(t).b4] xor cast_sbox2[dw(t).b3]) -
      cast_sbox3[dw(t).b2]) + cast_sbox4[dw(t).b1]);
    t:= LRot32(KeyData[14]-r, KeyData[14+16]);
    l:= l xor (((cast_sbox1[dw(t).b4] + cast_sbox2[dw(t).b3]) xor
      cast_sbox3[dw(t).b2]) - cast_sbox4[dw(t).b1]);
    t:= LRot32(KeyData[13] xor l, KeyData[13+16]);
    r:= r xor (((cast_sbox1[dw(t).b4] - cast_sbox2[dw(t).b3]) +
      cast_sbox3[dw(t).b2]) xor cast_sbox4[dw(t).b1]);
    t:= LRot32(KeyData[12]+r, KeyData[12+16]);
    l:= l xor (((cast_sbox1[dw(t).b4] xor cast_sbox2[dw(t).b3]) -
      cast_sbox3[dw(t).b2]) + cast_sbox4[dw(t).b1]);
  end;
  t:= LRot32(KeyData[11]-l, KeyData[11+16]);
  r:= r xor (((cast_sbox1[dw(t).b4] + cast_sbox2[dw(t).b3]) xor
    cast_sbox3[dw(t).b2]) - cast_sbox4[dw(t).b1]);
  t:= LRot32(KeyData[10] xor r, KeyData[10+16]);
  l:= l xor (((cast_sbox1[dw(t).b4] - cast_sbox2[dw(t).b3]) +
    cast_sbox3[dw(t).b2]) xor cast_sbox4[dw(t).b1]);
  t:= LRot32(KeyData[9]+l, KeyData[9+16]);
  r:= r xor (((cast_sbox1[dw(t).b4] xor cast_sbox2[dw(t).b3]) -
    cast_sbox3[dw(t).b2]) + cast_sbox4[dw(t).b1]);
  t:= LRot32(KeyData[8]-r, KeyData[8+16]);
  l:= l xor (((cast_sbox1[dw(t).b4] + cast_sbox2[dw(t).b3]) xor
    cast_sbox3[dw(t).b2]) - cast_sbox4[dw(t).b1]);
  t:= LRot32(KeyData[7] xor l, KeyData[7+16]);
  r:= r xor (((cast_sbox1[dw(t).b4] - cast_sbox2[dw(t).b3]) +
    cast_sbox3[dw(t).b2]) xor cast_sbox4[dw(t).b1]);
  t:= LRot32(KeyData[6]+r, KeyData[6+16]);
  l:= l xor (((cast_sbox1[dw(t).b4] xor cast_sbox2[dw(t).b3]) -
    cast_sbox3[dw(t).b2]) + cast_sbox4[dw(t).b1]);
  t:= LRot32(KeyData[5]-l, KeyData[5+16]);
  r:= r xor (((cast_sbox1[dw(t).b4] + cast_sbox2[dw(t).b3]) xor
    cast_sbox3[dw(t).b2]) - cast_sbox4[dw(t).b1]);
  t:= LRot32(KeyData[4] xor r, KeyData[4+16]);
  l:= l xor (((cast_sbox1[dw(t).b4] - cast_sbox2[dw(t).b3]) +
    cast_sbox3[dw(t).b2]) xor cast_sbox4[dw(t).b1]);
  t:= LRot32(KeyData[3]+l, KeyData[3+16]);
  r:= r xor (((cast_sbox1[dw(t).b4] xor cast_sbox2[dw(t).b3]) -
    cast_sbox3[dw(t).b2]) + cast_sbox4[dw(t).b1]);
  t:= LRot32(KeyData[2]-r, KeyData[2+16]);
  l:= l xor (((cast_sbox1[dw(t).b4] + cast_sbox2[dw(t).b3]) xor
    cast_sbox3[dw(t).b2]) - cast_sbox4[dw(t).b1]);
  t:= LRot32(KeyData[1] xor l, KeyData[1+16]);
  r:= r xor (((cast_sbox1[dw(t).b4] - cast_sbox2[dw(t).b3]) +
    cast_sbox3[dw(t).b2]) xor cast_sbox4[dw(t).b1]);
  t:= LRot32(KeyData[0]+r, KeyData[0+16]);
  l:= l xor (((cast_sbox1[dw(t).b4] xor cast_sbox2[dw(t).b3]) -
    cast_sbox3[dw(t).b2]) + cast_sbox4[dw(t).b1]);
   l:=bswap(l);
   r:=bswap(R);
  {$endif}
  Move(l,OutBlock,Sizeof(l));
  Move(r,pointer(longint(@OutBlock)+4)^,Sizeof(r));
 end;
end;

procedure Cast128Init;
var
  x, t, z:array[0..3] of DWord;
  i:longint;
begin
 if (Size> 128) or (Size<= 0) or ((Size mod 8)<> 0) then Exit;
 with Data do begin
  Size:= Size div 8;
  if Size<= 10 then Rounds:= 12 else Rounds:= 16;
  FillChar(x,Sizeof(x),0);
  Move(Key,x,Size);
  {$ifdef win32}
  x[0]:=(x[0] shr 24) or ((x[0] shr 8) and $FF00) or ((x[0] shl 8) and $FF0000) or (x[0] shl 24);
  x[1]:=(x[1] shr 24) or ((x[1] shr 8) and $FF00) or ((x[1] shl 8) and $FF0000) or (x[1] shl 24);
  x[2]:=(x[2] shr 24) or ((x[2] shr 8) and $FF00) or ((x[2] shl 8) and $FF0000) or (x[2] shl 24);
  x[3]:=(x[3] shr 24) or ((x[3] shr 8) and $FF00) or ((x[3] shl 8) and $FF0000) or (x[3] shl 24);
  {$else}
  x[0]:=bswap(x[0]);
  x[1]:=bswap(x[1]);
  x[2]:=bswap(x[2]);
  x[3]:=bswap(x[3]);
  {$endif}
  i:= 0;
  while i< 32 do begin
    case (i and 4) of
  {$ifdef win32}
      0:begin
          z[0]:= x[0] xor cast_sbox5[(x[3] shr 16) and $FF] xor
           cast_sbox6[x[3] and $FF] xor cast_sbox7[x[3] shr 24] xor
           cast_sbox8[(x[3] shr 8) and $FF] xor cast_sbox7[x[2] shr 24];
          t[0]:= z[0];
          z[1]:= x[2] xor cast_sbox5[z[0] shr 24] xor
           cast_sbox6[(z[0] shr 8) and $FF] xor cast_sbox7[(z[0] shr 16) and $FF] xor
           cast_sbox8[z[0] and $FF] xor cast_sbox8[(x[2] shr 8) and $FF];
          t[1]:= z[1];
          z[2]:= x[3] xor cast_sbox5[z[1] and $FF] xor
           cast_sbox6[(z[1] shr 8) and $FF] xor cast_sbox7[(z[1] shr 16) and $FF] xor
           cast_sbox8[z[1] shr 24] xor cast_sbox5[(x[2] shr 16) and $FF];
          t[2]:= z[2];
          z[3]:= x[1] xor cast_sbox5[(z[2] shr 8) and $FF] xor
           cast_sbox6[(z[2] shr 16) and $FF] xor cast_sbox7[z[2] and $FF] xor
           cast_sbox8[z[2] shr 24] xor cast_sbox6[x[2] and $FF];
          t[3]:= z[3];
        end;
      4:begin
          x[0]:= z[2] xor cast_sbox5[(z[1] shr 16) and $FF] xor
           cast_sbox6[z[1] and $FF] xor cast_sbox7[z[1] shr 24] xor
           cast_sbox8[(z[1] shr 8) and $FF] xor cast_sbox7[z[0] shr 24];
          t[0]:= x[0];
          x[1]:= z[0] xor cast_sbox5[x[0] shr 24] xor
           cast_sbox6[(x[0] shr 8) and $FF] xor cast_sbox7[(x[0] shr 16) and $FF] xor
           cast_sbox8[x[0] and $FF] xor cast_sbox8[(z[0] shr 8) and $FF];
          t[1]:= x[1];
          x[2]:= z[1] xor cast_sbox5[x[1] and $FF] xor
           cast_sbox6[(x[1] shr 8) and $FF] xor cast_sbox7[(x[1] shr 16) and $FF] xor
           cast_sbox8[x[1] shr 24] xor cast_sbox5[(z[0] shr 16) and $FF];
          t[2]:= x[2];
          x[3]:= z[3] xor cast_sbox5[(x[2] shr 8) and $FF] xor
           cast_sbox6[(x[2] shr 16) and $FF] xor cast_sbox7[x[2] and $FF] xor
           cast_sbox8[x[2] shr 24] xor cast_sbox6[z[0] and $FF];
          t[3]:= x[3];
        end;
    end;
    case (i and 12) of
      0,12:begin
          KeyData[i+0]:= cast_sbox5[t[2] shr 24] xor cast_sbox6[(t[2] shr 16) and $FF] xor
           cast_sbox7[t[1] and $FF] xor cast_sbox8[(t[1] shr 8) and $FF];
          KeyData[i+1]:= cast_sbox5[(t[2] shr 8) and $FF] xor cast_sbox6[t[2] and $FF] xor
           cast_sbox7[(t[1] shr 16) and $FF] xor cast_sbox8[t[1] shr 24];
          KeyData[i+2]:= cast_sbox5[t[3] shr 24] xor cast_sbox6[(t[3] shr 16) and $FF] xor
           cast_sbox7[t[0] and $FF] xor cast_sbox8[(t[0] shr 8) and $FF];
          KeyData[i+3]:= cast_sbox5[(t[3] shr 8) and $FF] xor cast_sbox6[t[3] and $FF] xor
           cast_sbox7[(t[0] shr 16) and $FF] xor cast_sbox8[t[0] shr 24];
        end;
      4,8:begin
          KeyData[i+0]:= cast_sbox5[t[0] and $FF] xor cast_sbox6[(t[0] shr 8) and $FF] xor
           cast_sbox7[t[3] shr 24] xor cast_sbox8[(t[3] shr 16) and $FF];
          KeyData[i+1]:= cast_sbox5[(t[0] shr 16) and $FF] xor cast_sbox6[t[0] shr 24] xor
           cast_sbox7[(t[3] shr 8) and $FF] xor cast_sbox8[t[3] and $FF];
          KeyData[i+2]:= cast_sbox5[t[1] and $FF] xor cast_sbox6[(t[1] shr 8) and $FF] xor
           cast_sbox7[t[2] shr 24] xor cast_sbox8[(t[2] shr 16) and $FF];
          KeyData[i+3]:= cast_sbox5[(t[1] shr 16) and $FF] xor cast_sbox6[t[1] shr 24] xor
           cast_sbox7[(t[2] shr 8) and $FF] xor cast_sbox8[t[2] and $FF];
        end;
    end;
    case (i and 12) of
      0:begin
          KeyData[i+0]:= KeyData[i+0] xor cast_sbox5[(z[0] shr 8) and $FF];
          KeyData[i+1]:= KeyData[i+1] xor cast_sbox6[(z[1] shr 8) and $FF];
          KeyData[i+2]:= KeyData[i+2] xor cast_sbox7[(z[2] shr 16) and $FF];
          KeyData[i+3]:= KeyData[i+3] xor cast_sbox8[z[3] shr 24];
        end;
      4:begin
          KeyData[i+0]:= KeyData[i+0] xor cast_sbox5[x[2] shr 24];
          KeyData[i+1]:= KeyData[i+1] xor cast_sbox6[(x[3] shr 16) and $FF];
          KeyData[i+2]:= KeyData[i+2] xor cast_sbox7[x[0] and $FF];
          KeyData[i+3]:= KeyData[i+3] xor cast_sbox8[x[1] and $FF];
        end;
      8:begin
          KeyData[i+0]:= KeyData[i+0] xor cast_sbox5[(z[2] shr 16) and $FF];
          KeyData[i+1]:= KeyData[i+1] xor cast_sbox6[z[3] shr 24];
          KeyData[i+2]:= KeyData[i+2] xor cast_sbox7[(z[0] shr 8) and $FF];
          KeyData[i+3]:= KeyData[i+3] xor cast_sbox8[(z[1] shr 8) and $FF];
        end;
      12:begin
          KeyData[i+0]:= KeyData[i+0] xor cast_sbox5[x[0] and $FF];
          KeyData[i+1]:= KeyData[i+1] xor cast_sbox6[x[1] and $FF];
          KeyData[i+2]:= KeyData[i+2] xor cast_sbox7[x[2] shr 24];
          KeyData[i+3]:= KeyData[i+3] xor cast_sbox8[(x[3] shr 16) and $FF];
        end;
  {$else}
      0:begin
          z[0]:= x[0] xor cast_sbox5[dw(x[3]).b3] xor
           cast_sbox6[dw(x[3]).b1] xor cast_sbox7[dw(x[3]).b4] xor
           cast_sbox8[dw(x[3]).b2] xor cast_sbox7[dw(x[2]).b4];
          t[0]:= z[0];
          z[1]:= x[2] xor cast_sbox5[dw(z[0]).b4] xor
           cast_sbox6[dw(z[0]).b2] xor cast_sbox7[dw(z[0]).b3] xor
           cast_sbox8[dw(z[0]).b1] xor cast_sbox8[dw(x[2]).b2];
          t[1]:= z[1];
          z[2]:= x[3] xor cast_sbox5[dw(z[1]).b1] xor
           cast_sbox6[dw(z[1]).b2] xor cast_sbox7[dw(z[1]).b3] xor
           cast_sbox8[dw(z[1]).b4] xor cast_sbox5[dw(x[2]).b3];
          t[2]:= z[2];
          z[3]:= x[1] xor cast_sbox5[dw(z[2]).b2] xor
           cast_sbox6[dw(z[2]).b3] xor cast_sbox7[dw(z[2]).b1] xor
           cast_sbox8[dw(z[2]).b4] xor cast_sbox6[dw(x[2]).b1];
          t[3]:= z[3];
        end;
      4:begin
          x[0]:= z[2] xor cast_sbox5[dw(z[1]).b3] xor
           cast_sbox6[dw(z[1]).b1] xor cast_sbox7[dw(z[1]).b4] xor
           cast_sbox8[dw(z[1]).b2] xor cast_sbox7[dw(z[0]).b4];
          t[0]:= x[0];
          x[1]:= z[0] xor cast_sbox5[dw(x[0]).b4] xor
           cast_sbox6[dw(x[0]).b2] xor cast_sbox7[dw(x[0]).b3] xor
           cast_sbox8[dw(x[0]).b1] xor cast_sbox8[dw(z[0]).b2];
          t[1]:= x[1];
          x[2]:= z[1] xor cast_sbox5[dw(x[1]).b1] xor
           cast_sbox6[dw(x[1]).b2] xor cast_sbox7[dw(x[1]).b3] xor
           cast_sbox8[dw(x[1]).b4] xor cast_sbox5[dw(z[0]).b3];
          t[2]:= x[2];
          x[3]:= z[3] xor cast_sbox5[dw(x[2]).b2] xor
           cast_sbox6[dw(x[2]).b3] xor cast_sbox7[dw(x[2]).b1] xor
           cast_sbox8[dw(x[2]).b4] xor cast_sbox6[dw(z[0]).b1];
          t[3]:= x[3];
        end;
    end;
    case (i and 12) of
      0,12:begin
          KeyData[i+0]:= cast_sbox5[dw(t[2]).b4] xor cast_sbox6[dw(t[2]).b3] xor
           cast_sbox7[dw(t[1]).b1] xor cast_sbox8[dw(t[1]).b2];
          KeyData[i+1]:= cast_sbox5[dw(t[2]).b2] xor cast_sbox6[dw(t[2]).b1] xor
           cast_sbox7[dw(t[1]).b3] xor cast_sbox8[dw(t[1]).b4];
          KeyData[i+2]:= cast_sbox5[dw(t[3]).b4] xor cast_sbox6[dw(t[3]).b3] xor
           cast_sbox7[dw(t[0]).b1] xor cast_sbox8[dw(t[0]).b2];
          KeyData[i+3]:= cast_sbox5[dw(t[3]).b2] xor cast_sbox6[dw(t[3]).b1] xor
           cast_sbox7[dw(t[0]).b3] xor cast_sbox8[dw(t[0]).b4];
        end;
      4,8:begin
          KeyData[i+0]:= cast_sbox5[dw(t[0]).b1] xor cast_sbox6[dw(t[0]).b2] xor
           cast_sbox7[dw(t[3]).b4] xor cast_sbox8[dw(t[3]).b3];
          KeyData[i+1]:= cast_sbox5[dw(t[0]).b3] xor cast_sbox6[dw(t[0]).b4] xor
           cast_sbox7[dw(t[3]).b2] xor cast_sbox8[dw(t[3]).b1];
          KeyData[i+2]:= cast_sbox5[dw(t[1]).b1] xor cast_sbox6[dw(t[1]).b2] xor
           cast_sbox7[dw(t[2]).b4] xor cast_sbox8[dw(t[2]).b3];
          KeyData[i+3]:= cast_sbox5[dw(t[1]).b3] xor cast_sbox6[dw(t[1]).b4] xor
           cast_sbox7[dw(t[2]).b2] xor cast_sbox8[dw(t[2]).b1];
        end;
    end;
    case (i and 12) of
      0:begin
          KeyData[i+0]:= KeyData[i+0] xor cast_sbox5[dw(z[0]).b2];
          KeyData[i+1]:= KeyData[i+1] xor cast_sbox6[dw(z[1]).b2];
          KeyData[i+2]:= KeyData[i+2] xor cast_sbox7[dw(z[2]).b3];
          KeyData[i+3]:= KeyData[i+3] xor cast_sbox8[dw(z[3]).b4];
        end;
      4:begin
          KeyData[i+0]:= KeyData[i+0] xor cast_sbox5[dw(x[2]).b4];
          KeyData[i+1]:= KeyData[i+1] xor cast_sbox6[dw(x[3]).b3];
          KeyData[i+2]:= KeyData[i+2] xor cast_sbox7[dw(x[0]).b1];
          KeyData[i+3]:= KeyData[i+3] xor cast_sbox8[dw(x[1]).b1];
        end;
      8:begin
          KeyData[i+0]:= KeyData[i+0] xor cast_sbox5[dw(z[2]).b3];
          KeyData[i+1]:= KeyData[i+1] xor cast_sbox6[dw(z[3]).b4];
          KeyData[i+2]:= KeyData[i+2] xor cast_sbox7[dw(z[0]).b2];
          KeyData[i+3]:= KeyData[i+3] xor cast_sbox8[dw(z[1]).b2];
        end;
      12:begin
          KeyData[i+0]:= KeyData[i+0] xor cast_sbox5[dw(x[0]).b1];
          KeyData[i+1]:= KeyData[i+1] xor cast_sbox6[dw(x[1]).b1];
          KeyData[i+2]:= KeyData[i+2] xor cast_sbox7[dw(x[2]).b4];
          KeyData[i+3]:= KeyData[i+3] xor cast_sbox8[dw(x[3]).b3];
        end;
  {$endif}
    end;
    if (i >= 16) then begin
      KeyData[i+0]:= KeyData[i+0] and 31;
      KeyData[i+1]:= KeyData[i+1] and 31;
      KeyData[i+2]:= KeyData[i+2] and 31;
      KeyData[i+3]:= KeyData[i+3] and 31;
    end;
    Inc(i,4);
  end;
  if IVector= nil then begin
    FillChar(IV,Sizeof(IV),$FF);
    Cast128EncryptECB(Data,IV,IV);
    Move(IV,LB,Sizeof(LB));
  end else begin
    Move(IVector^,IV,Sizeof(IV));
    Move(IV,LB,Sizeof(IV));
  end;
 end;
end;

procedure Cast128Burn;
begin
 with Data do begin
  FillChar(KeyData,Sizeof(KeyData),$FF);
  FillChar(IV,Sizeof(IV),$FF);
  FillChar(LB,Sizeof(LB),$FF);
 end;
end;

procedure Cast128Reset;
begin
 with Data do Move(IV,LB,Sizeof(LB));
end;

procedure Cast128EncryptCBC;
var
  TB:array[0..7] of byte;
  i:longint;
begin
 with Data do begin
  for i:= 1 to (Size div 8) do begin
    XorBlock(pointer(longint(@InData)+((i-1)*8)),@LB,@TB,Sizeof(TB));
    Cast128EncryptECB(Data,TB,TB);
    Move(TB,pointer(longint(@OutData)+((i-1)*8))^,Sizeof(TB));
    Move(TB,LB,Sizeof(TB));
  end;
  if (Size mod 8)<> 0 then begin
    Cast128EncryptECB(Data,LB,TB);
    XorBlock(@TB,@pointer(longint(@InData)+Size-(Size mod 8))^,@pointer(longint(@OutData)+Size-(Size mod 8))^,Size mod 8);
  end;
  FillChar(TB,Sizeof(TB),$FF);
 end;
end;

procedure Cast128DecryptCBC;
var
  TB:array[0..7] of byte;
  i:longint;
begin
 with Data do begin
  for i:= 1 to (Size div 8) do begin
    Move(pointer(longint(@InData)+((i-1)*8))^,TB,Sizeof(TB));
    Cast128DecryptECB(Data,pointer(longint(@InData)+((i-1)*8))^,pointer(longint(@OutData)+((i-1)*8))^);
    XorBlock(@LB,pointer(longint(@OutData)+((i-1)*8)),pointer(longint(@OutData)+((i-1)*8)),Sizeof(TB));
    Move(TB,LB,Sizeof(TB));
  end;
  if (Size mod 8)<> 0 then begin
    Cast128EncryptECB(Data,LB,TB);
    XorBlock(@TB,@pointer(longint(@InData)+Size-(Size mod 8))^,@pointer(longint(@OutData)+Size-(Size mod 8))^,Size mod 8);
  end;
  FillChar(TB,Sizeof(TB),$FF);
 end;
end;

procedure Cast128EncryptCFB;
var
  i:longint;
  TB:array[0..7] of byte;
begin
 with Data do begin
  for i:= 0 to Size-1 do begin
    Cast128EncryptECB(Data,LB,TB);
    PByteArray(@OutData)^[i]:= PByteArray(@InData)^[i] xor TB[0];
    Move(LB[1],LB[0],7);
    LB[7]:= PByteArray(@OutData)^[i];
  end;
 end;
end;

procedure Cast128DecryptCFB;
var
  i:longint;
  TB:array[0..7] of byte;
  b:byte;
begin
 with Data do begin
  for i:= 0 to Size-1 do begin
   b:= PByteArray(@InData)^[i];
   Cast128EncryptECB(Data,LB,TB);
   PByteArray(@OutData)^[i]:= PByteArray(@InData)^[i] xor TB[0];
   Move(LB[1],LB[0],7);
   LB[7]:= b;
  end;
 end;
end;


end.
